{$D-}
{$S-}
{$V-}

Unit fileLib;

{
FileLib, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there may be some code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

Good luck! :)
}



INTERFACE

Uses
  Dos,stuff;


  Function EXIST(thisfile : pathstr) : boolean;
  Function VALID(thisfile : pathstr) : boolean;
  Function name_form(name:string):string;
  function exten(name:string):string;
  function base_name(name:string):string;
  Function attribs(b:byte):string;
  function path(fn:string):string;
  function no_path(fn:string):string;
  function file_length(fn:string):longint;

IMPLEMENTATION

Const
  null  = #0;
  bell  = #7;
  esc   = #27;
  f10   = #$44; {scan code}
  basex : byte = 1;
  basey : byte = 1;
  tempx : byte = 1;
  tempy : byte = 1;
  endx  : byte = 24;
  endy  : byte = 80;

Var
  regs        : registers;
  textattr    : word;
  workstr     : string;


Function EXIST(thisfile : pathstr) : boolean;
  var
    afile : file;
    iocode : word;

  begin {* fExist *}
    assign(afile,thisfile);
    {$I-}
    reset(afile);
    iocode := ioresult;
    {$I+}
    Exist := (iocode = 0);
    if iocode = 0 then close(afile);
  end;  {* fExist *}

Function VALID(thisfile : pathstr) : boolean;
  Var
    afile : file;
    check : boolean;
    iocode : word;

  begin {* fValid *}
    if not Exist(thisfile) then
      begin
        assign(afile,thisfile);
        {$I-}
        rewrite(afile);
        close(afile);
        erase(afile);
        {$I+}
        iocode := ioresult;
        Valid := (iocode = 0)
      end
    else Valid := true
  end;  {* fValid *}

Function name_form(name:string):string;
var
 i,j,k,l:integer;
 s1,s2,s3:string;
begin
 s1:=''; s2:='';
 k:=1;
 if (name='.') or (name='..') then
  begin
   name_form:=addrear(name,12);
   exit;
  end;
 while (k<=length(name)) and (name[k]<>'.') do
  begin
   s1:=s1+name[k];
   inc(k);
  end;
 if k<length(name) then
  begin
   inc(k);
   while (k<=length(name)) and (name[k]<>'.') do
    begin
     s2:=s2+name[k];
     inc(k);
    end;
  end;
 name_form:=addrear(s1,9)+addrear(s2,3);
end;

function exten(name:string):string;
var
 i,j,k,l:integer;
 s1,s2,s3:string;
begin
 s1:=''; s2:='';
 k:=1;
 while (k<=length(name)) and (name[k]<>'.') do
  begin
   s1:=s1+name[k];
   inc(k);
  end;
 if k<length(name) then
  begin
   inc(k);
   while (k<=length(name)) and (name[k]<>'.') do
    begin
     s2:=s2+name[k];
     inc(k);
    end;
  end;
 exten:=addrear(s2,3);
end;


function base_name(name:string):string;
var
 i,j,k,l:integer;
 s1,s2,s3:string;
begin
 s1:=''; s2:='';
 k:=1;
 while (k<=length(name)) and (name[k]<>'.') do
  begin
   s1:=s1+name[k];
   inc(k);
  end;
 base_name:=s1;
end;

Function attribs(b:byte):string;
{const
   ReadOnly = $01;
   Hidden   = $02;
   SysFile  = $04;
   VolumeID = $08;
   Directory= $10;
   Archive  = $20;
   AnyFile  = $3F;}
var
s1:string[8];
begin
 s1:=' ';
 if (b and readonly)<>0  then s1:=s1+'R' else s1:=s1+'.';
 if (b and hidden  )<>0  then s1:=s1+'H' else s1:=s1+'.';
 if (b and sysfile )<>0  then s1:=s1+'S' else s1:=s1+'.';
 if (b and archive )<>0  then s1:=s1+'A' else s1:=s1+'.';
 attribs:=s1;
end;

function path(fn:string):string;
var
 i,k:integer;
begin
 k:=0;
 for i:=length(fn) downto 1 do
  begin
   if ((fn[i]='\') or (fn[i]=':')) and (k<i) then k:=i;
  end;
 if k<>0 then
   path:=lstr(fn,k)
  else
   path:='';
end;

function no_path(fn:string):string;
var
 i,k:integer;
begin
 k:=0;
 for i:=length(fn) downto 1 do
  begin
   if ((fn[i]='\') or (fn[i]=':')) and (k<i) then k:=i;
  end;
 if k<>0 then
   no_path:=rstr(fn,length(fn)-k)
  else
   no_path:=fn;
end;

function file_length(fn:string):longint;
var
 sr:searchrec;
begin
 findfirst(fn,archive,sr);
 if doserror=0 then file_length:=sr.size
               else file_length:=0;
end;

end. Unit
