{
Stellar Conquest III, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there is code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

If you do create a derivative work, please drop me a note at
necrobones@necrobones.com and let me know! I'd love to hear about it!

Good luck! :)
}

procedure beep;
begin
 if not sound_off then
  begin
   sound(1000);
   delay(50);
   sound(500);
   delay(100);
   nosound;
  end;
end;

procedure kill_buttons;
var
 i:integer;
begin
 for i:=1 to max_buttons do
  begin
   button[i].a:=false;
   button[i].key:=#0;
  end;
end;

procedure add_button(xx,yy,sz:integer; c:char; st:string);
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_buttons do
  if (k=0) and (not button[i].a) then k:=i;
 if k>0 then
  with button[k] do
   begin
    x:=xx; y:=yy; size:=sz; name:=st; pressed:=false; a:=true; key:=c;
   end;
end;

function case_fix(s:string):string;
var
 i:integer;
begin
 s:=lcase(s);
 s[1]:=upcase(s[1]);
 case_fix:=s;
end;


procedure button_text(x,y:integer; c:char; s:string);
var
 i,k,j:integer;
begin
 x:=x-((length(s)*8) div 2);
 setcolor(0);
 outtextxy(x,y-3,s);
 setcolor(4);
 j:=0;
 for i:=1 to length(s) do
  if (s[i]=upcase(c)) and (j=0) then
   begin outtextxy(x+(i-1)*8,y-3,s[i]); j:=i; end;
 if j=0 then
  for i:=1 to length(s) do
   if (s[i]=locase(c)) and (j=0) then
    begin outtextxy(x+(i-1)*8,y-3,s[i]); j:=i; end;
end;



procedure draw_button(x,y,size:integer; c:char; s:String);
begin
 setfillstyle(1,7);
 bar(x-size,y-5,x+size,y+5);
 setwritemode(copyput);
 setcolor(8);
 line(x+size,y-5,x+size,y+5);
 line(x-size,y+5,x+size,y+5);
 setcolor(15);
 line(x-size,y-5,x-size,y+5);
 line(x-size,y-5,x+size,y-5);
 button_text(x,y,c,s);
end;

procedure change_button(s1,s2:string; new_key:char);
var
 i,j,k,l:integer;
begin
 for i:=1 to max_buttons do
  if (button[i].a) and (ucase(button[i].name)=ucase(s1)) then
   with button[i] do
     begin
      name:=s2; {case_fix(s2);}
      if new_key<>#0 then key:=new_key;
      draw_button(x,y,size,key,name);
     end;
end;


procedure make_button(x,y,size:integer; c:char; s:String);
begin
 draw_button(x,y,size,c,s);
 add_button(x,y,size,c,s);
end;

procedure askmouse(var mx,my:integer; var lb,rb,bb:boolean);
var
 x,y:word;
begin
 pollmouse(x,y,lb,rb,bb); mx:=x; my:=y;
end;

procedure special_key(code:char);
var
 i,j,k,l,xx,yy:integer;
 c:char;
 s:string[20];
begin
 if not (code in [#00,#59,#60,#61]) then exit;
 hide_mouse;
 xx:=150; yy:=60;
 getimage(0,0,xx,yy,tempp^);
 setfillstyle(1,1);
 bar(0,0,xx,yy);
 setcolor(4);
 rectangle(0,0,xx,yy);
 case code of
  #00:begin
       setcolor(14);
       outtextxy(5,10,'Quit to Dos?');
       setcolor(11);
       outtextxy(5,20,'Y or N:');
       repeat
        c:=upcase(readkey);
       until c in ['Y','N'];
       if c='Y' then shutdown;
      end;
  #59:begin
       setcolor(14);
       outtextxy(2,2,'Game Options:');
       setcolor(11);
       outtextxy(5,12,'S-Save game');
       outtextxy(5,20,'L-Load game');
       outtextxy(5,28,'R-Resume');
       outtextxy(5,36,'P-Players');
       outtextxy(5,44,'Q-Quit');
       repeat
        c:=upcase(readkey);
       until (c in ['S','R','Q','L',#27,'P']);
       if c='Q' then shutdown;
       if c='P' then
        begin
         repeat
          setfillstyle(1,1);
          bar(0,0,xx,yy);
          setcolor(4);
          rectangle(0,0,xx,yy);
          setcolor(14);
          outtextxy(5,5,'0-Done');
          for i:=1 to max_players do
           begin
            if player[i].comp then s:='Comp' else s:='Human';
            outtextxy(5,8*i+5,cstr(i)+'-Player#'+cstr(i)+': '+s);
           end;
          outtextxy(5,45,'S-See all:  '+cbool(gamesys.see_all));
          repeat
           c:=upcase(readkey);
          until (c in ['0'..'4','S']);
          case c of
           '1':player[1].comp:=player[1].comp=false;
           '2':player[2].comp:=player[2].comp=false;
           '3':player[3].comp:=player[3].comp=false;
           '4':player[4].comp:=player[4].comp=false;
           'S':gamesys.see_all:=gamesys.see_all=false;
          end;
         until c='0';
         c:=#255;
        end;
       if c='L' then
        begin
         setfillstyle(1,1);
         bar(0,0,xx,yy);
         setcolor(4);
         rectangle(0,0,xx,yy);
         setcolor(14);
         outtextxy(5, 5,'Press 1-9 for load');
         outtextxy(5,15,'slot, or 0 to');
         outtextxy(5,25,'abort.');
         repeat
          c:=upcase(readkey);
         until (c in ['0'..'9']);
         if c<>'0' then
          begin
           setfillstyle(1,1);
           bar(0,0,xx,yy);
           setcolor(4);
           rectangle(0,0,xx,yy);
           setcolor(14);
           outtextxy(15,25,'Loading..');
           load_game(main_filename+'.SV'+c);
          end;
         c:=#255;
        end;
       if c='S' then
        begin
         setfillstyle(1,1);
         bar(0,0,xx,yy);
         setcolor(4);
         rectangle(0,0,xx,yy);
         setcolor(14);
         outtextxy(5, 5,'Press 1-9 for save');
         outtextxy(5,15,'slot, or 0 to');
         outtextxy(5,25,'abort.');
         repeat
          c:=upcase(readkey);
         until (c in ['0'..'9']);
         if c<>'0' then
          begin
           setfillstyle(1,1);
           bar(0,0,xx,yy);
           setcolor(4);
           rectangle(0,0,xx,yy);
           setcolor(14);
           outtextxy(15,25,'Saving...');
           save_game(main_filename+'.SV'+c);
          end;
         c:=#255;
        end;
      end;
  #60:sound_off:=sound_off=false;
  #61:fast_combat:=fast_combat=false;
 end;
 putimage(0,0,tempp^,copyput);
 show_mouse;
end;

function the_button_check(mx,my,n:integer):boolean;
begin
 with button[n] do
  begin
   if (abs(mx-x)<=size) and (abs(my-y)<=5)
      then the_button_check:=true
      else the_button_check:=false;
  end;
end;


procedure check_buttons(mx,my:integer; click:boolean);
var
 i,j,k,l:integer;
 {click:boolean;}
begin
 for i:=1 to max_buttons do
 if button[i].a then
  with button[i] do
   if ((the_button_check(mx,my,i)) and (not pressed) and (click)) or
      ((not (the_button_check(mx,my,i) and click)) and pressed) then
   begin
    hide_mouse;
    pressed:=click and the_button_check(mx,my,i);
    if pressed then k:=1 else k:=0;
    setfillstyle(1,7);
    bar(x-size,y-5,x+size,y+5);
    setcolor(8);
    if not pressed then
     begin
      line(x+size,y-5,x+size,y+5);
      line(x-size,y+5,x+size,y+5);
     end
    else
     begin
      line(x-size,y-5,x-size,y+5);
      line(x-size,y-5,x+size,y-5);
     end;
    setcolor(15);
    line(x-size+k,y-5+k,x-size+k,y+5);
    line(x-size+k,y-5+k,x+size,y-5+k);
    button_text(x+k,y+k,key,name);
    show_mouse;
   end;
end;

procedure flash_color(spd:integer);
var
 i,j,k,l:integer;
begin
 inc(palette_rotation); if palette_rotation>63 then palette_rotation:=1;
 setpalette(6,palette_rotation);
 {palette_rotation:=1-palette_rotation;
 case palette_rotation of
  0:setpalette(6,player_color(playnum)-8);
  1:setpalette(6,14);
 end;}
 {hide_mouse;}
 setwritemode(orput);
 for i:=1 to max_istars do
  with istar[i] do
   begin
    if lastdrawn then putpixel(x,y,0);
    x:=x+xv;
    if x>365 then
     begin
      x:=0; xv:=((random(((spd*3) div 2)+1)+(spd div 2)) div 3)+1;
      k:=random(3); y:=random(52)+422;
      case k of
       0:col:=7;
       1:col:=8;
       2:col:=15;
      end;
     end;
    lastdrawn:=true; setcolor(col);
    if getpixel(x,y)>0 then lastdrawn:=false else
       line(x,y,x,y); {putpixel(x,y,col);}
   end;
 {show_mouse;}
 setwritemode(copyput);
end;

procedure init_istars(spd:integer);
var
 i,k:integer;
begin
 hide_mouse;
 for i:=1 to max_istars do
  with istar[i] do
   begin
     x:=random(360); y:=random(52)+422;
     xv:=((random(((spd*3) div 2)+1)+(spd div 2)) div 3)+1; k:=random(3);
     case k of
      0:col:=7;
      1:col:=8;
      2:col:=15;
     end;
    lastdrawn:=true;
    if getpixel(x,y)>0 then lastdrawn:=false else putpixel(x,y,col);
   end;
 show_mouse;
end;


procedure the_input(var mx,my:integer; var b:boolean; var c:char; flash:boolean; speed:integer; specials:boolean);
var
 lb,rb,bb:boolean;
 i,j,k,l:integer;
 mmx,mmy:integer;
 timer:longint;
begin
 timer:=meml[0:$46C];
 flushkey; c:=#0;
 repeat
  askmouse(mmx,mmy,lb,rb,bb);
  if flash and (timer<>meml[0:$46C]) then flash_color(speed);
  timer:=meml[0:$46C];
 until ((not lb) and (not rb) and (not bb)) or keypressed;
 repeat
  askmouse(mmx,mmy,lb,rb,bb);
  if flash and (timer<>meml[0:$46C]) then flash_color(speed);
  timer:=meml[0:$46C];
  check_buttons(mmx,mmy,false);
 until lb or rb or bb or keypressed;
 if lb or rb or bb then b:=true else b:=false;
 if rb then c:=#255;
 repeat
  askmouse(mmx,mmy,lb,rb,bb);
  if flash and (timer<>meml[0:$46C]) then flash_color(speed);
  timer:=meml[0:$46C];
  check_buttons(mmx,mmy,true);
 until ((not lb) and (not rb) and (not bb)) or keypressed;
 mx:=mmx; my:=mmy;
 if keypressed then
  begin
   c:=upcase(readkey);
   if (c=#0) then
    begin
      if (specials) then begin special_key(readkey); c:=#254; end
                    else flushkey;
    end;
  end
 else begin if c<>#255 then c:=#0; end;
 if (c=#27) and (specials) then special_key(#00);
 if (c in [#0,#255]) then
  for i:=1 to max_buttons do
   if (button[i].a) and (the_button_check(mx,my,i)) and
      (button[i].key<>#0) then c:=button[i].key;
end;

procedure click_wait(var mx,my:integer; var b:boolean; var c:char);
begin
 the_input(mx,my,b,c,false,0,true);
end;

procedure flash_wait(var mx,my:integer; var b:boolean; var c:char; spd:integer);
begin
 the_input(mx,my,b,c,true,spd,true);
end;

procedure nospecial_wait(var mx,my:integer; var b:boolean; var c:char);
begin
 the_input(mx,my,b,c,false,0,false);
end;


procedure pause;
var
 mx,my:integer;
 b1,b2,b3:boolean;
 c:char;
begin
 flushkey;
 repeat
  askmouse(mx,my,b1,b2,b3);
 until keypressed or b1 or b2 or b3;
 flushkey;
end;

procedure start_mouse;
begin
 MouseReset;
 ShowMouse;
 SetColumnRange(635,0);
 SetRowRange(405,0);
 mouse_hidden:=false;
 {arrow5mouse;}
end;


{function mouse_check(mx,my:integer; b:boolean; x,y:integer):boolean;
begin
 if b and (abs(mx-x)<=button_size) and (abs(my-y)<=7) then mouse_check:=true
                                                      else mouse_check:=false;
end;}

