{$G+}
unit mygraph;

{
MyGraph, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there may be some code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

Good luck! :)
}

interface

uses graph;

type
 screen_type=array[0..65534] of byte;
 big_array=array[0..500] of byte;
 temp_ptr_type=^big_array;
 scr_ptr_type=^screen_type;
 color_rec=record
             red,green,blue:byte;
           end;
 color_type=array[0..255] of color_rec;
 ptr_type= record
            offs,segm:word;
           end;
 color_ptr=^color_type;

var
 screen,realscreen:scr_ptr_type;
 tp:temp_ptr_type;
 color,tcolor:color_type;
 point:ptr_type;

procedure wait_vrefresh;
procedure wait_hrefresh;
procedure setpal(p:color_ptr; st,len:integer);
procedure setall(p:color_ptr);
procedure setpalf(p:color_ptr; st,len:integer);
procedure setallf(p:color_ptr);
procedure black_palette;
procedure set_palette;
procedure do_palette(n:integer);
procedure do_palettef(n:integer);
Procedure VGA_off;
Procedure VGA_on;
Procedure fast_palette(c,x1,x2,x3:byte);
Procedure fix_area(x1,y1,x2,y2:integer);
Procedure fix_area_word(x1,y1,x2,y2:integer);
Procedure fix_area_long(x1,y1,x2,y2:integer);
Procedure copy_vscreen;
Procedure save_area(x1,y1,x2,y2:integer);
Procedure copy_area(x1,y1,x2,y2:integer; ptr:scr_ptr_type);
Procedure move_area(x1,y1,x2,y2:integer; ptr,ptr2:scr_ptr_type);
Procedure move2_area(x1,y1,x2,y2:integer; ptr,ptr2:scr_ptr_type);
Procedure Open_graph;
Procedure Close_graph;
Procedure img_get(scrn:pointer; x1,y1,x2,y2:integer; p:pointer); {the real image get routine}
Procedure img_xor(x,y:integer; p:pointer);
Procedure img_mxor(x,y:integer; p:pointer; m:byte);
Procedure img_matte(x,y:integer; p:pointer);
Procedure img_mmatte(x,y:integer; p:pointer; m:byte);
Procedure img_mput(x,y:integer; p:pointer; mm:byte; tf:boolean);
Procedure img_copy(x,y:integer; p:pointer);
Procedure img_vcopy(x,y:integer; p:pointer);
Procedure img_vcopy_32(x,y:integer; p:pointer);
Procedure img_vxor(x,y:integer; p:pointer);
Procedure img_vmxor(x,y:integer; p:pointer; m:byte);
Procedure img_vmatte(x,y:integer; p:pointer);
Procedure img_vmmatte(x,y:integer; p:pointer; m:byte);
Procedure img_vmmatte15(x,y:integer; p:pointer; m:byte);
Procedure img_vmput(x,y:integer; p:pointer; mm:byte; tf:boolean);
Procedure img_vget(x,y:integer; p:pointer); {Warning! Strange!}
Procedure v_bar(x1,y1,x2,y2,c:integer);
Function get_point(x,y:word):byte;
procedure clear_v_screen;
Procedure GraphMCGA;
Procedure a_bar(x1,y1,x2,y2:integer; ptr:scr_ptr_type; col:byte);
procedure v_rect(x1,y1,x2,y2,c:integer);
procedure load_palette(fn:string);
procedure read_palette(fn:string);
procedure save_palette(fn:string);
procedure color_set(start,c1,c2,c3:integer);
procedure color_spread(start,stop,c1,c2,c3,d1,d2,d3:integer);
procedure pal_fade(p1,p2:color_ptr; n,start,len:integer; refresh:boolean);
procedure new_setallf(col:color_ptr);
procedure new_setpalf(col:color_ptr; start,len:byte);

implementation

procedure wait_vrefresh;
begin
 asm
        MOV   DX,3DAh
@1:     IN    AL,DX
        TEST  AL,08h
        JZ    @1
@2:     IN    AL,DX
        TEST  AL,08h
        JNZ   @2
 end;
end;

procedure wait_hrefresh;
begin
 asm
      mov dx, 03DAH
@1:   in  al, dx
      test al, 1
      jnz @1
@2:   in  al, dx
      test al, 1
      jz @2
 end;
end;



procedure setpal(p:color_ptr;st,len:integer);
var
 x,start,stop:word;
label
 fade_in_loop,wait_high1,wait_low1,wait_high2,wait_low2,wait_high3,wait_low3;
begin

 start:=st; stop:=st+len-1;
 point.offs:=ofs(p^[st]);
 point.segm:=seg(p^[st]);
 x:=start;
 FADE_IN_LOOP:
    asm
      mov dx, 03C8H
      mov al, byte ptr x
      out dx, al

      lds bx, point

      mov cl, [bx]
      mov dx, 03DAH
WAIT_LOW1:

      in  al, dx
      test al, 1
      jnz WAIT_LOW1
WAIT_HIGH1:
      in  al, dx
      test al, 1
      jz WAIT_HIGH1

      mov dx, 03C9H
      mov al, cl
      out dx, al

      mov cl, [bx + 1]
      mov dx, 03DAH
WAIT_LOW2:
      in  al, dx
      test al, 1
      jnz WAIT_LOW2
WAIT_HIGH2:
      in  al, dx
      test al, 1
      jz WAIT_HIGH2

      mov dx, 03C9H
      mov al, cl
      out dx, al

      mov cl, [bx + 2]
      mov dx, 03DAH
WAIT_LOW3:
      in  al, dx
      test al, 1
      jnz WAIT_LOW3
WAIT_HIGH3:
			in  al, dx
			test al, 1
      jz WAIT_HIGH3

      mov dx, 03C9H
      mov al, cl
      out dx, al
   end;
    point.offs:=point.offs+3;
   asm
      inc x

      mov ax, x

      cmp ax, stop

      jb FADE_IN_LOOP
  end;

end;

procedure setall(p:color_ptr);
begin
 setpal(p,0,257);
end;

procedure setpalf(p:color_ptr;st,len:integer);
var
 r,g,b:byte;
 i:integer;
begin
 wait_vrefresh;
 for i:=st to st+len-1 do
  begin
   r:=p^[i].red;
   g:=p^[i].green;
   b:=p^[i].blue;
    asm
        mov dx, 03C8H
        mov ax, i
        out dx, al
        mov dx, 03C9H
        mov al, r
        out dx, al
        mov al, g
        out dx, al
        mov al, b
        out dx, al
    end;
  end;
end;

procedure setallf(p:color_ptr);
begin
 setpalf(p,0,256);
end;


procedure black_palette;
var
 i:integer;
begin
 for i:=0 to 255 do
  begin color[i].red:=0; color[i].green:=0; color[i].blue:=0; end;
 setall(@color);
end;

procedure set_palette;
var
 i:integer;
begin
 color[0].red:=0; color[0].blue:=0; color[0].green:=0;
 color[1].red:=0; color[1].blue:=40; color[1].green:=0;
 color[2].red:=0; color[2].blue:=0; color[2].green:=40;
 color[3].red:=0; color[3].blue:=40; color[3].green:=40;
 color[4].red:=40; color[4].blue:=0; color[4].green:=0;
 color[5].red:=40; color[5].blue:=40; color[5].green:=0;
 color[6].red:=40; color[6].blue:=0; color[6].green:=40;
 color[7].red:=40; color[7].blue:=40; color[7].green:=40;
 color[8].red:=20; color[8].blue:=20; color[8].green:=20;
 color[9].red:=0; color[9].blue:=63; color[9].green:=0;
 color[10].red:=0; color[10].blue:=0; color[10].green:=63;
 color[11].red:=0; color[11].blue:=63; color[11].green:=63;
 color[12].red:=63; color[12].blue:=0; color[12].green:=0;
 color[13].red:=63; color[13].blue:=63; color[13].green:=0;
 color[14].red:=63; color[14].blue:=0; color[14].green:=63;
 color[15].red:=63; color[15].blue:=63; color[15].green:=63;
 color[16].red:=0;  color[16].blue:=0;  color[16].green:=0;
 color[17].red:=0;  color[17].blue:=40; color[17].green:=0;
 color[18].red:=0;  color[18].blue:=0;  color[18].green:=40;
 color[19].red:=0;  color[19].blue:=40; color[19].green:=40;
 color[20].red:=40; color[20].blue:=0;  color[20].green:=0;
 color[21].red:=40; color[21].blue:=40; color[21].green:=0;
 color[22].red:=40; color[22].blue:=0;  color[22].green:=40;
 color[23].red:=40; color[23].blue:=40; color[23].green:=40;
 color[24].red:=20; color[24].blue:=20; color[24].green:=20;
 color[25].red:=0;  color[25].blue:=63; color[25].green:=0;
 color[26].red:=0;  color[26].blue:=0;  color[26].green:=63;
 color[27].red:=0;  color[27].blue:=63; color[27].green:=63;
 color[28].red:=63; color[28].blue:=0;  color[28].green:=0;
 color[29].red:=63; color[29].blue:=63; color[29].green:=0;
 color[30].red:=63; color[30].blue:=0;  color[30].green:=63;
 color[31].red:=63; color[31].blue:=63; color[31].green:=63;
 {Blue}
 for i:=0 to 15 do
  begin color[i+32].red:=0; color[i+32].green:=0; color[i+32].blue:=i*4; end;
 for i:=16 to 31 do
  begin color[i+32].red:=(i-16)*4; color[i+32].green:=(i-16)*4; color[i+32].blue:=63; end;
 {Green}
 for i:=0 to 15 do
  begin color[i+64].red:=0; color[i+64].green:=i*4; color[i+64].blue:=0; end;
 for i:=16 to 31 do
  begin color[i+64].red:=(i-16)*4; color[i+64].green:=63; color[i+64].blue:=(i-16)*4; end;
 {Cyan}
 for i:=0 to 15 do
  begin color[i+96].red:=0; color[i+96].green:=i*4; color[i+96].blue:=i*4; end;
 for i:=16 to 31 do
  begin color[i+96].red:=(i-16)*4; color[i+96].green:=63; color[i+96].blue:=63; end;
 {Red}
 for i:=0 to 15 do
  begin color[i+128].red:=i*4; color[i+128].green:=0; color[i+128].blue:=0; end;
 for i:=16 to 31 do
  begin color[i+128].red:=63; color[i+128].green:=(i-16)*4; color[i+128].blue:=(i-16)*4; end;
 {Purple}
 for i:=0 to 15 do
  begin color[i+160].red:=i*4; color[i+160].green:=0; color[i+160].blue:=i*4; end;
 for i:=16 to 31 do
  begin color[i+160].red:=63; color[i+160].green:=(i-16)*4; color[i+160].blue:=63; end;
 {Yellow}
 for i:=0 to 15 do
  begin color[i+192].red:=i*4; color[i+192].green:=i*4; color[i+192].blue:=0; end;
 for i:=16 to 31 do
  begin color[i+192].red:=63; color[i+192].green:=63; color[i+192].blue:=(i-16)*4; end;
 {Grey}
 for i:=0 to 31 do
  begin color[i+224].red:=i*2; color[i+224].green:=i*2; color[i+224].blue:=i*2; end;
 setallf(@color);
end;



procedure do_palette(n:integer);
var
 i:integer;
begin
 tcolor:=color;
 for i:=0 to 255 do
  begin
   tcolor[i].red:=round((n/100)*color[i].red);
   tcolor[i].green:=round((n/100)*color[i].green);
   tcolor[i].blue:=round((n/100)*color[i].blue);
  end;
 setall(@tcolor);
end;

procedure do_palettef(n:integer);
var
 i:integer;
begin
 tcolor:=color;
 for i:=0 to 255 do
  begin
   tcolor[i].red:=round((n/100)*color[i].red);
   tcolor[i].green:=round((n/100)*color[i].green);
   tcolor[i].blue:=round((n/100)*color[i].blue);
  end;
 setallf(@tcolor);
end;


(* 'Detection' routine *)
{$F+}                                   (* Force to far calls *)
function DetectVGA : Integer;
var Vid : Integer;

begin
{  Writeln('Which video mode would you like to use?');
  Writeln('  0) 320x200x256');
  Writeln('  1) 640x400x256');
  Writeln('  2) 640x480x256');
  Writeln('  3) 800x600x256');
  Writeln('  4) 1024x768x256');
  Write('> ');
  Readln(Vid);
}
  vid:=0;
  DetectVGA := Vid;
end;
{$F-}


Procedure GraphMCGA;
var
  graphmode,graphdriver,i:integer;
  autodetect:pointer;
begin
  AutoDetect := @DetectVGA;
  GraphDriver := InstallUserDriver('SVGA256',AutoDetect);
  GraphDriver := Detect;
  InitGraph(GraphDriver,GraphMode,'');
  if (graphresult<>0) then
       begin
	writeln('You must have a VGA or MCGA to run this program');
	halt;
       end;
end;


Procedure Open_graph;
begin
 {graphMCGA;}
 asm
  mov   ax,     0013h
  int   10h
 end;
end;

Procedure Close_graph;
begin
 asm
  mov   ax,     0003h
  int   10h
 end;
end;

Procedure img_get(scrn:pointer; x1,y1,x2,y2:integer; p:pointer);
var
 start,sofs1,sseg1,sseg2,sofs2,xs,ys:word;
begin
 start:=y1*320+x1;
 sseg1:=seg(scrn^);
 sofs1:=ofs(scrn^);
 sseg2:=seg(p^);
 sofs2:=ofs(p^);
 xs:=abs(x2-x1); ys:=abs(y2-y1);
 asm
  push  ds

  mov   dx,     xs
  mov   cx,     ys
  mov   bx,     320

  mov   di,     sofs2
  mov   ax,     sseg2
  mov   es,     ax
  mov   es:[di],        dx
  mov   es:[di+2],      cx
  add   di,     4
  inc   cx
  inc   dx
  sub   bx,     dx

  mov   si,     sofs1
  add   si,     start
  mov   ax,     sseg1
  mov   ds,     ax

@1:
  push cx

  mov  cx,      dx
  rep  movsb
  add  si,      bx

  pop cx
  loop @1;

  pop  ds
 end;
end;

Procedure img_xor(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  xor  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_copy(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_matte(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_mput(x,y:integer; p:pointer; mm:byte; tf:boolean);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind,put_it,
 loop_top2,inner_top2,nevermind2,put_it2,
 go_on1,go_on2,go_on3;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 if tf then
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top2:
  push cx

  mov  cx,      dx
inner_top2:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   put_it2
  cmp  al,      1
  jne  go_on1
  mov  al,   246
  jmp  put_it2
  go_on1:
  cmp  al,      7
  jne  go_on2
  mov  al,   251
  jmp  put_it2
  go_on2:
  cmp  al,      8
  jne  go_on3
  mov  al,   241
  jmp  put_it2
  go_on3:
  mov    al,    243
put_it2:
  mov  byte ptr [es:di],      al
nevermind2:
  inc  si
  inc  di

  loop inner_top2
  add  di,      upp

  pop cx
  loop loop_top2;

  pop  es
  pop  ds
 end
 else
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      1
  jne  put_it
  mov  al,      mm
put_it:
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_vmxor(x,y:integer; p:pointer; m:byte);
var
 start,upp:word;
label
 loop_top,inner_top,put_it;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   put_it
  add  al,      m
  put_it:
  xor  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vmmatte(x,y:integer; p:pointer; m:byte);
var
 start,upp:word;
label
 loop_top,inner_top,put_it,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  add  al,      m
  put_it:
  mov  byte ptr [es:di],      al
  nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vmmatte15(x,y:integer; p:pointer; m:byte);
var
 start,upp:word;
label
 loop_top,inner_top,put_it,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  cmp  al,      15
  je   put_it
  add  al,      m
  put_it:
  mov  byte ptr [es:di],      al
  nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_vcopy(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vcopy_32(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx
  shr  dx,      2

loop_top:
  push cx

  mov  cx,      dx
  db   0F3h,066h,0A5h {rep  movsd}
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_vxor(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  xor  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vmatte(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vget(x,y:integer; p:pointer);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [es:di]
  mov  byte ptr [ds:si],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_vmput(x,y:integer; p:pointer; mm:byte; tf:boolean);
var
 start,upp:word;
label
 loop_top,inner_top,nevermind,put_it,
 loop_top2,inner_top2,nevermind2,put_it2,
 go_on1,go_on2,go_on3;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 if tf then
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top2:
  push cx

  mov  cx,      dx
inner_top2:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   put_it2
  cmp  al,      1
  jne  go_on1
  mov  al,   246
  jmp  put_it2
  go_on1:
  cmp  al,      7
  jne  go_on2
  mov  al,   251
  jmp  put_it2
  go_on2:
  cmp  al,      8
  jne  go_on3
  mov  al,   241
  jmp  put_it2
  go_on3:
  mov    al,    243
put_it2:
  mov  byte ptr [es:di],      al
nevermind2:
  inc  si
  inc  di

  loop inner_top2
  add  di,      upp

  pop cx
  loop loop_top2;

  pop  es
  pop  ds
 end
 else
 asm
  push ds
  push es
  {mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start}
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      1
  jne  put_it
  mov  al,      mm
put_it:
  mov  byte ptr [es:di],      al
nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure img_mxor(x,y:integer; p:pointer; m:byte);
var
 start,upp:word;
label
 loop_top,inner_top,put_it;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   put_it
  add  al,      m
  xor  byte ptr [es:di],      al
  put_it:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure img_mmatte(x,y:integer; p:pointer; m:byte);
var
 start,upp:word;
label
 loop_top,inner_top,put_it,nevermind;
begin
 tp:=p;
 start:=y*320+x;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  mov  dx,      word ptr [ds:si]
  mov  cx,      word ptr [ds:si+2];
  add  si,      4
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      byte ptr [ds:si]
  cmp  al,      0
  je   nevermind
  add  al,      m
  put_it:
  mov  byte ptr [es:di],      al
  nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure fix_area(x1,y1,x2,y2:integer);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
label
 loop_top,inner_top,nevermind;
begin
 {tp:=screen;}
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  cld
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg screen
  mov   ds,     ax
  mov   si,     offset screen
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  add   si,     start
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure fix_area_word(x1,y1,x2,y2:integer);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
label
 loop_top,inner_top,nevermind;
begin
 {tp:=screen;}
 if x1 and 1<>0 then dec(x1);
 if x2 and 1=0 then inc(x2);
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  cld
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg screen
  mov   ds,     ax
  mov   si,     offset screen
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  add   si,     start
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx
  shr  dx,      1

loop_top:
  push cx
  cld
  mov  cx,      dx
  rep  movsw
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure fix_area_long(x1,y1,x2,y2:integer);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
label
 loop_top,inner_top,nevermind;
begin
 {tp:=screen;}
 if x1 and 3<>0 then dec(x1);
 if x2 and 3=0 then x2:=(x2 div 4)*4+3;
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  cld
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg screen
  mov   ds,     ax
  mov   si,     offset screen
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  add   si,     start
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx
  shr  dx,      2

loop_top:
  push cx
  cld
  mov  cx,      dx
  db 0F3h,066h,0A5h {rep  movsd}
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure copy_vscreen;
var
 sofs,sseg:word;
begin
 sseg:=seg(screen^);
 sofs:=ofs(screen^);
 asm
  push  ds
  mov   si,     sofs
  mov   ax,     sseg
  mov   ds,     ax
  mov   ax,     0A000h
  mov   es,     ax
  mov   di,     0
  mov   cx,     32000
  rep   movsw
  pop   ds
 end;
end;

Procedure save_area(x1,y1,x2,y2:integer);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
label
 loop_top,inner_top,nevermind;
begin
 {tp:=screen;}
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  push ds
  push es
  xor  dx,      dx
  xor  cx,      cx
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  mov  ax,      0A000h
  mov  si,      start
  mov  bx,      si
  push ax
  pop  ds
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     bx
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure copy_area(x1,y1,x2,y2:integer; ptr:scr_ptr_type);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
 p1:pointer;
label
 loop_top,inner_top,nevermind;
begin
 p1:=ptr;
 tp:=p1;
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   ds
  pop   si
  add   si,     start
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure move_area(x1,y1,x2,y2:integer; ptr,ptr2:scr_ptr_type);
var
 start,upp,sofs1,sofs2,sseg1,sseg2:word;
 xs,ys,xs2,ys2:byte;
 p1:pointer;
label
 loop_top,inner_top,nevermind;
begin
 p1:=ptr;
 tp:=p1;
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 sseg1:=seg(ptr^);
 sseg2:=seg(ptr2^);
 sofs1:=ofs(ptr^);
 sofs2:=ofs(ptr2^);
 asm
  push ds
  push es

  mov  ax,      sseg2
  mov  es,      ax
  mov  di,      sofs2
  mov  si,      sofs1
  mov  ax,      sseg1
  mov  ds,      ax
  add  si,      start

  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

Procedure move2_area(x1,y1,x2,y2:integer; ptr,ptr2:scr_ptr_type);
var
 start,upp,sofs1,sofs2,sseg1,sseg2:word;
 xs,ys,xs2,ys2:byte;
 p1:pointer;
label
 loop_top,inner_top,nevermind;
begin
 p1:=ptr;
 tp:=p1;
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 sseg1:=seg(ptr^);
 sseg2:=seg(ptr2^);
 sofs1:=ofs(ptr^);
 sofs2:=ofs(ptr2^);
 asm
  push ds
  push es

  mov  ax,      sseg2
  mov  es,      ax
  mov  di,      sofs2
  mov  si,      sofs1
  add  si,      start
  add  di,      start
  mov  ax,      sseg1
  mov  ds,      ax

  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      byte ptr [ds:si]
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top}
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure fast_palette(c,x1,x2,x3:byte);
begin
 {setrgbpalette(c,x1,x2,x3);
 exit;}
 asm
  {push ds
  push ax
  push dx}
        mov dx, 03C8H
        mov al, c
	out dx, al
        mov dx, 03C9H
        mov al, x1
	out dx, al
        mov al, x2
        out dx, al
        mov al, x3
        out dx, al
{  pop dx
  pop ax
  pop ds}
 end;
end;

Procedure VGA_on;
begin
 asm
  mov   ax,     1200h
  mov   bx,     0036h
  int   10h
 end;
end;

Procedure VGA_off;
begin
 asm
  mov   ax,     1201h
  mov   bx,     0036h
  int   10h
 end;
end;


procedure clear_v_screen;
var
 i:word;
begin
 for i:=0 to 65534 do
   screen^[i]:=0;
end;


Function get_point(x,y:word):byte;
begin
 get_point:=screen^[y*320+x];
end;

procedure ASM_bar(x1,y1,x2,y2,c:integer);
var
 start,upp:word;
 xs,ys:byte;
label
 loop_top,inner_top,nevermind;
begin
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 start:=y1*320+x1;
 upp:=320-(x2-x1+1);
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov  dl,      xs
  mov  cl,      ys

loop_top:
  push cx

  mov  cx,      dx
  rep  movsb
{inner_top:

  mov  al,      c
  mov  byte ptr [es:di],      al
  inc  di

  loop inner_top}
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;

procedure ASM_v_bar(x1,y1,x2,y2,c:integer);
var
 start,upp:word;
 xs,ys:word;
 col:byte;
label
 loop_top,inner_top,put_it,nevermind;
begin
 start:=y1*320+x1;
 upp:=320;
 col:=c;
 xs:=x2-x1+1;
 ys:=y2-y1+1;
 asm
  push ds
  push es
  mov   ax,     seg screen
  mov   es,     ax
  mov   di,     offset screen
  mov   ax,     [es:di]
  push  ax
  mov   ax,     [es:di+2]
  push  ax
  pop   es
  pop   di
  add   di,     start

  xor  dx,      dx
  xor  cx,      cx
  mov  dx,      xs
  mov  cx,      ys
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
inner_top:

  mov  al,      col
  mov  byte ptr [es:di],      al
  nevermind:
  inc  si
  inc  di

  loop inner_top
  add  di,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


Procedure v_bar(x1,y1,x2,y2,c:integer);
var
 i,k:integer;
begin
 if x1<0 then x1:=0;
 if x2<0 then x2:=0;
 if y2<0 then y2:=0;
 if y1<0 then y1:=0;
 if x1>319 then x1:=319;
 if x2>319 then x2:=319;
 if y2>319 then y2:=319;
 if y1>319 then y1:=319;
{ if x1<x2 then for i:=x1 to x2 do
  if y1<y2 then for k:=y1 to y2 do
   screen^[k,i]:=c
  else for k:=y2 to y1 do
   screen^[k,i]:=c
 else for i:=x2 to x1 do
  if y1<y2 then for k:=y1 to y2 do
   screen^[k,i]:=c
  else for k:=y2 to y1 do
   screen^[k,i]:=c;}
 if x1<x2 then
  begin
   if y1<y2 then
    asm_v_bar(x1,y1,x2,y2,c)
   else
    asm_v_bar(x1,y2,x2,y1,c);
  end
 else
  begin
   if y1<y2 then
    asm_v_bar(x2,y1,x1,y2,c)
   else
    asm_v_bar(x2,y2,x1,y1,c);
  end;
end;

Procedure a_bar(x1,y1,x2,y2:integer; ptr:scr_ptr_type; col:byte);
var
 start,upp:word;
 xs,ys,xs2,ys2:byte;
 p1:pointer;
label
 loop_top,inner_top,nevermind;
begin
 p1:=ptr;
 tp:=p1;
 start:=y1*320+x1;
 xs :=abs(x2-x1) mod 256;
 ys :=abs(y2-y1) mod 256;
 xs2:=abs(x2-x1) div 256;
 ys2:=abs(y2-y1) div 256;
 upp:=320;
 asm
  push ds
  push es
  mov  ax,      0A000h
  push ax
  pop  es
  mov  di,      start
  xor  dx,      dx
  xor  cx,      cx
  mov   ax,     seg tp
  mov   ds,     ax
  mov   si,     offset tp
  mov   ax,     [ds:si]
  push  ax
  mov   ax,     [ds:si+2]
  push  ax
  pop   es
  pop   di
  add   di,     start
  mov  dl,      xs {byte ptr [ds:si]}
  mov  cl,      ys {byte ptr [ds:si+2];}
  mov  dh,      xs2{byte ptr [ds:si+1]}
  mov  ch,      ys2{byte ptr [ds:si+3];}
  {add  si,      4}
  inc  cx
  inc  dx
  sub  upp,     dx

loop_top:
  push cx

  mov  cx,      dx
  {rep  movsb}
inner_top:

  mov  al,      col {byte ptr [ds:si]}
  mov  byte ptr [es:di],      al
  inc  si
  inc  di

  loop inner_top
  add  di,      upp
  add  si,      upp

  pop cx
  loop loop_top;

  pop  es
  pop  ds
 end;
end;


procedure v_rect(x1,y1,x2,y2,c:integer);
begin
 v_bar(x1,y1,x1,y2,c);
 v_bar(x1,y1,x2,y1,c);
 v_bar(x1,y2,x2,y2,c);
 v_bar(x2,y1,x2,y2,c);
end;

Function EXIST(thisfile : string) : boolean;
  var
    afile : file;
    iocode : word;

  begin {* fExist *}
    assign(afile,thisfile);
    {$I-}
    reset(afile);
    {$I+}
    iocode := ioresult;
    Exist := (iocode = 0);
    if iocode = 0 then close(afile);
  end;  {* fExist *}


procedure load_palette(fn:string);
var
 i,k:integer;
 f:text;
begin
 if not exist(fn) then exit;
 assign(f,fn);
 reset(f);
 for i:=0 to 255 do
  begin
   read(f,color[i].red);
   read(f,color[i].green);
   readln(f,color[i].blue);
  end;
 setall(@color);
 close(f);
end;

procedure read_palette(fn:string);
var
 i,k:integer;
 f:text;
begin
 if not exist(fn) then exit;
 assign(f,fn);
 reset(f);
 for i:=0 to 255 do
  begin
   read(f,color[i].red);
   read(f,color[i].green);
   readln(f,color[i].blue);
  end;
 close(f);
end;


procedure save_palette(fn:string);
var
 i,k:integer;
 f:text;
begin
 assign(f,fn);
 rewrite(f);
 for i:=0 to 255 do
  begin
   writeln(f,color[i].red,' ',color[i].green,' ',color[i].blue);
  end;
 close(f);
end;



procedure color_set(start,c1,c2,c3:integer);
var
 i:integer;
begin
 for i:=0 to 15 do
  begin
   color[i+start].red  :=round((i/15)*c1);
   color[i+start].green:=round((i/15)*c2);
   color[i+start].blue :=round((i/15)*c3);
  end;
 for i:=0 to 15 do
  begin
   color[i+start+16].red  :=round(c1+(i/15)*(63-c1));
   color[i+start+16].green:=round(c2+(i/15)*(63-c2));
   color[i+start+16].blue :=round(c3+(i/15)*(63-c3));
  end;
end;

procedure color_spread(start,stop,c1,c2,c3,d1,d2,d3:integer);
var
 i:integer;
begin
 for i:=0 to stop-start do
  begin
   color[i+start].red  :=c1+round((d1-c1)*i/(stop-start+1));
   color[i+start].green:=c2+round((d2-c2)*i/(stop-start+1));
   color[i+start].blue :=c3+round((d3-c3)*i/(stop-start+1));
  end;
end;

procedure pal_fade(p1,p2:color_ptr; n,start,len:integer; refresh:boolean);
var
 i,j,k:integer;
 {tcol:color_type;}
begin
 j:=start; if j<0 then j:=0;
 k:=start+len-1; if k>255 then k:=255;
 for i:=j to k do
  begin
   tcolor[i].red  :=p1^[i].red  +round((p2^[i].red  -p1^[i].red  )*n/100);
   tcolor[i].green:=p1^[i].green+round((p2^[i].green-p1^[i].green)*n/100);
   tcolor[i].blue :=p1^[i].blue +round((p2^[i].blue -p1^[i].blue )*n/100);
  end;
 if refresh then
  begin
   setpal(@tcolor,start,len+1);
   {wait_vrefresh;
   for i:=start to start+len-1 do
    fast_palette(i,tcolor[i].red,tcolor[i].green,tcolor[i].blue);}
  end else setpalf(@tcolor,start,len+1);
end;

procedure new_setallf(col:color_ptr);
var
 sseg,sofs:word;
begin
 sseg:=seg(col^);
 sofs:=ofs(col^);
 asm
        mov     si,sofs
        mov     dx,3C8h         { DAC index register               }
        mov     al,0            { start with reg 1                 }
        out     dx,al           { and load                         }
        inc     dx              { DAC read/write register          }
        mov     cx,256          { write 256 items                  }
        push    ds              { store DS                         }
        mov     ax,sseg
        mov     ds,ax           { address segment                  }
        cld                     { ensure SI is incremented         }
@1:     outsb                   { load R,G,B                       }
        outsb                   { Note - REP OUTSB is too fast on  }
        outsb                   { some older VGA cards..           }
        loop    @1              { so loop                          }
        pop     ds              { and restore DS                   }
 end;
end;

procedure new_setpalf(col:color_ptr; start,len:byte);
var
 sseg,sofs:word;
begin
 sseg:=seg(col^);
 sofs:=ofs(col^);
 asm
        mov     si,sofs
        mov     dx,3C8h         { DAC index register               }
        mov     al,start        { start with reg #'start'          }
        out     dx,al           { and load                         }
        inc     dx              { DAC read/write register          }
        xor     cx,cx
        mov     cl,len          { write 'len' items                }
        push    ds              { store DS                         }
        mov     ax,sseg
        mov     ds,ax           { address segment                  }
        cld                     { ensure SI is incremented         }
@1:     outsb                   { load R,G,B                       }
        outsb                   { Note - REP OUTSB is too fast on  }
        outsb                   { some older VGA cards..           }
        loop    @1              { so loop                          }
        pop     ds              { and restore DS                   }
 end;
end;


begin
 if memavail<64000 then
  begin writeln('Graphics-Daemon Error: Insufficient memory.'); halt(1); end;
 new(screen);
 realscreen:=ptr($A000,0);
end.
