unit stelc3u;

{
Stellar Conquest III, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there is code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

If you do create a derivative work, please drop me a note at
necrobones@necrobones.com and let me know! I'd love to hear about it!

Good luck! :)
}


interface

uses dos, crt, filelib, stuff, graph, myfile, svgabgi, mygraph, bobmouse;

const
 cnotice1     ='Stellar Conquest III, Hostile Takeover. v1.05';
 cnotice2     ='(C) 1994 Ed T. Toton III, All Rights Reserved.';
 main_filename='STELCON3';
 max_ships    =100;
 max_weaps    =64;
 max_pods     =9;
 max_stars    =50;
 max_players  =4;
 max_holes    =10;
 action_range =4;
 max_games    =1;
 max_tactics  =2;
 weap_mine    =1;
 weap_torp    =2;
 mine_mass    =20;
 torp_mass    =50;
 torp_speed   =24;
 max_distrib  =2;
 sstar_acc    =1.05;
 max_sstar    =150;
 i_debugging  =false;
 max_pimg     =24;
 cheat_mode   =false;
 max_name_length=25;
 max_names    =200;
{$I regscrn.pas}

type
 ship_rec = record
             tx,ty,x,y,hp,cargo,rx,ry,ox,oy,
             torpedoes,mines,fnum,fired:integer;
             pod:string[max_pods];
             pcount:array[1..max_pods] of shortint;
             name:string[max_name_length];
             base,a,booster,auto,repaired,cloak_active,
             anystar,anybase,robot,mining,torping,leader:boolean;
             engine:byte;
            end;
 weap_rec = record
             x,y,tx,ty,typ,age:integer;
             {typ:   0=non-existent
                     1=mine
                     2=torpedo}
            end;
 player_rec=record
             ship:array[1..max_ships] of ship_rec;
             weap:array[1..max_weaps] of weap_rec;
             comp,grid,grid2:boolean;
             money:longint;
             ratio:real;
             mode,team:byte;
             tactic,cships:integer;
             name:string[max_name_length];
            end;
 star_rec = record
             x,y:integer;
             supply:longint;
            end;
 streak_rec=record
             x,y:integer;
             lshow:boolean;
             col,spd:byte;
            end;
 sstar_rec= record
             x,y,xv,yv:real;
             bright,col:shortint;
             lshow:boolean;
             count:integer;
            end;
 hole_rec = record
             x,y:integer;
             visible,travelled:boolean;
            end;
 start_ship_type=record
                  pod:string[max_pods];
                  booster,robot:boolean;
                  engine:byte;
                 end;
 sys_rec  = record
             bomb_base,shoot_base,base_mobile,base_fire,see_all:boolean;
             num_bases,end_type,num_players,base_damage,
             base_distribution,base_speed:integer;
             ship:array[1..max_players,1..10] of start_ship_type;
             name:string[64];
             base_pod:string[max_pods];
             start_money:longint;
            end;


var
 {gamedata}
 player:array[1..max_players] of player_rec;
 star:array[1.. max_stars] of star_rec;
 hole:array[1..max_holes] of hole_rec;
 sstar:array[1..max_sstar] of sstar_rec;
 registered,loaded_game,sound_off,fast_combat:boolean;
 game_type,playnum,num_players:integer;
 gamesys:sys_rec;
 cycle:longint;
 regname:string;
 regcode:word;
 {images}
 star_img,crosshair,crosshair2,crosshair3,crosshair4,
 explosion,tempp,hole_img,big_blast,base_portrait,
 img_torp,img_mine:pointer;
 ship_img:array[1..max_players,0..max_pods] of pointer;
 base_img:array[1..max_players] of pointer;
 pod_img:array[1..max_pimg] of pointer;
 {local data}
 main_color:color_type;
 num_names:integer;
 name:array[1..max_names] of ^string;



procedure ship_sort(p:integer);
procedure prt(x,y:integer; s:string; col:byte);
function human_comp(p:integer):string;
function cstrrr(r:real):string;
function bd(i:integer):string;
procedure draw_ship(x,y:integer; pod:string; engine,booster,robot:boolean);
procedure h_bar(x1,y1,x2,y2,thickness:integer);
procedure v_bar(x1,y1,x2,y2,thickness:integer);
procedure show_tmode(tmode:integer);
procedure print(y:integer;s:string);
procedure draw_base;
procedure necrologo(px,py:integer; palname:string; title:boolean);
procedure show_reg_screen;
procedure shutdown;
Procedure verify_reg;
function check_view(p,p2,n:integer):boolean;
function check_holeview(p,n:integer):boolean;
function check_view_weap(p,p2,n:integer):boolean;
procedure read_docs;
procedure show_scn(fn:string);
procedure low_res_intro;
procedure check_files;
procedure Abort(Msg : string);
procedure save_game(fn:string);
procedure load_game(fn:string);
procedure load_img(h:word; var p:pointer);
procedure load_binary;
procedure load_file(fn:string);
procedure load_file2(fn:string);
procedure load_images;
procedure working;
procedure working2;
procedure do_sstars;
procedure ending(winner:integer; message:string; col:integer);
procedure show_game_stats;
function myabs(x:longint):longint;
function diff(n1,n2:integer):integer;
function count_weaps(p,t:integer):integer;
function add_weap(p,xx,yy,ttx,tty,t:integer):integer;
procedure clear_ship(var tship:ship_rec);
function find_star(xx,yy:integer):integer;
function count_bases(p:integer):integer;
function random_base(p:integer):integer;
function weakest_base(p:integer):integer;
function find_a_base(xx,yy:integer):integer;
function find_a_base2(p,xx,yy,range,range2:integer):integer;
procedure find_enemy_base(p,xx,yy,range,tp,tn:integer);
function nearest_base(p,xx,yy:integer):integer;
procedure load_names;
function randname:string;
function count_pods(pod:string; p:char):integer;
procedure sound_effect(n:integer);
function all_computers:boolean;
function count_cargo_ships(p:integer):integer;
function count_weapon_ships(p:integer):integer;
function count_ships(p:integer):integer;
function ship_class(ship:ship_rec):string;
function player_color(p:integer):integer;
function max_armor(s:string):integer;
function ship_cost(ship:ship_rec):longint;
function weap_val(s:string):integer;
function pick_name(p,n:integer):string;
function pod_weight(ship:ship_rec; carg:boolean):integer;
function max_cargo(ship:ship_rec):integer;
function max_mines(ship:ship_rec):integer;
function max_torps(ship:ship_rec):integer;
function ship_weight(ship:ship_rec):integer;
function ship_weighte(ship:ship_rec):integer;
function ship_weightf(ship:ship_rec):integer;
function ship_speed(ship:ship_rec):integer;
function ship_speede(ship:ship_rec):integer;
function ship_speedf(ship:ship_rec):integer;
function scan_range(ship:ship_rec):integer;
function slowest_speed(p,n,f:integer):integer;
function find_leader(p,f:integer):integer;
function Cbool(b:boolean):string;
function team_value(p:integer):longint;
function add_ship(p,n:integer; s:string; e:byte; bb,rob:boolean):integer;
procedure game_init;
procedure main_init;
procedure the_init;
procedure finish_it(start:integer; all_the_way:boolean);
procedure draw_ship_stats(p,n:integer);
procedure draw_base_stats(p,n:integer; tship:ship_rec);
procedure draw_guy(xx,yy,mapx,mapy,p,n,mapmode:integer; flashy:boolean);
procedure xorimg(x,y:integer; p1:pointer; col,size:integer);
procedure put_crosshair(mapx,mapy,p,n,mapmode:integer);



implementation


procedure ship_sort(P:integer);
var
 i,j,k:integer;
 sh:ship_rec;
begin
 with player[p] do
  begin
   for i:=1 to max_ships-1 do
    if not ship[i].a then
     begin
      sh:=ship[i];
      for k:=i to max_ships-1 do ship[k]:=ship[k+1];
      ship[max_ships]:=sh;
     end;
  end;
end;

procedure prt(x,y:integer; s:string; col:byte);
begin
 setfillstyle(1,0);
 bar(x,y-3,x+(length(s)*8),y+5);
 setcolor(col);
 outtextxy(x,y-3,s);
end;

function human_comp(p:integer):string;
begin
 if player[p].comp then human_comp:='Computer' else human_comp:='Human   ';
end;

function cstrrr(r:real):string;
var
 i,k:integer;
 s:string;
begin
 k:=trunc(r*10);
 s:=zero_pad(k,2);
 cstrrr:=s[1]+'.'+s[2];
end;

function bd(i:integer):string;
begin
 case i of
  0:bd:='Normal   ';
  1:bd:='Random   ';
  2:bd:='Clustered';
 end;
end;


procedure draw_ship(x,y:integer; pod:string; engine,booster,robot:boolean);
var
 i,j,k,l:integer;
begin
 x:=x-(length(pod)+2)*16;
 y:=y-15;
 for i:=0 to length(pod)+1 do
  begin
   if i=0 then
    case robot of
     true :putimage(x,y,pod_img[16]^,copyput);
     false:putimage(x,y,pod_img[5]^,copyput);
    end;
   if (i=length(pod)+1) and engine then putimage(x,y,pod_img[7]^,copyput);
   if (i=length(pod)+1) and (not engine) then putimage(x,y,pod_img[6]^,copyput);
   if (i=length(pod)+1) and booster then putimage(x,y,pod_img[8]^,orput);
   if (i>0) and (i<=length(pod)) then
    case pod[i] of
     'C':putimage(x,y,pod_img[1]^,copyput);
     'L':putimage(x,y,pod_img[2]^,copyput);
     'M':putimage(x,y,pod_img[3]^,copyput);
     'P':putimage(x,y,pod_img[4]^,copyput);
     'A':putimage(x,y,pod_img[9]^,copyput);
     'S':putimage(x,y,pod_img[10]^,copyput);
     'I':putimage(x,y,pod_img[11]^,copyput);
     'B':putimage(x,y,pod_img[12]^,copyput);
     'T':putimage(x,y,pod_img[13]^,copyput);
     'E':putimage(x,y,pod_img[14]^,copyput);
     'F':putimage(x,y,pod_img[17]^,copyput);
     'X':putimage(x,y,pod_img[18]^,copyput);
     'O':putimage(x,y,pod_img[20]^,copyput);
     'W':putimage(x,y,pod_img[19]^,copyput);
     'J':putimage(x,y,pod_img[21]^,copyput);
     'K':putimage(x,y,pod_img[22]^,copyput);
     'V':putimage(x,y,pod_img[23]^,copyput);
     else putimage(x,y,pod_img[15]^,copyput);
    end;
   x:=x+32;
  end;
end;


procedure h_bar(x1,y1,x2,y2,thickness:integer);
begin
 setfillstyle(1,7);
 bar(x1,y1-thickness,x2,y2+thickness);
 setcolor(8);
 line(x1,y1+1+thickness,x2,y2+1+thickness);
 setcolor(15);
 line(x1,y1-1-thickness,x2,y2-1-thickness);
end;

procedure v_bar(x1,y1,x2,y2,thickness:integer);
begin
 setfillstyle(1,7);
 bar(x1-thickness,y1,x2+thickness,y2);
 setcolor(8);
 line(x1+1+thickness,y1,x2+1+thickness,y2);
 setcolor(15);
 line(x1-1-thickness,y1,x2-1-thickness,y2);
end;

procedure show_tmode(tmode:integer);
begin
 setfillstyle(1,0);
 bar(6,368,305,376);
 setcolor(7);
 case tmode of
  0:outtextxy(6,368,'Normal Navigation Mode.');
  1:outtextxy(6,368,'AutoMine Base Select Mode.');
  2:outtextxy(6,368,'Torpedo Targeting Mode.');
 end;
end;


procedure print(y:integer;s:string);
begin
 setfillstyle(1,0);
 bar(374,y,634,y+9);
 outtextxy(374,y,s);
end;

procedure draw_base;
var
 i,j,k:integer;
begin
 setfillstyle(1,0);
 bar(372,200,634,306);
 setcolor(15);
 rectangle(375,209,630,299);
 for i:=1 to 100 do
  begin
   k:=random(4);
   case k of
    0:j:=7;
    1:j:=8;
    2:j:=15;
    3:j:=1+random(2)*8;
   end;
   putpixel(376+random(254),210+random(89),j);
  end;
 putimage(475,235,base_portrait^,copyput);
end;



{$I nlogo.inc}

procedure show_reg_screen;
var
 i,j,k,l:integer;
 c,cc:char;
begin
 textmode(co80);
 asm
  push  ds
  mov   ax,     $B800
  mov   es,     ax
  mov   di,     0
  mov   ax,     seg IMAGEDATA
  mov   ds,     ax
  mov   si,     offset IMAGEDATA
  mov   cx,     4000
  rep   movsb
  pop   ds
 end;
 repeat
  cc:=upcase(chr(random(94)+33));
 until not (cc in ['`','"','''']);
 textcolor(15);
 textbackground(2);
 gotoxy(2,17);
 write(space(78));
 gotoxy(28,17);
 write('Press the "'+cc+'" key to exit.');
 repeat
 until upcase(readkey)=cc;
 gotoxy(1,20);
 textcolor(7); textbackground(0);
end;

procedure shutdown;
begin
 closegraph;
 if not registered then show_reg_screen;
 writeln(cnotice1);
 writeln(cnotice2);
 halt;
end;

Procedure verify_reg;
var
 fil:text;
 i:integer;
 w:word;
 s:String;
begin
 if not exist(path(paramstr(0))+main_filename+'.reg') then begin registered:=false; exit; end;
 assign(fil,path(paramstr(0))+main_filename+'.reg');
 reset(fil);
 readln(fil,regname);
 readln(fil,s);
 regcode:=value(s);
 close(fil);
 registered:=false;
 regname:=btrim(regname);
 s:=ucase(regname);
 if length(s)>0 then
  begin
   w:=0;
   for i:=1 to length(s) do
    w:=w+ord(s[i]);
   w:=w xor $5A5A;
   if w=regcode then registered:=true else registered:=false;
  end
 else registered:=false;
end;



function check_view(p,p2,n:integer):boolean;
var
 i,j,k,l:integer;
 Stealth:boolean;
 r:real;
begin
 if (p=p2) or (cheat_mode) then begin check_view:=true; exit; end;
 if (player[p2].ship[n].cloak_active) and (count_pods(player[p2].ship[n].pod,'X')>0) then
    begin check_view:=false; exit; end;
 if (gamesys.see_all) then begin check_view:=true; exit; end;
 Stealth:=count_pods(player[p2].ship[n].pod,'I')>0;
 i:=0; k:=-1;
 while (i<max_ships) and (k<0) do
  with player[p2].ship[n] do
   begin
    inc(i);
    if player[p].ship[i].a then
     begin
      r:=abs(sqr(abs(x-player[p].ship[i].x)))+abs(sqr(abs(y-player[p].ship[i].y)));
      if r>=1 then j:=round(sqrt(r)) else j:=0;
      if ((j<=scan_range(player[p].ship[i])) and (not Stealth)) or
         ((abs(x-player[p].ship[i].x)<=action_range) and (abs(y-player[p].ship[i].y)<=action_range))
         or (player[p].team=player[p2].team) then k:=i;
     end;
   end;
 if k>0 then check_view:=true else check_view:=false;
end;

function check_holeview(p,n:integer):boolean;
var
 i,j,k,l:integer;
 ok:boolean;
 r:real;
begin
 i:=0; k:=0; ok:=false;
 if (hole[n].visible) or (cheat_mode) or (gamesys.see_all) then ok:=true
  else
   while (i<max_ships) and (not ok) do
    with hole[n] do
     begin
      inc(i);
      if player[p].ship[i].a then
       begin
        r:=sqr(abs(x-player[p].ship[i].x))+sqr(abs(y-player[p].ship[i].y));
        if r>=1 then j:=round(sqrt(r)) else j:=0;
        if j<=scan_range(player[p].ship[i]) then ok:=true;
       end;
     end;
 hole[n].visible:=ok;
 check_holeview:=ok;
end;

function check_view_weap(p,p2,n:integer):boolean;
var
 i,j,k,l:integer;
 ok:boolean;
 r:real;
begin
 i:=0; k:=0; ok:=false;
 if player[p2].weap[n].typ=0 then begin check_view_weap:=false; exit; end;
 if (player[p2].weap[n].typ=weap_mine) or (p2=p) then begin check_view_weap:=true; exit; end;
 with player[p2] do
  if (cheat_mode) or (gamesys.see_all) then ok:=true
   else
    while (i<max_ships) and (not ok) do
     with weap[n] do
      begin
       inc(i);
       if player[p].ship[i].a then
        begin
         r:=sqr(abs(x-player[p].ship[i].x))+sqr(abs(y-player[p].ship[i].y));
         if r>=1 then j:=round(sqrt(r)) else j:=0;
         if j<=scan_range(player[p].ship[i]) then ok:=true;
        end;
      end;
 check_view_weap:=ok;
end;



procedure read_docs;
begin
 closegraph;
 exec('READ.EXE',main_filename+'.DOC');
 graphVGA;
end;

procedure show_scn(fn:string);
var
 h:word;
 i,j,k,l:integer;
begin
 open_filein(h,fn);
 black_palette;
 l:=768;   read_file(h,@color,l); 
 l:=32000; read_file(h,ptr($A000,0),l);
 l:=32000; read_file(h,ptr($A000,32000),l);
 setall(@color);
 close_file(h);
end;

procedure fade_in;
var
 i:integer;
 ltimer:word;
label abort;
begin
 black_palette;
 color:=main_color;
 for i:=0 to 25 do
  begin
   do_palette(i*4);
   repeat
   until (memw[0:$46C]<>ltimer) or keypressed;
   if keypressed then goto abort;
   ltimer:=memw[0:$46C];
  end;
 abort:
 color:=main_color;
 setall(@color);
end;

procedure fade_out;
var
 i:integer;
 ltimer:word;
label abort;
begin
 {set_palette;}
 color:=main_color;
 for i:=25 downto 0 do
  begin
   do_palette(i*4);
   repeat
   until (memw[0:$46C]<>ltimer) or keypressed;
   if keypressed then goto abort;
   ltimer:=memw[0:$46C];
  end;
 abort:
 black_palette;
end;

procedure a_delay(n:integer);
var
 i:integer;
 ltimer:word;
begin
 i:=0;
 flushkey;
 repeat
    repeat
    until (memw[0:$46C]<>ltimer) or keypressed;
    ltimer:=memw[0:$46C];
    inc(i);
 until keypressed or (i>=n);
end;

procedure low_res_intro;
var
 i,j,k,l:integer;
 s:string[80];
begin
 dispose(screen);
 graphitV;
 load_palette(main_filename+'.PAL');
 main_color:=color;
 black_palette;
 necrologo(160,70,main_filename+'.PAL',false);
 settextjustify(centertext,toptext);
 setcolor(3);
 outtextxy(160,160,'A NecroBones Production');
 fade_in;
 a_delay(72);
 fade_out;
 black_palette;
 show_scn(main_filename+'.SCN');
 k:=7*32; color_set(k,0,63,10); setall(@color);
 settextstyle(defaultfont,horizdir,1);
 settextjustify(centertext,toptext);
 s:='Stellar Conquest ]I['; i:=10;
 setcolor(k+08); outtextxy(160,i+6,s);
 setcolor(k+18); outtextxy(160,i+5,s);
 s:='(C) 1994 Ed T. Toton ]I[';
 setcolor(k+08); outtextxy(160,i+21,s);
 setcolor(k+18); outtextxy(160,i+20,s);
 s:='All Rights Reserved.';
 setcolor(k+08); outtextxy(160,i+31,s);
 setcolor(k+18); outtextxy(160,i+30,s);
 flushkey; readkey;
 closegraph;
end;

procedure check_files;
var
 s,fn:string;
begin
 s:='';
 fn:=main_filename+'.SCN'; if not exist(fn) then s:=fn;
 fn:=main_filename+'.DOC'; if not exist(fn) then s:=fn;
 fn:=main_filename+'.BMG'; if not exist(fn) then s:=fn;
 fn:=main_filename+'.EXE'; if not exist(fn) then s:=fn;
 fn:=main_filename+'.PAL'; if not exist(fn) then s:=fn;
 fn:='READ.EXE'; if not exist(fn) then s:=fn;
 fn:='LOGO.DAT'; if not exist(fn) then s:=fn;
 if s<>'' then
  begin
   writeln('Error finding file "'+s+'".');
   halt(2);
  end;
end;


procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

procedure save_game(fn:string);
var
 h:word;
 i,j,k,l:integer;
begin
 open_fileout(h,fn);
 l:=sizeof(gamesys);
 write_file(h,@gamesys,l);
 l:=sizeof(game_type);
 write_file(h,@game_type,l);
 l:=sizeof(playnum);
 write_file(h,@playnum,l);
 l:=sizeof(num_players);
 write_file(h,@num_players,l);
 l:=sizeof(star);
 write_file(h,@star,l);
 for i:=1 to max_players do
  begin
   l:=sizeof(player[i]);
   write_file(h,@player[i],l);
  end;
 l:=sizeof(cycle);
 write_file(h,@cycle,l);
 l:=sizeof(hole);
 write_file(h,@hole,l);
 close_file(h);
end;

procedure load_game(fn:string);
var
 h:word;
 i,j,k,l:integer;
begin
 if not exist(fn) then exit;
 open_filein(h,fn);
 l:=sizeof(gamesys);
 read_file(h,@gamesys,l);
 l:=sizeof(game_type);
 read_file(h,@game_type,l);
 l:=sizeof(playnum);
 read_file(h,@playnum,l);
 l:=sizeof(num_players);
 read_file(h,@num_players,l);
 l:=sizeof(star);
 read_file(h,@star,l);
 for i:=1 to max_players do
  begin
   l:=sizeof(player[i]);
   read_file(h,@player[i],l);
  end;
 l:=sizeof(cycle);
 read_file(h,@cycle,l);
 l:=sizeof(hole);
 read_file(h,@hole,l);
 close_file(h);
 if playnum>0 then loaded_game:=true;
end;

procedure load_img(h:word; var p:pointer);
var
 k,l:integer;
begin
 k:=2; read_file(h,@l,k); getmem(p,l);
 read_file(h,p,l);
end;

procedure load_binary;
var
 i,j,k,l:integer;
 h:word;
begin
 open_filein(h,main_filename+'.BMG');

 load_img(h,hole_img);
 load_img(h,explosion);
 load_img(h,crosshair);
 load_img(h,crosshair2);
 load_img(h,star_img);

 for j:=1 to max_players do
  for i:=0 to 6 do
   load_img(h,ship_img[j,i]);

 for i:=1 to max_players do
  load_img(h,base_img[i]);

 load_img(h,big_blast);
 load_img(h,crosshair3);
 load_img(h,crosshair4);
 load_img(h,img_torp);
 load_img(h,img_mine);

 for i:=0 to max_pimg-1 do
  load_img(h,pod_img[i+1]);

 load_img(h,base_portrait);

 close_file(h);
end;

procedure load_file(fn:string);
var
 i,j,k,l,x,y:integer;
 f:text;
begin
 assign(f,fn);
 reset(f);
 readln(f,x);
 readln(f,y);
 for i:=0 to x-1 do
  for k:=0 to y-1 do
   begin
    readln(f,j);
    putpixel(i,k,j);
   end;
 close(f);
end;

procedure load_file2(fn:string);
var
 i,j,k,l,x,y:integer;
 f:text;
begin
 assign(f,fn);
 reset(f);
 readln(f,x);
 readln(f,y);
 for i:=0 to x-1 do
  for k:=0 to y-1 do
   begin
    readln(f,j);
    setcolor(j);
    rectangle(i*2,k*2,i*2+1,k*2+1);
   end;
 close(f);
end;


procedure load_images;
var
 i,j,k,l:integer;
 h:word;
begin
 if not i_debugging then begin load_binary; exit; end;
 open_fileout(h,main_filename+'.BMG');

 load_file('SHIP.1');
 l:=imagesize(58,4,68,13);
 getmem(hole_img,l);
 getimage(58,4,68,13,hole_img^);
 k:=2; write_file(h,@l,k);
 write_file(h,hole_img,l);
 l:=imagesize(53,44,71,59);
 getmem(explosion,l);
 getimage(53,44,71,59,explosion^);
 k:=2; write_file(h,@l,k);
 write_file(h,explosion,l);
 l:=imagesize(0,25,20,45);
 getmem(crosshair,l);
 getimage(0,25,20,45,crosshair^);
 k:=2; write_file(h,@l,k);
 write_file(h,crosshair,l);
 l:=imagesize(0,46,20,66);
 getmem(crosshair2,l);
 getimage(0,46,20,66,crosshair2^);
 k:=2; write_file(h,@l,k);
 write_file(h,crosshair2,l);
 l:=imagesize(35,19,51,35);
 getmem(star_img,l);
 getimage(35,19,51,35,star_img^);
 k:=2; write_file(h,@l,k);
 write_file(h,star_img,l);
 for i:=0 to 15 do
  for k:=0 to 21 do
   begin
    j:=getpixel(i,k);
    putpixel(16+(15-i),k,j);
    if j=10 then j:=12;
    if j=2 then j:=4;
    putpixel(32+i,k,j);
    if j=12 then j:=13;
    if j=4 then j:=5;
    putpixel(48+(15-i),k,j);
    if j=13 then j:=11;
    if j=5 then j:=3;
    putpixel(64+i,k,j);
   end;
 for j:=1 to max_players do
  for i:=0 to 6 do
   begin
    l:=imagesize(0,0,15,3);
    getmem(ship_img[j,i],l);
    getimage(0+j*16,i*3,15+j*16,i*3+2,ship_img[j,i]^);
    k:=2; write_file(h,@l,k);
    write_file(h,ship_img[j,i],l);
   end;

  for i:=1 to max_players do
   begin
    l:=imagesize(34,38,45,49);
    getmem(base_img[i],l);
    getimage(34,38,45,49,base_img[i]^);
    k:=2; write_file(h,@l,k);
    write_file(h,base_img[i],l);
    for j:=34 to 45 do
     for k:=38 to 49 do
      begin
       l:=getpixel(j,k);
       case l of
         2:l:=4;
        10:l:=12;
         4:l:=5;
        12:l:=13;
         5:l:=3;
        13:l:=11;
       end;
       putpixel(j,k,l);
      end;
   end;

 load_file('SHIP.2');
 l:=imagesize(0,0,32,32);
 getmem(big_blast,l);
 getimage(0,0,32,32,big_blast^);
 k:=2; write_file(h,@l,k);
 write_file(h,big_blast,l);
 l:=imagesize(44,0,64,20);
 getmem(crosshair3,l);
 getimage(44,0,64,20,crosshair3^);
 k:=2; write_file(h,@l,k);
 write_file(h,crosshair3,l);
 l:=imagesize(44,26,64,46);
 getmem(crosshair4,l);
 getimage(44,26,64,46,crosshair4^);
 k:=2; write_file(h,@l,k);
 write_file(h,crosshair4,l);

 l:=imagesize(27,44,31,48);
 getmem(img_torp,l);
 getimage(27,44,31,48,img_torp^);
 k:=2; write_file(h,@l,k);
 write_file(h,img_torp,l);
 l:=imagesize(10,42,13,45);
 getmem(img_mine,l);
 getimage(10,42,13,45,img_mine^);
 k:=2; write_file(h,@l,k);
 write_file(h,img_mine,l);

 l:=imagesize(0,0,31,31);
 for i:=1 to max_pimg do
  getmem(pod_img[i],l);
 for i:=0 to max_pimg-1 do
  begin
   if i mod 4=0 then load_file('pods'+cstr((i div 4)+1)+'.img');
   getimage((i mod 2)*32,((i mod 4) div 2)*32,(i mod 2)*32+31,((i mod 4) div 2)*32+31,pod_img[i+1]^);
   k:=2; write_file(h,@l,k);
   write_file(h,pod_img[i+1],l);
  end;

 load_file('base.img');
 l:=imagesize(6,9,58,42); {12,18,117,85}
 getmem(base_portrait,l);
 getimage(6,9,58,42,base_portrait^);
 k:=2; write_file(h,@l,k);
 write_file(h,base_portrait,l);

 close_file(h);
end;



procedure working;
begin
 setfillstyle(1,1);
 bar(576,0,639,10);
 setcolor(14);
 outtextxy(580,2,'WORKING');
end;

procedure working2;
begin
 setfillstyle(1,1);
 bar(250,200,390,220);
 setcolor(14);
 settextstyle(defaultfont,horizdir,2);
 outtextxy(264,202,'WORKING');
 settextstyle(defaultfont,horizdir,1);
end;


procedure do_sstars;
var
 i,j,k,l,mx,my:integer;
 b:boolean;
 c:char;
 w:word;
begin
 for j:=1 to 250 do
  begin
   repeat
    i:=random(640); k:=random(480);
   until getpixel(i,k)=0;
   putpixel(i,k,8);
  end;
 for i:=1 to max_sstar do
  with sstar[i] do
   begin x:=-1000; y:=-1000; xv:=-1; yv:=-1; lshow:=false; end;
 flushkey;
 repeat
  for i:=1 to max_sstar do
   with sstar[i] do
    begin
     if lshow then putpixel(round(x+320),round(y+240),0);
     xv:=xv*sstar_acc; yv:=yv*sstar_acc;
     x:=x+xv; y:=y+yv;
     inc(count);
     if count>=30 then
      case col of
       1:bright:=8;
       7:bright:=8;
       8:bright:=-1;
      end;
     if count>=60 then
      case col of
       1:bright:=2;
       7:bright:=8;
       8:bright:=7;
      end;
     if ((x+320.0<0.0) or (x+320.0>639.0) or (y+240.0<0) or (y+240.0>479.0)) then
      begin
       repeat
        x:=(random(101));
        y:=(random(101));
        if random(2)=0 then y:=-y;
        if random(2)=0 then x:=-x;
       until (x<>0) or (y<>0);
       yv:=y/100; xv:=x/100;
       bright:=0; count:=0;
       k:=random(5);
       case k of
        0:col:=1;
        1,2:col:=7;
        3,4:col:=8;
       end;
      end;
     if (getpixel(round(x+320),round(y+240))>0) then lshow:=false
     else
      begin
       lshow:=true;
       putpixel(round(x+320),round(y+240),col+bright);
      end;
    end;
  repeat
  until w<>memw[0:$46C];
  w:=memw[0:$46C];
 until keypressed;
end;


procedure ending(winner:integer; message:string; col:integer);
var
 i,j,k,l,mx,my:integer;
 b:boolean;
 c:char;
 w:word;
begin
 cleardevice;
 settextjustify(centertext,toptext);
 setcolor(col);
 settextstyle(defaultfont,horizdir,2);
 outtextxy(320,180,message);
 {if winner>0 then outtextxy(320,180,'Player #'+cstr(winner)+' wins!')
             else outtextxy(320,180,'No one wins!');}
 setcolor(3);
 settextstyle(defaultfont,horizdir,1);
 settextjustify(lefttext,toptext);
 outtextxy(0,470,'Press any key to continue...');
 do_sstars;
end;

procedure show_game_stats;
var
 xx,yy:integer;
begin
 xx:=185; yy:=110;
 setcolor(15);
 settextjustify(centertext,toptext);
 settextstyle(defaultfont,horizdir,2);
 setfillstyle(1,1); bar(xx-180,yy,xx+179,yy+75);
 outtextxy(xx,yy+10,'Player#'+cstr(playnum));
 outtextxy(xx,yy+30,'Bases: '+cstr(count_bases(playnum)));
 outtextxy(xx,yy+50,'Turn: '+cstr(cycle));
 settextstyle(defaultfont,horizdir,1);
 settextjustify(lefttext,toptext);
end;



function myabs(x:longint):longint;
begin
 if x<0 then myabs:=-x else myabs:=x;
end;

function diff(n1,n2:integer):integer;
begin
 if n1>n2 then diff:=n1-n2 else diff:=n2-n1;
end;


function count_weaps(p,t:integer):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_weaps do
  if player[p].weap[i].typ=t then inc(k);
 count_weaps:=k;
end;

function add_weap(p,xx,yy,ttx,tty,t:integer):integer;
var
 i,k:integer;
begin
 with player[p] do
  begin
   k:=0;
   for i:=1 to max_weaps do
    if (weap[i].typ=0) and (k=0) then k:=i;
  end;
 if k>0 then with player[p].weap[k] do
  begin
   x:=xx; y:=yy; tx:=ttx; ty:=tty; typ:=t;
  end;
 add_weap:=k;
end;

procedure clear_ship(var tship:ship_rec);
var
 i:integer;
begin
 with tship do
  begin
   pod:=''; engine:=1; booster:=false;
   name:=''; cargo:=0; robot:=false;
   base:=false; torpedoes:=0; mines:=0;
   mining:=false; torping:=false; cloak_active:=false;
   for i:=1 to max_pods do pcount[i]:=0;
   fnum:=0; leader:=false;
  end;
end;

function find_star(xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0; l:=0;
 for i:=1 to max_stars do
  with star[i] do
   if (x=xx) and (y=yy) and (k=0) then k:=i;
 if k=0 then
  for i:=1 to max_stars do
   with star[i] do
    if (abs(x-xx)<=1) and (abs(y-yy)<=1) and (k=0) then k:=i;
 find_star:=k;
end;

function count_bases(p:integer):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (base) then inc(k);
 count_bases:=k;
end;

function random_base(p:integer):integer;
var
 i,k,l,j:integer;
begin
 l:=random(count_bases(p))+1;
 k:=0; j:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (base) then begin inc(k); if k=l then j:=i; end;
 random_base:=j;
end;

function weakest_base(p:integer):integer;
var
 i,j,k,l,m:integer;
begin
 k:=0; l:=10000;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (base) then
    begin
     m:=0;
     for j:=1 to max_ships do
      if (player[p].ship[j].a) and (not player[p].ship[j].base) and
         (diff(x,player[p].ship[j].x)<=action_range) and
         (diff(y,player[p].ship[j].y)<=action_range) then
         m:=m+weap_val(player[p].ship[j].pod);
     if (m<l) or ((m<l+6) and (random(2)=0)) then begin l:=m; k:=i; end;
    end;
 weakest_base:=k;
end;

function find_a_base(xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0;
 for j:=1 to num_players do
  for i:=1 to max_ships do
   with player[j].ship[i] do
    if (a) and (base) and (abs(x-xx)<=2) and (abs(y-yy)<=2) then k:=j;
 find_a_base:=k;
end;

function find_a_base2(p,xx,yy,range,range2:integer):integer;
var
 i,j,k,l,r:integer;
begin
 k:=0;
 for j:=1 to num_players do
  for i:=1 to max_ships do
   with player[j].ship[i] do
    begin
     if j=p then r:=range else r:=range2;
     if (a) and (base) and (abs(x-xx)<=r) and (abs(y-yy)<=r) then k:=j;
    end;
 find_a_base2:=k;
end;

procedure find_enemy_base(p,xx,yy,range,tp,tn:integer);
var
 i,j,k,l,d,pp:integer;
begin
 k:=0; l:=5000; pp:=0;
 for j:=1 to num_players do
  if j<>p then
   for i:=1 to max_ships do
    with player[j].ship[i] do
     begin
      d:=diff(x,xx); if diff(y,yy)>d then d:=diff(y,yy);
      if (a) and (base) and (d<l) and (d<=range) then
         begin pp:=j; k:=i; l:=d; end;
     end;
 tp:=pp; tn:=k;
end;

function nearest_base(p,xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0; l:=10000;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (base) and (abs(x-xx)<l) and (abs(y-yy)<l) then
    begin
     l:=abs(x-xx); if abs(y-yy)>l then l:=abs(y-yy); k:=i;
    end;
 nearest_base:=k;
end;

procedure load_names;
var
 f:text;
 s:string;
 i:integer;
 p:pointer;
begin
 num_names:=0;
 assign(f,main_filename+'.NAM');
 reset(f);
 while (not eof(f)) and (num_names<max_names) do
  begin
   readln(f,s); s:=btrim(s);
   if (s[1]<>';') and (s<>'') then
    begin
     inc(num_names);
     getmem(p,length(s)+1);
     name[num_names]:=p;
     for i:=0 to length(s) do
      name[num_names]^[i]:=s[i];
    end;
  end;
 close(f);
 writeln('Names Loaded.');
end;

function randname:string;
var
 i,j,k:integer;
 s:string;
begin
 s:='This Ship';
 i:=random(num_names)+1;
 s:=name[i]^;
 randname:='ISS '+s;
end;

function count_pods(pod:string; p:char):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to length(pod) do
  if pod[i]=p then inc(k);
 count_pods:=k;
end;

procedure sound_effect(n:integer);
var                   {1 = explosion (hit)}
 i,j,k,l:integer;     {2 = Shot fire}
 w:word;              {3 = bomb, mine, and torp explosion}
begin                 {4 = jump sound}
 case n of
  1:begin
     for i:=1 to 10 do
      begin
       w:=memw[0:$46C];
       repeat
        if not sound_off then sound(random(i*200)+100);
        if fast_combat then
         begin
          if sound_off then delay(2) else delay(5);
         end;
       until (w<>memw[0:$46C]) or fast_combat;
      end;
     nosound;
    end;
  2:begin
     for i:=50 downto 5 do
      begin
       if not sound_off then sound(i*10);
       if fast_combat then delay(1) else delay(5);
      end;
     nosound;
     if fast_combat then
      begin
        if sound_off then delay(10) else delay(20);
      end else delay(40);
    end;
  3:begin
     for i:=1 to 10 do
      begin
       w:=memw[0:$46C];
       repeat
        if not sound_off then
          case random(4) of
           0:sound(i*80);
           1:sound(i*40);
           2:sound(random(i*200)+100);
           3:sound(random(i*100)+50);
          end;
        if fast_combat then
         begin
          if sound_off then delay(2) else delay(5);
         end;
       until (w<>memw[0:$46C]) or fast_combat;
      end;
     nosound;
    end;
  4:begin
     for i:=50 downto 5 do
      begin
       if not sound_off then sound(i*10);
       delay(4);
       if not sound_off then sound((60-i)*20);
       delay(4);
      end;
     nosound;
     if fast_combat then
      begin
        if sound_off then delay(10) else delay(20);
      end else delay(40);
    end;
 end;
end;

function all_computers:boolean;
var
 i,j,k,l:integer;
begin
 k:=0; l:=0; j:=0;
 for i:=1 to num_players do
  begin
   l:=0;
   for k:=1 to max_ships do
    if player[i].ship[k].a then inc(l);
   if (not player[i].comp) and (l>0) then inc(j);
  end;
 if j>0 then all_computers:=false else all_computers:=true;
end;


function count_cargo_ships(p:integer):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  if (not player[p].ship[i].base) and (player[p].ship[i].a) and
     (count_pods(player[p].ship[i].pod,'C')>0) then inc(k);
 count_cargo_ships:=k;
end;

function count_weapon_ships(p:integer):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  if (player[p].ship[i].a) and (not player[p].ship[i].base) and
     ((count_pods(player[p].ship[i].pod,'M')>0) or
      (count_pods(player[p].ship[i].pod,'L')>0) or
      (count_pods(player[p].ship[i].pod,'P')>0) or
      (count_pods(player[p].ship[i].pod,'W')>0)) and
      (count_pods(player[p].ship[i].pod,'C')=0) then inc(k);
 count_weapon_ships:=k;
end;

function count_ships(p:integer):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  if player[p].ship[i].a then inc(k);
 count_ships:=k;
end;


function ship_class(ship:ship_rec):string;
var
 i,j,k,l,m:integer;
 s:string;
begin
 s:='StarShip';
 j:=0; k:=0; l:=0; m:=0;
 for i:=1 to length(ship.pod) do
  case ship.pod[i] of
   'S':inc(j);
   'L','M','P':inc(k);
   'C':inc(l);
   'B':inc(m);
  end;
 if l>k then
  case l of
   1:s:='Lt. Transport';
   2:s:='Cargo Transport';
   3:s:='Lt. Freighter';
   4:s:='Med. Freighter';
   5:s:='Freighter';
   6:s:='Hvy Freighter';
  end;
 if k>l then
  case k of
   1:s:='Ordinance Ship';
   2:s:='Patrol Vessel';
   3:s:='Frigate';
   4:s:='Destroyer';
   5:s:='Hvy Cruiser';
   6:s:='Battleship';
   7:s:='Hvy Battleship';
   8,9:s:='Weapons Platform';
  end;
 if (l=k) and (l>0) then
  case l of
   1:s:='Lt. Freighter Escort';
   2:s:='Hvy Freighter Escort';
   3,4:s:='MultiPurpose Cruiser';
  end;
 if (l=0) and (k=0) and (j>=0) then
  case j of
   0:s:='Small Scout';
   1:s:='Fast Scout';
   2:s:='Scout';
   3:s:='Large Scout';
   4:s:='Explorer';
   5:s:='Survey Vessel';
   6:s:='Science Vessel';
  end;
 if m=length(ship.pod) then s:='Kamikaze';
 if length(ship.pod)=0 then s:='Yacht';
 ship_class:=s;
end;

function player_color(p:integer):integer;
var
 i:integer;
begin
 i:=0;
 case p of
  1:i:=10;
  2:i:=12;
  3:i:=13;
  4:i:=11;
 end;
 player_color:=i;
end;

function max_armor(s:string):integer;
var
 i,k:integer;
begin
 k:=0;
 for i:=1 to length(s) do
  if s[i]='A' then inc(k);
 k:=6+k*4+length(s)*3;
 max_armor:=k;
end;


function ship_cost(ship:ship_rec):longint;
var
 i,j,k:longint;
begin
 k:=5000;
 if ship.booster then k:=k+7000;
 if ship.engine=2 then k:=k+3000;
 if ship.robot then k:=k+5000;
 for i:=1 to length(ship.pod) do
  case ship.pod[i] of
   'C':k:=k+500;
   'L':k:=k+1000;
   'M':k:=k+1000;
   'A':k:=k+800;
   'S':k:=k+1200;
   'I':k:=k+6000;
   'P':k:=k+2500;
   'B':k:=k+2500;
   'T':k:=k+2000;
   'E':k:=k+1200;
   'F':k:=k+2300;
   'X':k:=k+7000;
   'O':k:=k+4000;
   'W':k:=k+3000;
   'J':k:=k+2000;
   'K':k:=k+3000;
   'V':k:=k+1500;
  end;
 ship_cost:=k;
end;


function weap_val(s:string):integer;
var
 i,k,j:integer;
 r:real;
begin
 r:=0; j:=count_pods(s,'T');
 for i:=1 to length(s) do
  case s[i] of
   'L':r:=r+(2*(6+j)/12);
   'M':r:=r+(3*(4+j)/12);
   'P':r:=r+(4*(6+j)/12);
  end;
 weap_val:=round(r);
end;


function pick_name(p,n:integer):string;
var
 s:string;
 i,j,k,l:integer;
begin
 s:=randname;
 k:=0;
 with player[p] do
  for i:=1 to max_ships do
   if (i<>n) and (ship[i].name=s) then k:=i;
 if k>0 then
  begin
   j:=1;
   repeat
    k:=0; inc(j);
    with player[p] do
     for i:=1 to max_ships do
      if (i<>n) and (ship[i].name=s+' '+cstr(j)) then k:=i;
   until k=0;
   s:=s+' '+cstr(j);
  end;
 pick_name:=s;
end;

function pod_weight(ship:ship_rec; carg:boolean):integer;
var
 i,k:integer;
begin
 k:=0;
 with ship do
 for i:=1 to length(pod) do
  case pod[i] of
   'C':k:=k+300;
   'L','M','P':k:=k+600;
   'A':k:=k+250;
   'S':k:=k+200;
   'I':k:=k+1000;
   'B':k:=k+1250;
   'T':k:=k+250;
   'E':k:=k+250;
   'F':k:=k+500;
   'X':k:=k+1500;
   'O':k:=k+1000;
   'W':k:=k+650;
   'J':k:=k+850;
   'K':k:=k+350;
   'V':k:=k+500;
  end;
 if carg then
  begin
   k:=k+ship.cargo+(ship.mines*mine_mass)+(ship.torpedoes*torp_mass);
  end;
 pod_weight:=k;
end;

function max_cargo(ship:ship_rec):integer;
begin
 max_cargo:=count_pods(ship.pod,'C')*400;
end;

function max_mines(ship:ship_rec):integer;
begin
 max_mines:=count_pods(ship.pod,'W')*10;
end;

function max_torps(ship:ship_rec):integer;
begin
 max_torps:=count_pods(ship.pod,'O')*3+count_pods(ship.pod,'K')*5;
end;

function the_weight(ship:ship_rec; t:integer):integer;
var
 i,j,k,l:integer;
begin
 case t of
  1:l:=pod_weight(ship,true);
  2:l:=pod_weight(ship,false);
  3:l:=pod_weight(ship,false)+max_cargo(ship)+(max_mines(ship)*mine_mass)+(max_torps(ship)*torp_mass);
 end;
 j:=0;
 if ship.booster then j:=j+400;
 if ship.robot then j:=j+100;
 k:=2100+j+((ship.engine-1)*500)+l;
 the_weight:=k;
end;

function ship_weight(ship:ship_rec):integer;
begin
 ship_weight:=the_weight(ship,1);
end;

function ship_weighte(ship:ship_rec):integer;
begin
 ship_weighte:=the_weight(ship,2);
end;

function ship_weightf(ship:ship_rec):integer;
begin
 ship_weightf:=the_weight(ship,3);
end;

function the_speed(ship:ship_rec; t:integer):integer;
var
 i,j,k:integer;
begin
 case t of
  1:j:=pod_weight(ship,true);
  2:j:=pod_weight(ship,false);
  3:j:=pod_weight(ship,false)+max_cargo(ship)+(max_mines(ship)*mine_mass)+(max_torps(ship)*torp_mass);
 end;
 if ship.booster then j:=j-1000;
 j:=j-(count_pods(ship.pod,'F')*750);
 k:=18;
 if ship.engine=2 then k:=k+2;
 if ship.robot then k:=k+1;
 i:=k-(j div 250);
 if (i<1) or (ship.base) then i:=1;
 if (ship.base) and (i<gamesys.base_speed) then i:=gamesys.base_speed;
 if (ship.base) and (not gamesys.base_mobile) then i:=0;
 the_speed:=i;
end;

function ship_speed(ship:ship_rec):integer;
begin
 ship_speed:=the_speed(ship,1);
end;

function ship_speede(ship:ship_rec):integer;
begin
 ship_speede:=the_speed(ship,2);
end;

function ship_speedf(ship:ship_rec):integer;
begin
 ship_speedf:=the_speed(ship,3);
end;


function scan_range(ship:ship_rec):integer;
var
 i,j,k,l:integer;
begin
 with ship do
  begin
    k:=0;
    for j:=1 to length(pod) do if pod[j]='S' then inc(k);
    k:=k*4+4;
    scan_range:=k;
  end;
end;


function slowest_speed(p,n,f:integer):integer;
var
 i,j,k:integer;
begin
 j:=5000; k:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (fnum=f) and (ship_speed(player[p].ship[i])<j) then
    begin j:=ship_speed(player[p].ship[i]); k:=i; end;
 if k>0 then slowest_speed:=j else slowest_speed:=ship_speed(player[p].ship[n]);
end;

function find_leader(p,f:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (leader) and (fnum=f) and (k=0) then k:=i;
 find_leader:=k;
end;

function Cbool(b:boolean):string;
begin
 if b then cbool:='Yes' else cbool:='No';
end;

function team_value(p:integer):longint;
var
 i,j,k,l:longint;
begin
 k:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if a and (not base) then
    begin
     k:=k+cargo+ship_cost(player[p].ship[i]);
     j:=0; for l:=1 to length(pod) do
              if pod[l] in ['a'..'z'] then j:=j+500;
     if (hp<max_armor(pod)) or (j>0) then j:=1500;
     k:=k-j;
    end
   else if (a) then
    begin
     k:=k-(500*(gamesys.base_damage-hp));
    end;
 k:=k+player[p].money;
 team_value:=k;
end;



function add_ship(p,n:integer; s:string; e:byte; bb,rob:boolean):integer;
var
 i,j,k,l:integer;
begin
 k:=0; i:=0;
 while (i<max_ships) and (k=0) do
  begin
   inc(i);
   if not player[p].ship[i].a then k:=i;
  end;
 if k>0 then
  with player[p].ship[k] do
   begin
    name:='Ship #'+cstr(k); hp:=max_armor(s); pod:=btrim(s); a:=true;
    x:=player[p].ship[n].x+random(action_range*2+1)-action_range;
    y:=player[p].ship[n].y+random(action_range*2+1)-action_range;
    if (x<-59) then x:=-59;
    if (x> 59) then x:=59;
    if (y<-59) then y:=-59;
    if (y> 59) then y:=59;
    tx:=player[p].ship[n].x;
    ty:=player[p].ship[n].y; {tx:=0; ty:=0;}
    rx:=tx; ry:=ty; ox:=0; oy:=0;
    torpedoes:=max_torps(player[p].ship[k]);
    mines:=max_mines(player[p].ship[k]);
    engine:=e; booster:=bb; cargo:=0; auto:=false; robot:=rob;
    anystar:=true; anybase:=true; cloak_active:=false;
    mining:=false; torping:=false; fnum:=0; leader:=false;
    name:=pick_name(p,k); base:=false; repaired:=false;
    if count_pods(pod,'C')>0 then auto:=true;
    for i:=1 to max_pods do pcount[i]:=0;
   end
 else
  begin sound(100); delay(55); nosound; end;
 add_ship:=k;
end;

procedure game_init;
var
 i,j,k,l:integer;
begin
 gamesys.see_all:=false;
 for i:=1 to max_players do
  player[i].team:=i;
 for i:=1 to max_players do
  for k:=1 to 10 do
   begin
    gamesys.ship[i,k].pod:='';
    gamesys.ship[i,k].booster:=false;
    gamesys.ship[i,k].robot:=false;
    gamesys.ship[i,k].engine:=1;
   end;
 game_type:=0;
 with gamesys do
  case game_type of
   0:begin
      name:='Capture the Flag'; start_money:=15000;
      base_damage:=60; bomb_base:=true; shoot_base:=true;
      end_type:=1; num_players:=2; num_bases:=3;
      base_fire:=false; base_mobile:=true; base_pod:='SS';
      base_distribution:=0; base_speed:=2;
      for i:=1 to max_players do
       begin
        ship[i,1].pod:='CC';
        ship[i,2].pod:='LC';
        ship[i,3].pod:='LM';
        ship[i,4].pod:='SA';
        ship[i,5].pod:='IS';
        ship[i,6].pod:='BB';
        ship[i,7].pod:='VS';
       end;
     end;
  end;
end;


procedure main_init;
var
 i,j,k,l:integer;
begin
 cycle:=0;
 num_players:=2;
 sound_off:=false;
 fast_combat:=false;
 for i:=1 to max_players do
  with player[i] do
   begin
    if i=1 then comp:=false else comp:=true;
    {comp:=false;}
    ratio:=0.7;
    mode:=0;
    team:=i;
   end;
 game_init;
end;

procedure the_init;
var
 i,j,k,l,n,p,xxx,m:integer;
 ok:boolean;
begin
 playnum:=1; flushkey;
 num_players:=gamesys.num_players;
 cycle:=0; flushkey;
 repeat {until not keypressed}
 for i:=1 to max_players do
  begin
   for k:=1 to max_ships do
    player[i].ship[k].a:=false;
   for k:=1 to max_weaps do
    player[i].weap[k].typ:=0;
    {with player[i].weap[k] do
     begin typ:=random(3); x:=random(118)-59; y:=random(118)-59; end;}
  end;
 for p:=1 to max_players do
 repeat {until satisfactory arrangement}
  for i:=1 to max_ships do
   player[p].ship[i].a:=false;
  i:=p;
  for k:=1 to gamesys.num_bases do
  with player[i].ship[k] do
   begin
    repeat   {until successful placement in 500 cycles or less}
    xxx:=0;
    case gamesys.base_distribution of
     0:if k=1 then
        begin y:=random(21)-10; x:=random(21)-10;
         case i of
          1:x:=x-40;
          2:x:=x+40;
          3:y:=y-40;
          4:y:=y+40;
         end;
        end
       else
        case i of
         1:begin x:=-45-random(10); y:=random(81)-40; end;
         2:begin x:= 45+random(10); y:=random(81)-40; end;
         3:begin y:=-45-random(10); x:=random(81)-40; end;
         4:begin y:= 45+random(10); x:=random(81)-40; end;
        end;
     1:begin
        repeat
         x:=random(101)-50;
         y:=random(101)-50;
         inc(xxx);
        until (find_a_base2(i,x,y,16,32)=0) or (xxx>500) or keypressed;
       end;
     2:begin
        if k=1 then
         repeat
          x:=random(81)-40;
          y:=random(81)-40;
          inc(xxx);
         until (find_a_base2(i,x,y,16,32)=0) or (xxx>500) or keypressed
        else
         repeat
          x:=random(45)-22+player[i].ship[1].x;
          y:=random(45)-22+player[i].ship[1].y;
          inc(xxx);
         until ((find_a_base2(i,x,y,16,32)=0) and (abs(x)<59) and (abs(y)<59))
               or (xxx>500) or keypressed;
       end;
    end;
    until (xxx<=500);
    a:=true; hp:=gamesys.base_damage;
    tx:=-500; if gamesys.base_mobile then tx:=x;
    ty:=y; pod:=gamesys.base_pod; base:=true; cargo:=0;
    name:='StarBase #'+cstr(k); robot:=false;
    if gamesys.base_fire then pod:=pod+'MLP';
    auto:=false; repaired:=false; cloak_active:=false;
    mining:=false; torping:=false; torpedoes:=0; mines:=0;
    fnum:=0; leader:=false;
   end;
  j:=0; k:=0; l:=p; m:=0;
  if (gamesys.num_players=2) and (gamesys.base_distribution in [1,2]) then
   begin
    if ((player[p].ship[1].x<0) and (player[3-p].ship[1].x<0)) or
       ((player[p].ship[1].x>=0) and (player[3-p].ship[1].x>=0)) or
       ((player[p].ship[1].y>=0) and (player[3-p].ship[1].y>=0)) or
       ((player[p].ship[1].y<0) and (player[3-p].ship[1].y<0)) then m:=1;
   end;
  if l<=2 then
     begin
      for i:=2 to gamesys.num_bases do
       begin
        if player[l].ship[i].y<player[l].ship[1].y then inc(j);
        if player[l].ship[i].y>player[l].ship[1].y then inc(k);
       end;
     end
    else
     begin
      for i:=2 to gamesys.num_bases do
       begin
        if player[l].ship[i].x<player[l].ship[1].x then inc(j);
        if player[l].ship[i].x>player[l].ship[1].x then inc(k);
       end;
     end;
 until (((j>0) and (k>0)) or (gamesys.num_bases<3)) or
         ((gamesys.base_distribution<>0) and (m=0)) or keypressed;
 until not keypressed;
 flushkey;
 for i:=1 to max_players do
  with player[i] do
   begin
    money:=gamesys.start_money;
    tactic:=random(max_tactics)+1;
    cships:=random(4)+7;
    name:='';
    grid:=false; grid2:=false;
    for k:=1 to 10 do
     if gamesys.ship[i,k].pod<>'' then
       add_ship(i,1,ucase(gamesys.ship[i,k].pod),gamesys.ship[i,k].engine,
                    gamesys.ship[i,k].booster,gamesys.ship[i,k].robot);
   end;
 for i:=1 to max_players do
  begin
   repeat
    j:=((random(3)-1)*7);
    k:=((random(3)-1)*7);
   until (j<>0) or (k<>0);
   j:=j+(random(3)-1); k:=k+(random(3)-1);
   star[i].x:=player[i].ship[1].x+j;
   star[i].y:=player[i].ship[1].y+k;
   star[i].supply:=50000;
  end;
 for i:=max_players+1 to max_stars do
  with star[i] do
   begin
    repeat
     j:=0; l:=12;
     case i mod 9 of
      0:begin x:=-20-random(40); y:=-20-random(40); end;
      1:begin x:=random(41)-20;  y:=-20-random(40); end;
      2:begin x:= 20+random(40); y:=-20-random(40); end;
      3:begin x:=-20-random(40); y:=random(41)-20;  end;
      4:begin x:=random(41)-20;  y:=random(41)-20;  end;
      5:begin x:= 20+random(40); y:=random(41)-20;  end;
      6:begin x:=-20-random(40); y:= 20+random(40); end;
      7:begin x:=random(41)-20;  y:= 20+random(40); end;
      8:begin x:= 20+random(40); y:= 20+random(40); end;
     end;
     for k:=1 to max_players do
      if (abs(x-player[k].ship[1].x)<=l) and (abs(y-player[k].ship[1].y)<=l)
         then j:=k;
    until j=0;
    supply:=random(50000)+30000;
   end;
 for i:=1 to max_holes do
  with hole[i] do
   begin
    visible:=false;
    travelled:=false;
    repeat
     ok:=true;
     x:=random(119)-59;
     y:=random(119)-59;
     for k:=1 to max_stars do
      if (star[k].x=x) and (star[k].y=y) then ok:=false;
     for k:=1 to i do
      if (hole[k].x=x) and (hole[k].y=y) and (i<>k) then ok:=false;
     l:=20;
     for k:=1 to max_players do
      if (abs(x-player[k].ship[1].x)<=l) and (abs(y-player[k].ship[1].y)<=l)
         then ok:=false;
    until ok;
   end;
end;


procedure finish_it(start:integer; all_the_way:boolean);
var
 y:integer;
begin
 setfillstyle(1,0);
 if all_the_way then y:=320 else y:=306;
 bar(374,start,634,y);
end;

procedure draw_ship_stats(p,n:integer);
var
 s:string[20];
begin
 with player[p] do
  begin
   setcolor(player_color(p));
   print(010,'Player #'+cstr(p)+' ship #'+cstr(n));
   print(020,'Name:  '+ship[n].name);
   if ship[n].robot then s:='Robot' else s:='Human';
   print(030,'Crew:  '+s);
   print(040,'Class: '+ship_class(ship[n]));
   print(050,'Pods:  '+ship[n].pod);
   print(060,'Cargo: '+cstr(ship[n].cargo)+' Tons');
   setcolor(player_color(p)-8);
   print(070,'Money: '+cstr(money)+' Credits');
   print(080,'');
   setcolor(14);
   print(090,'Speed:    '+cstr(ship_speed(ship[n]))+' Ly/Week');
   setcolor(2);
   print(100,'Speed[E]: '+cstr(ship_speede(ship[n]))+' Ly/Week');
   print(110,'Speed[F]: '+cstr(ship_speedf(ship[n]))+' Ly/Week');
   setcolor(14);
   print(120,'Mass:     '+cstr(ship_weight(ship[n]))+' Tons');
   setcolor(2);
   print(130,'Mass[E]:  '+cstr(ship_weighte(ship[n]))+' Tons');
   print(140,'Mass[F]:  '+cstr(ship_weightf(ship[n]))+' Tons');
   setcolor(14);
   print(150,'Armor:    '+cstr(ship[n].hp)+'/'+cstr(max_armor(ship[n].pod)));
   print(160,'Weap-Val: '+cstr(weap_val(ship[n].pod)));
   print(170,'Scan:     '+cstr(scan_range(ship[n])));
   print(180,'Value:    '+cstr(ship_cost(ship[n]))+' Credits');
   print(190,'Location: '+cstr(ship[n].x)+','+cstr(ship[n].y));
   print(200,'Dest:     '+cstr(ship[n].tx)+','+cstr(ship[n].ty));
   print(210,'');
   print(215,'AutoMine: '+cbool(ship[n].auto));
   print(225,'AnyStar:  '+cbool(ship[n].anystar));
   print(235,'AnyBase:  '+cbool(ship[n].anybase));
   print(245,'');
   print(250,'Cloaked:         '+cbool(ship[n].cloak_active));
   print(260,'Mine-Laying:     '+addrear(cbool(ship[n].mining),4)
                               +'Mines: '+cstr(ship[n].mines));
   print(270,'Torpedo-Firing:  '+addrear(cbool(ship[n].torping),4)
                               +'Torps: '+cstr(ship[n].torpedoes));
   print(280,'');
   print(285,'Flotilla-Leader: '+cbool(ship[n].leader));
   if ship[n].fnum>0 then s:=cstr(ship[n].fnum) else s:='None.';
   print(295,'Flotilla:        '+s);
   finish_it(305,true);
  end;
end;

procedure draw_base_stats(p,n:integer; tship:ship_rec);
var
 range:integer;
begin
 with player[p].ship[n] do
  begin
   setcolor(player_color(p));
   print(010,'Player #'+cstr(p)+' '+name+': '+cstr(hp));
   print(020,'Score: '+cstr(team_value(p)));
   print(030,'Money: '+cstr(player[p].money));
   print(040,'');
  end;
 with tship do
  begin
   print(050,'Ship under construction:');
   setcolor(7);
   print(060,'Class:  '+ship_class(tship));
   setcolor(14);
   print(070,'Speed (empty): '+cstr(ship_speede(tship))+' Ly/Week');
   print(080,'Speed (full):  '+cstr(ship_speedf(tship))+' Ly/Week');
   print(090,'Mass (empty):  '+cstr(ship_weighte(tship))+' Tons');
   print(100,'Mass (full):   '+cstr(ship_weightf(tship))+' Tons');
   print(110,'Weapon Rating: '+cstr(weap_val(pod))+' Avg pts/turn');
   print(120,'');
   print(130,'Cost:          '+cstr(ship_cost(tship))+' Credits');
   print(140,'Max-Cargo:     '+cstr(max_cargo(tship))+' Tons');
   print(150,'Armor/Shield:  '+cstr(max_armor(pod)));
   print(160,'Scan Range:    '+cstr(scan_range(tship)));
   print(170,'');
   if count_pods(pod,'B')>0 then range:=(count_pods(pod,'B') div 2)+1 else range:=0;
   print(180,'Blast Radius:  '+cstr(range));
   print(190,'Avg Blast:     '+cstr(round(count_pods(pod,'B')*4.5)));
   {finish_it(200);}
  end;
end;


procedure draw_guy(xx,yy,mapx,mapy,p,n,mapmode:integer; flashy:boolean);
var
 k,mx,my:integer;
begin
 mx:=mapx-12; my:=mapy-12;
 with player[p].ship[n] do
  case mapmode of
   0:begin
      if (a) and (check_view(playnum,p,n)) then
       begin
        if base then begin k:=14; setcolor(player_color(p)); end
                else begin k:=player_color(p); setcolor(k-8); end;
        if flashy then begin setcolor(6); k:=6; end;
        circle(xx+(x+59)*3+1,yy+(y+59)*3+1,1);
        putpixel(xx+(x+59)*3+1,yy+(y+59)*3+1,k);
       end;
     end;
   1:begin
      if (a) and (abs(mapx-x)<=12) and (abs(mapy-y)<=12) and
         (check_view(playnum,p,n)) then
       begin
        if base then
         putimage(xx+(x-mx)*14+2,yy+(y-my)*14+2,base_img[p]^,orput)
        else
         putimage(xx+(x-mx)*14-1,yy+(y-my)*14+6,ship_img[p,round(length(pod)/2)]^,orput);
       end;
     end;
  end;
end;

procedure xorimg(x,y:integer; p1:pointer; col,size:integer);
begin
 if (x>=0) and (y>=0) then
  putimage(x,y,p1^,xorput)
 else
  begin
   setcolor(col);
   setwritemode(xorput);
   rectangle(x,y,x+size,y+size);
   line(x,y,x+size,y+size);
   line(x+size,y,x,y+size);
   setwritemode(copyput);
  end;
end;

procedure put_crosshair(mapx,mapy,p,n,mapmode:integer);
var
 mx,my:integer;
begin
 mx:=mapx-12; my:=mapy-12;
 with player[p].ship[n] do
   case mapmode of
    0:if (not base) or (gamesys.base_mobile) then begin
       {if (count_pods(pod,'C')=0) then auto:=false;}
       if (count_pods(pod,'O')>0) then
          xorimg((ox+59)*3-4,(oy+59)*3-4,crosshair4,4,20);
       if not auto then
          xorimg((tx+59)*3-4,(ty+59)*3-4,crosshair2,10,20)
        else
         begin
          if (not anystar) and (count_pods(pod,'C')>0) then
           begin
            xorimg((tx+59)*3-4,(ty+59)*3-4,crosshair,10,20);
            xorimg((tx+59)*3-4,(ty+59)*3-4,crosshair2,10,20);
           end;
          if (not anybase) and (count_pods(pod,'C')>0) then
            xorimg((rx+59)*3-4,(ry+59)*3-4,crosshair3,10,20);
         end;
      end;
    1:begin
       {if (count_pods(pod,'C')=0) then auto:=false;}
       if (count_pods(pod,'O')>0) then
          xorimg((ox-mx)*14+2,(oy-my)*14+2,crosshair4,4,20);
       if (abs(x-mapx)<=12) and (abs(y-mapy)<=12) then
         putimage((x-mx)*14+2,(y-my)*14+2,crosshair^,xorput);
       if (not base) or (gamesys.base_mobile) then
        begin
         if not auto then
           begin
            if (abs(tx-mapx)<=12) and (abs(ty-mapy)<=12) then
             putimage((tx-mx)*14+2,(ty-my)*14+2,crosshair2^,xorput);
           end
          else
           begin
            if (not anystar) and (count_pods(pod,'C')>0) and
               (abs(tx-mapx)<=12) and (abs(ty-mapy)<=12) then
             begin
              putimage((tx-mx)*14+2,(ty-my)*14+2,crosshair^,xorput);
              putimage((tx-mx)*14+2,(ty-my)*14+2,crosshair2^,xorput);
             end;
            if (not anybase) and (count_pods(pod,'C')>0) and
               (abs(rx-mapx)<=12) and (abs(ry-mapy)<=12) then
              putimage((rx-mx)*14+2,(ry-my)*14+2,crosshair3^,xorput);
           end;
        end;
      end;
   end;
end;


begin
 writeln('Loading...');
 load_names;
end.


