{$M 16384,70000,110000}
Program Stellar_Conquest_III;

{
Stellar Conquest III, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there is code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

If you do create a derivative work, please drop me a note at
necrobones@necrobones.com and let me know! I'd love to hear about it!

Good luck! :)
}

uses stuff, crt, graph, egavga, filelib, myfile,
    bobmouse, stelc3u{, mice};

const
 max_buttons  =100;
 max_istars   =50;
 max_tmode    =2;
 fire_delay   =300;

type
 istar_type = record
               x,y,xv,col:integer;
               lastdrawn:boolean;
              end;
 button_rec = record
               x,y:integer;
               a,pressed:boolean;
               name:string[12];
               size:integer;
               key:char;
              end;
 target_rec = record
               tp,tn:integer;
              end;
 button_array=array[1..max_buttons] of button_rec;

var
 istar:array[1..max_istars] of istar_type;
 target:array[1..40] of target_rec;
 num_targets:integer;
 button,buttonbak:button_array;
 palette_rotation:byte;
 mouse_hidden:boolean;


procedure hide_mouse;
begin
 if not mouse_hidden then hidemouse;
 mouse_hidden:=true;
end;

procedure show_mouse;
begin
 if mouse_hidden then showmouse;
 mouse_hidden:=false;
end;


{$I io.inc}

procedure setscreen(draw_whole_thing,starbase:boolean);
var
 i,j,k,l:integer;
begin
 hide_mouse;
 kill_buttons;
 if draw_whole_thing then
  begin
   setfillstyle(1,0);
   bar(0,0,640,480);
   setfillstyle(1,7);
   bar(0,0,640,5);
   bar(0,0,5,480);
   bar(0,475,640,480);
   bar(635,0,640,480);
   setcolor(15);
   line(0,0,640,0);
   line(0,0,0,480);
   setcolor(8);
   line(0,479,640,479);
   line(639,0,639,480);
   setcolor(15);
   rectangle(5,5,635,475);
   setcolor(8);
   rectangle(4,4,634,474);
   setfillstyle(1,0);
   bar(5,5,634,474);
  end;
 setcolor(7);
 v_bar(367,4,367,475,1);
 h_bar(4,366,365,366,0);
 h_bar(4,395,365,395,1);
 h_bar(4,418,365,418,3);
 h_bar(369,418,635,418,3);
 h_bar(369,395,635,395,1);
 setfillstyle(1,0);
 bar(371,307,634,390);
 {bar(5,407,365,407);}
 if starbase then
  begin
   {for i:=0 to 13 do
    add_button((i mod 2)*65+405,(i div 2)*14+214,30,chr(180+i),chr(180+i));}
   for i:=0 to 23 do
    add_button((i mod 4)*65+405,(i div 4)*14+312,30,chr(128+i),chr(128+i));
   draw_base;
   {change_button(chr(180+00),'',#0);
   change_button(chr(180+01),'',#0);
   change_button(chr(180+02),'',#0);
   change_button(chr(180+03),'',#0);
   change_button(chr(180+04),'',#0);
   change_button(chr(180+05),'',#0);
   change_button(chr(180+06),'',#0);
   change_button(chr(180+07),'',#0);
   change_button(chr(180+08),'',#0);
   change_button(chr(180+09),'',#0);
   change_button(chr(180+10),'',#0);
   change_button(chr(180+11),'',#0);
   change_button(chr(180+12),'',#0);
   change_button(chr(180+13),'',#0);}
   change_button(chr(128+00),'Plasma','P');
   change_button(chr(128+01),'Cargo','C');
   change_button(chr(128+02),'Bomb','B');
   change_button(chr(128+03),'Targetr','T');
   change_button(chr(128+04),'Laser','L');
   change_button(chr(128+05),'Sensor','S');
   change_button(chr(128+06),'Booster','-');
   change_button(chr(128+07),'ECM','E');
   change_button(chr(128+08),'Missile','M');
   change_button(chr(128+09),'Shield','A');
   change_button(chr(128+10),'Engine','=');
   change_button(chr(128+11),'Stealth','I');
   change_button(chr(128+12),'Mines','W');
   change_button(chr(128+13),'Robot','+');
   change_button(chr(128+14),'Thrustr','U');
   change_button(chr(128+15),'Cloak','X');
   change_button(chr(128+16),'Torpedo','O');
   change_button(chr(128+17),'Loader','K');
   change_button(chr(128+18),'Jumper','J');
   change_button(chr(128+19),'V-ATC','V');
   change_button(chr(128+20),'FixBase','F');
   change_button(chr(128+21),'Buy It',#13);
   change_button(chr(128+22),'- Pod',#8);
   change_button(chr(128+23),'No Pods','N');
  end
 else
  begin
   {for i:=0 to 13 do
    add_button((i mod 2)*125+440,(i div 2)*13+306,60,chr(128+i),chr(128+i));}
   for i:=0 to 14 do
    add_button((i mod 3)*88+413,(i div 3)*14+326,42,chr(128+i),chr(128+i));
   change_button(chr(128+00),'F-Leader','-');
   change_button(chr(128+01),'F-Number','=');
   change_button(chr(128+02),'Destruct!','!');
   change_button(chr(128+03),'Repair','R');
   change_button(chr(128+04),'Cloak','C');
   change_button(chr(128+05),'Rename','N');
   change_button(chr(128+06),'AutoMine','A');
   change_button(chr(128+07),'AnyBase','B');
   change_button(chr(128+08),'AnyStar','S');
   change_button(chr(128+09),'Load Torps','O');
   change_button(chr(128+10),'Load Mines','I');
   change_button(chr(128+11),'Get Jumps','U');
   change_button(chr(128+12),'Torpedoes','T');
   change_button(chr(128+13),'MineLayer','M');
   change_button(chr(128+14),'Jump','J');
  end;
 make_button(0*65+405,405,30,'*','Base');
 make_button(1*65+405,405,30,'[','DnShip');
 make_button(2*65+405,405,30,']','UpShip');
 make_button(3*65+405,405,30,'D','EndTurn');
 make_button(029,385,20,'&','Mode');
 make_button(073,385,20,'Z','Zoom');
 make_button(127,385,30,'~','~Redraw');
 make_button(186,385,25,'?','Help?');
 make_button(235,385,20,'^','Corp');
 make_button(279,385,20,'#','Grid');
 make_button(335,373,8,#128,'U');
 make_button(335,385,8,#129,'D');
 make_button(315,379,8,#130,'L');
 make_button(355,379,8,#131,'R');
 setcolor(player_color(playnum));
 outtextxy(6,402,'Jettison:');
 for i:=1 to 9 do
  make_button(i*30+70,405,13,chr(ord('0')+i),chr(ord('0')+i));
 with player[playnum] do
  begin
   setcolor(player_color(playnum));
   print(425,'Corp:  '+name);
   print(435,'Score: '+cstr(team_value(playnum)));
   print(445,'Turn:  '+cstr(cycle));
   print(455,'Mines: '+addrear(cstr(count_weaps(playnum,weap_mine)),5)
                      +'Weapon Ships: '+cstr(count_weapon_ships(playnum)));
   print(465,'Torps: '+addrear(cstr(count_weaps(playnum,weap_torp)),5)
                      +'Cargo Ships:  '+cstr(count_cargo_ships(playnum)));
  end;
 {draw_ship(185,440,'CLMPSAIET',false,true);}
 show_mouse;
end;


procedure init;
var
 s:string;
 i,k:integer;
begin
 writeln;
 writeln(cnotice1);
 writeln(cnotice2);
 writeln;
 writeln('StelCon-3 Operating System Loading...');
 writeln;
 verify_reg;
 if registered then writeln('Registered to: '+regname) else writeln('Unregistered.');
 randomize;
 if RegisterBGIdriver(@EGAVGAProc) < 0 then
    Abort('EGA/VGA');
 if memavail<40000 then
  begin
   writeln('Insufficient memory to load images. Please free up ',40000-memavail,' bytes.');
   halt(1);
  end;
 check_files;
 low_res_intro;
 palette_rotation:=0;
 graphVGA;
 {outtextxy(0,0,cstr(imagesize(0,0,250,150))); readkey;}
 {-------------UNCOMMENT NEXT LINE!!!!!!!!-----------}
 getmem(tempp,imagesize(0,0,250,150));
 load_images;
 game_type:=0;
 sound_off:=false;
 fast_combat:=false;
 playnum:=1;
 loaded_game:=false;
 main_init;
 the_init;
end;



procedure draw_zoom_out;
var
 i,j,k,l,p:integer;
begin
 setviewport(5,5,364,364,true);
 p:=playnum;
 setfillstyle(1,0);
 bar(0,0,360,360);
 with player[p] do
  begin
   if grid2 then
    for i:=0 to 120 do
     for k:=0 to 120 do
      putpixel(i*3,k*3,8);
   setcolor(8);
   for i:=1 to max_ships do
    if (ship[i].a) then
     circle((ship[i].x+59)*3+1,(ship[i].y+59)*3+1,scan_range(ship[i])*3);
   setcolor(8);
   for i:=1 to max_ships do
    if (ship[i].a) and (ship[i].fnum>0) and (not ship[i].leader) then
     begin
      k:=find_leader(p,ship[i].fnum);
      if k>0 then line((ship[i].x+59)*3+1,(ship[i].y+59)*3+1,
                       (ship[k].x+59)*3+1,(ship[k].y+59)*3+1);
     end;
   for i:=1 to max_holes do
    if check_holeview(p,i) then
     begin
      case i of
       1:k:=2;
       2:k:=1;
       3:k:=4;
       4:k:=3;
       5:k:=6;
       6:k:=5;
      end;
      setcolor(1);
      if (i<=6) and (hole[i].travelled) then
       line((hole[i].x+59)*3+1,(hole[i].y+59)*3+1,
            (hole[k].x+59)*3+1,(hole[k].y+59)*3+1);
      setcolor(7);
      circle((hole[i].x+59)*3+1,(hole[i].y+59)*3+1,1);
      putpixel((hole[i].x+59)*3+1,(hole[i].y+59)*3+1,8);
     end;
   setcolor(9);
   for i:=1 to max_stars do
    begin
     circle((star[i].x+59)*3+1,(star[i].y+59)*3+1,1);
     putpixel((star[i].x+59)*3+1,(star[i].y+59)*3+1,11);
    end;
   setcolor(8);
   for j:=1 to num_players do
    with player[j] do
     for i:=1 to max_weaps do
      if (weap[i].typ=weap_torp) and (check_view_weap(p,j,i)) then
       begin
        circle((weap[i].x+59)*3+1,(weap[i].y+59)*3+1,1);
        putpixel((weap[i].x+59)*3+1,(weap[i].y+59)*3+1,player_color(j));
       end;
   for i:=1 to max_ships do
    draw_guy(0,0,0,0,p,i,0,false);
   for k:=1 to num_players do
    if k<>p then
     for i:=1 to max_ships do
      draw_guy(0,0,0,0,k,i,0,false);
  end;
 setviewport(0,0,getmaxx,getmaxy,true);
 setcolor(7);
end;

procedure draw_zoom_in(mapx,mapy:integer);
var
 i,j,k,l,p,mx,my,xx,yy:integer;
begin
 mx:=mapx-12; my:=mapy-12;
 xx:=5; yy:=5;
 setviewport(5,5,364,364,true);
 p:=playnum;
 setfillstyle(1,0);
 bar(0,0,360,360);
 setfillstyle(1,7);
 bar(0,350,360,360);
 bar(350,0,360,360);
 setviewport(5,5,354,354,true);
 for i:=1 to 100 do
  begin
   case random(4) of
    0:k:=8;
    1:k:=7;
    2:k:=15;
    3:k:=1+random(2)*8;
   end;
   putpixel(random(350),random(350),k);
  end;

 setcolor(8);
 with player[playnum] do
  if grid then
   begin
    setwritemode(orput);
    SetLineStyle(UserBitLn,$AAAA,NormWidth);
    for i:=0 to 24 do
     begin
      line(i*14,0,i*14,350);
      line(0,i*14,350,i*14);
     end;
    SetLineStyle(0,0,NormWidth);
    setwritemode(copyput);
   end;
 if player[playnum].grid then setcolor(player_color(p)-8) else setcolor(8);
 for j:=1 to num_players do
  for i:=1 to max_ships do
   with player[j] do
    if (ship[i].a) and (ship[i].base) and
       (abs(mapx-ship[i].x)<=13+action_range) and
       (abs(mapy-ship[i].y)<=13+action_range) and (check_view(p,j,i)) then
     rectangle((ship[i].x-mx)*14-action_range*14,(ship[i].y-my)*14-action_range*14,
               (ship[i].x-mx)*14+action_range*14+14,(ship[i].y-my)*14+action_range*14+14);
 for i:=1 to max_stars do
  if (abs(mapx-star[i].x)<=13+action_range) and
     (abs(mapy-star[i].y)<=13+action_range) then
   rectangle((star[i].x-mx)*14-action_range*14,(star[i].y-my)*14-action_range*14,
             (star[i].x-mx)*14+action_range*14+14,(star[i].y-my)*14+action_range*14+14);
 if player[playnum].grid then setcolor(1) else setcolor(8);
 with player[p] do
  for i:=1 to max_ships do
   if (ship[i].a) and (ship[i].fnum>0) and (not ship[i].leader) then
    begin
     k:=find_leader(p,ship[i].fnum);
     if (k>0) and
        (((abs(mapx-ship[i].x)<=12) and (abs(mapy-ship[i].y)<=12)) or
         ((abs(mapx-ship[k].x)<=12) and (abs(mapy-ship[k].y)<=12))) then
            line((ship[i].x-mx)*14+7,(ship[i].y-my)*14+7,
                 (ship[k].x-mx)*14+7,(ship[k].y-my)*14+7);
    end;
 setviewport(0,0,getmaxx,getmaxy,true);
 mx:=mapx-12; my:=mapy-12;
 for i:=1 to max_holes do
  if (hole[i].x<=mapx+12) and (hole[i].x>=mapx-12) and
     (hole[i].y<=mapy+12) and (hole[i].y>=mapy-12) and
     check_holeview(p,i) then
     putimage(xx+(hole[i].x-mx)*14+2,yy+(hole[i].y-my)*14+2,hole_img^,orput);
 mx:=mapx-12; my:=mapy-12;
 for i:=1 to max_stars do
  if (star[i].x<=mapx+12) and (star[i].x>=mapx-12) and
     (star[i].y<=mapy+12) and (star[i].y>=mapy-12) then
     putimage(xx+(star[i].x-mx)*14-1,yy+(star[i].y-my)*14-1,star_img^,orput);
 for j:=1 to num_players do
  with player[j] do
   for i:=1 to max_weaps do
    if (weap[i].typ>0) and (abs(weap[i].x-mapx)<=12) and
       (abs(weap[i].y-mapy)<=12) and (check_view_weap(p,j,i)) then
     case weap[i].typ of
      weap_mine:putimage(xx+(weap[i].x-mx)*14+6,yy+(weap[i].y-my)*14+6,img_mine^,copyput);
      weap_torp:putimage(xx+(weap[i].x-mx)*14+5,yy+(weap[i].y-my)*14+5,img_torp^,copyput);
     end;
 for i:=1 to max_ships do
  draw_guy(xx,yy,mapx,mapy,p,i,1,false);
 for k:=1 to num_players do
  if k<>p then
   for i:=1 to max_ships do
    draw_guy(xx,yy,mapx,mapy,k,i,1,false);

 setcolor(player_color(p));
 outtextxy(290,6,cstr(mapx)+','+cstr(mapy));
 setcolor(7);
end;

function find_base(p,xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0;
 for i:=1 to max_ships do
  with player[p].ship[i] do
   if (a) and (k=0) and (base) and (x=xx) and (y=yy) then k:=i;
 if k=0 then
  for i:=1 to max_ships do
   with player[p].ship[i] do
    if (a) and (k=0) and (base) and (abs(x-xx)<=1) and (abs(y-yy)<=1) then k:=i;
 find_base:=k;
end;

function find_star(xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
 k:=0;
 for i:=1 to max_stars do
  with star[i] do
   if (k=0) and (x=xx) and (y=yy) then k:=i;
 if k=0 then
  for i:=1 to max_stars do
   with star[i] do
    if (k=0) and (abs(x-xx)<=1) and (abs(y-yy)<=1) then k:=i;
 find_star:=k;
end;

procedure set_course(mx,my,mapx,mapy,p,n,mapmode,tmode:integer);
var
 i,j,k,l,xx,yy:integer;
begin
 case tmode of
  0:begin xx:=player[p].ship[n].tx; yy:=player[p].ship[n].ty; end;
  1:begin xx:=player[p].ship[n].rx; yy:=player[p].ship[n].ry; end;
  2:begin xx:=player[p].ship[n].ox; yy:=player[p].ship[n].oy; end;
 end;
 with player[p].ship[n] do
  case mapmode of
   0:begin mx:=((mx-5) div 3)-59; my:=((my-5) div 3)-59; end;
   1:begin mx:=((mx-5) div 14)+mapx-12; my:=((my-5) div 14)+mapy-12; end;
  end;
 with player[p].ship[n] do
  if (mx>-60) and (mx<60) and (my>-60) and (my<60) and
     ((tmode<>0) or (find_star(mx,my)>0) or (not auto)) and
     ((tmode<>1) or (find_base(p,mx,my)>0)) then
     begin xx:=mx; yy:=my; end;
 with player[p].ship[n] do
 case tmode of
  0:begin tx:=xx; ty:=yy; end;
  1:begin rx:=xx; ry:=yy; end;
  2:begin ox:=xx; oy:=yy; end;
 end;
end;

procedure show_text(s1,s2,s3:string; col,yy:integer);
begin
 setfillstyle(1,1);
 bar(66,130,300,yy);
 setcolor(col);
 settextjustify(centertext,toptext);
 outtextxy(185,130,s1);
 outtextxy(185,140,s2);
 outtextxy(185,150,s3);
 settextjustify(lefttext,toptext);
end;

procedure yell(s:string; p:integer);
var
 xx,yy,mx,my,ys:integer;
 b:boolean;
 c:char;
begin
 if player[p].comp then exit;
 xx:=35; yy:=135; ys:=40;
 buttonbak:=button;
 kill_buttons;
 hide_mouse;
 setwritemode(copyput);
 getimage(xx,yy,xx+299,yy+99,tempp^);
 setfillstyle(1,1);
 bar(xx,yy,xx+299,yy+ys-1);
 h_bar(xx,yy+2,xx+299,yy+2,1);
 h_bar(xx,yy+ys-3,xx+299,yy+ys-3,1);
 v_bar(xx+2,yy+1,xx+2,yy+ys-3,1);
 v_bar(xx+297,yy+1,xx+297,yy+ys-3,1);
 h_bar(xx+4,yy+2,xx+295,yy+2,1);
 h_bar(xx+4,yy+ys-3,xx+295,yy+ys-3,1);
 setcolor(player_color(p));
 settextjustify(centertext,toptext);
 outtextxy(185,150,s);
 settextjustify(lefttext,toptext);
 show_mouse;
 flushkey;
 click_wait(mx,my,b,c);
 hide_mouse;
 button:=buttonbak;
 putimage(xx,yy,tempp^,copyput);
 show_mouse;
end;

procedure open_window(xx,yy,ys:integer);
begin
 getimage(xx,yy,xx+249,yy+149,tempp^);
 setfillstyle(1,1);
 bar(xx,yy,xx+249,yy+ys-1);
 h_bar(xx,yy+2,xx+249,yy+2,1);
 h_bar(xx,yy+ys-3,xx+249,yy+ys-3,1);
 v_bar(xx+2,yy+1,xx+2,yy+ys-3,1);
 v_bar(xx+247,yy+1,xx+247,yy+ys-3,1);
 h_bar(xx+4,yy+2,xx+245,yy+2,1);
 h_bar(xx+4,yy+ys-3,xx+245,yy+ys-3,1);
end;

procedure close_window(xx,yy:integer);
begin
 putimage(xx,yy,tempp^,copyput);
end;

function getpassword(x,y,ml,col:integer; up:boolean):string;
  var
   cp:integer;
   c:char;
   r:real;
   i:string[255];
   size:integer;
  begin
     setcolor(col);
     cp:=0;
     size:=8;
     outtextxy(cp*size+x,0+y,'>');
     cp:=1;
     repeat
      c:=readkey;
      if up then c:=upcase(c);
      if (c>=' ') and (c<chr(127)) then
       if cp<=ml then
        begin
         i[cp]:=c;
         setcolor(col);
         outtextxy(cp*size+x,0+y,c);
         cp:=cp+1;
        end
       else
      else
       case ord(c) of
         8:if cp>1 then
            begin
             c:=chr(8);
             {prompt(#8#32#8);}
             cp:=cp-1;
             setfillstyle(1,1);
             bar(cp*size+x,0+y,cp*size+x+7,0+y+7);
             {setcolor(1);}
             {outtextxy(cp*size+x,0+y,'');}
            end;
        24:while cp<>1 do
            begin
             cp:=cp-1;
             setfillstyle(1,1);
             bar(cp*size+x,0+y,cp*size+x+7,0+y+7);
             {setcolor(1);
             outtextxy(cp*size+x,0+y,'');}
             {prompt(#8#32#8);}
            end;
       end;
     until (c=#13) or (c=#14);
     i[0]:=chr(cp-1);
     getpassword:=i;
  end;


Procedure destruct(p,n:integer; xx,yy:integer);
var
 i,j,k,l,bnum,range:integer;
begin
 range:=(count_pods(player[p].ship[n].pod,'B') div 2)+1;
 with player[p].ship[n] do
 for bnum:=1 to count_pods(pod,'B') do
  begin
   a:=false;
   putimage(164+(x-xx)*14,164+(y-yy)*14,big_blast^,xorput);
   sound_effect(3);
   for i:=1 to num_players do
    for k:=1 to max_ships do
     if (player[i].ship[k].a) and ((i<>p) or (k<>n)) and
        (abs(player[i].ship[k].x-x)<=range) and
        (abs(player[i].ship[k].y-y)<=range) then
      begin
       putimage(171+(player[i].ship[k].x-xx)*14,
                172+(player[i].ship[k].y-yy)*14,explosion^,xorput);
       if (not player[i].ship[k].base) or (gamesys.bomb_base) then
         player[i].ship[k].hp:=player[i].ship[k].hp-(random(4)+3);
       if player[i].ship[k].hp<=0 then
         begin
          player[i].ship[k].a:=false; sound_effect(1);
          if count_pods(player[i].ship[k].pod,'B')>0 then destruct(i,k,xx,yy);
          putimage(171+(player[i].ship[k].x-xx)*14,
                   172+(player[i].ship[k].y-yy)*14,explosion^,xorput);
         end;
      end;
   sound_effect(3);
   for i:=1 to num_players do
    for k:=1 to max_ships do
     if (player[i].ship[k].a) and ((i<>p) or (k<>n)) and
        (abs(player[i].ship[k].x-x)<=range) and
        (abs(player[i].ship[k].y-y)<=range) then
         putimage(171+(player[i].ship[k].x-xx)*14,
                  172+(player[i].ship[k].y-yy)*14,explosion^,xorput);
   putimage(164+(x-xx)*14,164+(y-yy)*14,big_blast^,xorput);
  end;
end;

procedure damage_ship(p,n,damage,mapx,mapy:integer);
begin
 player[p].ship[n].hp:=player[p].ship[n].hp-damage;
 if player[p].ship[n].hp<=0 then
   begin
     player[p].ship[n].a:=false; sound_effect(1);
     if count_pods(player[p].ship[n].pod,'B')>0 then
        destruct(p,n,mapx,mapy);
   end;
end;

procedure show_star(n:integer);
var
 xx,yy:integer;
begin
 hide_mouse;
 xx:=60; yy:=110;
 settextjustify(centertext,toptext);
 open_window(xx,yy,70);
 setcolor(11);
 with star[n] do
  begin
   outtextxy(xx+124,yy+12,'Star #'+cstr(n));
   outtextxy(xx+124,yy+22,'Supply: '+cstr(supply));
   outtextxy(xx+124,yy+32,'Location: '+cstr(x)+', '+cstr(y));
  end;
 settextjustify(lefttext,toptext);
 buttonbak:=button;
 kill_buttons;
 make_button(xx+125,yy+53,20,'O','OK');
 show_mouse;
 pause;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure show_ship(p,n:integer);
var
 xx,yy:integer;
begin
 hide_mouse;
 xx:=60; yy:=110;
 open_window(xx,yy,150);
 settextjustify(centertext,toptext);
 setcolor(11);
 with player[p] do
  begin
   outtextxy(xx+124,yy+8,'Player #'+cstr(p)+', Ship #'+cstr(n));
   outtextxy(xx+124,yy+16,'Speed: '+cstr(ship_speed(ship[n])));
   if ship[n].base then
     outtextxy(xx+124,yy+24,'--==[ STARBASE ]==--');
   outtextxy(xx+124,yy+32,'Pods: '+ship[n].pod);
   outtextxy(xx+124,yy+045,'C = Cargo     S = Sensor  ');
   outtextxy(xx+124,yy+053,'P = Plasma    I = Stealth ');
   outtextxy(xx+124,yy+061,'L = Laser     T = Targeter');
   outtextxy(xx+124,yy+069,'M = Missile   E = ECM     ');
   outtextxy(xx+124,yy+077,'A = Armor     B = Bomb    ');
   outtextxy(xx+124,yy+085,'F = Thruster  X = Cloak   ');
   outtextxy(xx+124,yy+093,'O = Torpedo   W = Mines   ');
   outtextxy(xx+124,yy+101,'J = Jump Pod  K = T-Loader');
   outtextxy(xx+124,yy+109,'V = Viper ATC             ');
  end;
 settextjustify(lefttext,toptext);
 buttonbak:=button;
 kill_buttons;
 make_button(xx+125,yy+130,20,'O','OK');
 show_mouse;
 pause;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

function scan_star(mmx,mmy,mapx,mapy,mapmode:integer):integer;
var
 i,j,k,l,mx,my:integer;
begin
 case mapmode of
  0:begin mx:=((mmx-5) div 3)-59; my:=((mmy-5) div 3)-59; end;
  1:begin mx:=((mmx-5) div 14)+mapx-12; my:=((mmy-5) div 14)+mapy-12; end;
 end;
 k:=find_star(mx,my);
 if (k>0) and (k<=max_stars) then show_star(k);
 scan_star:=k;
end;

function scan_ship(mmx,mmy,mapx,mapy,p,mapmode:integer):integer;
var
 i,j,k,l,mx,my,n:integer;
begin
 case mapmode of
  0:begin mx:=((mmx-5) div 3)-59; my:=((mmy-5) div 3)-59; end;
  1:begin mx:=((mmx-5) div 14)+mapx-12; my:=((mmy-5) div 14)+mapy-12; end;
 end;
 k:=0; l:=0;
 for i:=1 to num_players do
  if i<>p then
   for j:=1 to max_ships do
    with player[i].ship[j] do
     if (a) and (x=mx) and (y=my) and (k=0)
        and check_view(p,i,j) then begin k:=j; l:=i; end;
 if (k=0) then n:=scan_star(mmx,mmy,mapx,mapy,mapmode);
 if (k=0) and (n=0) then
  for i:=1 to num_players do
   if i<>p then
    for j:=1 to max_ships do
     with player[i].ship[j] do
      if (a) and (abs(x-mx)<=1) and (abs(y-my)<=1) and
      (k=0) and check_view(p,i,j) then begin k:=j; l:=i; end;
 if (l>0) and (k>0) then begin show_ship(l,k); n:=k; end;
 scan_ship:=n;
end;

procedure select_ship(mmx,mmy,mapx,mapy,p:integer; var n:integer; mapmode:integer);
var
 i,j,k,l,mx,my:integer;
begin
 case mapmode of
  0:begin mx:=((mmx-5) div 3)-59; my:=((mmy-5) div 3)-59; end;
  1:begin mx:=((mmx-5) div 14)+mapx-12; my:=((mmy-5) div 14)+mapy-12; end;
 end;
 k:=0;
 with player[p] do
  for i:=1 to max_ships do
   with ship[i] do
    if (a) and (x=mx) and (y=my) and (k=0) then k:=i;
 if (k=0) then j:=scan_ship(mmx,mmy,mapx,mapy,p,mapmode);
 if (k=0) and (j=0) then
  with player[p] do
   for i:=1 to max_ships do
    with ship[i] do
     if (a) and (abs(x-mx)<=1) and (abs(y-my)<=1) and (k=0) then k:=i;
 if k>0 then n:=k;
 if (k=0) and (j=0) then beep;
end;


function get_name(s:String):string;
var
 xx,yy:integer;
begin
 xx:=60; yy:=110;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons;
 hide_mouse;
 show_text(s,'Input new name below:','',15,183);
 get_name:=getpassword(67,170,max_name_length,14,false);
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure jettison(p,n,j:integer);
var
 mx,my,xx,yy:integer;
 b:boolean;
 c:char;
begin
 if player[p].ship[n].base then begin beep; exit; end;
 xx:=60; yy:=110;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; 
 hide_mouse;
 show_text('','Jettison pod #'+cstr(j)+'?','',15,183);
 make_button(120,170,30,'Y','Yes');
 make_button(250,170,30,'N','No');
 show_mouse;
 repeat
  click_wait(mx,my,b,c);
 until c in ['Y','N'];
 with player[p].ship[n] do
  if c='Y' then
   begin
    case pod[j] of
     'C':if cargo>400 then dec(cargo,400) else cargo:=0;
     'O':if torpedoes>3 then dec(torpedoes,3) else torpedoes:=0;
     'K':if torpedoes>5 then dec(torpedoes,5) else torpedoes:=0;
     'W':if mines>10 then dec(mines,10) else mines:=0;
    end;
    pod[j]:=locase(pod[j]);
   end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;


procedure repair_ship(p,n:integer);
var
 i,j,k,l,nb,xx,yy:integer;
 ok:boolean;
 mx,my:integer;
 c:char;
 b:boolean;
begin
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; ok:=false;
 k:=nearest_base(p,player[p].ship[n].x,player[p].ship[n].y);
 with player[p].ship[n] do
  begin
   if (abs(x-player[p].ship[k].x)<=action_range) and
      (abs(y-player[p].ship[k].y)<=action_range) and
      (player[p].ship[k].a) and (k>0) then
    begin
      hide_mouse;
      i:=1500;
      for k:=1 to length(pod) do
       if pod[k] in ['a'..'z'] then i:=i+500;
      show_text('Repair cost: '+cstr(i),'Repair this ship?','',15,183);
      make_button(120,170,30,'Y','Yes');
      make_button(250,170,30,'N','No');
      show_mouse;
      repeat
       click_wait(mx,my,b,c);
       if (c='Y') then
        begin
         ok:=true;
         if i<=player[p].money then
          begin
           player[p].money:=player[p].money-i;
           for i:=1 to length(pod) do
            pod[i]:=upcase(pod[i]);
           hp:=max_armor(pod);
          end
         else
          begin
           hide_mouse;
           kill_buttons;
           show_text('','You can''t afford that!','',15,183);
           make_button(185,170,30,'O','OK');
           show_mouse;
           click_wait(mx,my,b,c);
          end;
        end;
       if (c='N') then ok:=true;
      until ok;
    end
   else
    begin
      hide_mouse;
      show_text('','You aren''t near a starbase!','',15,183);
      make_button(185,170,30,'O','OK');
      show_mouse;
      click_wait(mx,my,b,c);
    end;
  end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure do_destruct(p,n:integer; var mapmode,mapx,mapy:integer);
var
 mx,my,xx,yy:integer;
 b:boolean;
 c:char;
begin
 if count_pods(player[p].ship[n].pod,'B')<=0 then begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons;
 repeat
  hide_mouse;
  show_text('','Destroy this ship?','',15,183);
  make_button(120,170,30,'Y','Yes');
  make_button(250,170,30,'N','No');
  show_mouse;
  click_wait(mx,my,b,c);
 until c in ['Y','N'];
 with player[p].ship[n] do
  if c='Y' then
   begin
    mapmode:=1; mapx:=x; mapy:=y;
    hide_mouse; kill_buttons;
    draw_zoom_in(mapx,mapy);
    destruct(p,n,mapx,mapy);
    setcolor(player_color(p));
    outtextxy(6,345,'Ship Destroyed.');
    flushkey; click_wait(mx,my,b,c);
   end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
 show_mouse;
end;

procedure fix_base(p,n:integer);
var
 mx,my,xx,yy:integer;
 b:boolean;
 c:char;
begin
 with player[p].ship[n] do
  if (player[p].money<500) or (hp>=gamesys.base_damage) or (repaired) then
     begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,90);
 buttonbak:=button;
 kill_buttons;
 repeat
  hide_mouse;
  show_text('Repair cost: 500 per point.',
            'Can only repair once per turn.',
            'Do you wish to proceed?',15,195);
  make_button(120,180,30,'Y','Yes');
  make_button(250,180,30,'N','No');
  show_mouse;
  click_wait(mx,my,b,c);
 until c in ['Y','N'];
 with player[p].ship[n] do
  if c='Y' then
   begin
    player[p].money:=player[p].money-500;
    inc(hp); repaired:=true;
   end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
 show_mouse;
end;

procedure buy_ship(p,n:integer;tship:ship_rec);
var
 mx,my,xx,yy,k:integer;
 b:boolean;
 c:char;
begin
 if player[p].money<ship_cost(tship) then begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons;
 repeat
  hide_mouse;
  show_text('Ship cost: '+cstr(ship_cost(tship)),'Buy it?','',15,183);
  make_button(120,170,30,'Y','Yes');
  make_button(250,170,30,'N','No');
  show_mouse;
  click_wait(mx,my,b,c);
 until c in ['Y','N'];
 with player[p] do
  if c='Y' then
   begin
    k:=add_ship(p,n,tship.pod,tship.engine,tship.booster,tship.robot);
    if k>0 then money:=money-ship_cost(tship)
     else
      begin
       hide_mouse; kill_buttons; 
       setfillstyle(1,1); bar(xx+5,yy+5,xx+245,yy+75);
       show_text('','You don''t have any room!','',15,183);
       make_button(185,170,30,'O','OK'); beep;
       show_mouse; click_wait(mx,my,b,c);
      end;
   end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
 show_mouse;
end;

procedure jump(p,n:integer);
var
 mx,my,xx,yy,i,k:integer;
 b:boolean;
 c:char;
begin
 if (count_pods(player[p].ship[n].pod,'J')<=0) then begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; c:='Y';
 if (count_pods(player[p].ship[n].pod,'B')>0) then
  begin
   repeat
    hide_mouse;
    show_text('This ship has bombs,','they will detonate.','Try jump anyway?',15,183);
    make_button(120,170,30,'Y','Yes');
    make_button(250,170,30,'N','No');
    show_mouse;
    click_wait(mx,my,b,c);
   until c in ['Y','N'];
   kill_buttons;
  end;
 if c<>'N' then
 repeat
  hide_mouse;
  show_text('Use up one jump pod to','teleport to current','destination?',15,183);
  make_button(120,170,30,'Y','Yes');
  make_button(250,170,30,'N','No');
  show_mouse;
  click_wait(mx,my,b,c);
 until c in ['Y','N'];
 hide_mouse;
 close_window(xx,yy);
 with player[p] do
  with ship[n] do
   if c='Y' then
    begin
     if count_pods(pod,'B')>0 then
      begin
       draw_zoom_in(x,y);
       destruct(p,n,x,y);
      end
     else
      begin
       k:=0;
       for i:=1 to length(pod) do
        if (k=0) and (pod[i]='J') then
         begin k:=i; pod[i]:='+'; end;
       if (k>0) then begin x:=tx; y:=ty; sound_effect(4); end;
      end;
    end;
 hide_mouse;
 button:=buttonbak;
 show_mouse;
end;

procedure load_jumper(p,n:integer);
var
 i,j,k,l,nb,xx,yy:integer;
 ok:boolean;
 mx,my:integer;
 c:char;
 b:boolean;
begin
 if count_pods(player[p].ship[n].pod,'+')<=0 then begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; ok:=false;
 k:=nearest_base(p,player[p].ship[n].x,player[p].ship[n].y);
 with player[p].ship[n] do
  begin
   if (abs(x-player[p].ship[k].x)<=action_range) and
      (abs(y-player[p].ship[k].y)<=action_range) and
      (player[p].ship[k].a) and (k>0) then
    begin
      hide_mouse;
      show_text('Reload one jumper','for 2000 credits?','',15,183);
      make_button(120,170,30,'Y','Yes');
      make_button(250,170,30,'N','No');
      show_mouse;
      repeat
       click_wait(mx,my,b,c);
       if (c='Y') then
        begin
         ok:=true;
         if 2000<=player[p].money then
          begin
           player[p].money:=player[p].money-2000;
           k:=0;
           for i:=1 to length(pod) do
            if (pod[i]='+') and (k=0) then begin pod[i]:='J'; k:=i; end;
          end
         else
          begin
           hide_mouse;
           kill_buttons;
           show_text('','You can''t afford that!','',15,183);
           make_button(185,170,30,'O','OK');
           show_mouse;
           click_wait(mx,my,b,c);
          end;
        end;
       if (c='N') then ok:=true;
      until ok;
    end
   else
    begin
      hide_mouse;
      show_text('','You aren''t near a starbase!','',15,183);
      make_button(185,170,30,'O','OK');
      show_mouse;
      click_wait(mx,my,b,c);
    end;
  end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure load_torps(p,n:integer);
var
 i,j,k,l,nb,xx,yy:integer;
 ok:boolean;
 mx,my:integer;
 c:char;
 b:boolean;
begin
 with player[p].ship[n] do
  if (count_pods(pod,'O')+count_pods(pod,'K')<=0) or
     (torpedoes>=max_torps(player[p].ship[n])) then
     begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; ok:=false;
 with player[p].ship[n] do
  begin
   k:=nearest_base(p,x,y);
   if (abs(x-player[p].ship[k].x)<=action_range) and
      (abs(y-player[p].ship[k].y)<=action_range) and
      (player[p].ship[k].a) and (k>0) then
    begin
      hide_mouse;
      i:=100;
      i:=i+(max_torps(player[p].ship[n])-torpedoes)*80;
      show_text('Torp reload cost: '+cstr(i),'Reload this ship?','',15,183);
      make_button(120,170,30,'Y','Yes');
      make_button(250,170,30,'N','No');
      show_mouse;
      repeat
       click_wait(mx,my,b,c);
       if (c='Y') then
        begin
         ok:=true;
         if i<=player[p].money then
          begin
           player[p].money:=player[p].money-i;
           torpedoes:=max_torps(player[p].ship[n]);
          end
         else
          begin
           hide_mouse;
           kill_buttons;
           show_text('','You can''t afford that!','',15,183);
           make_button(185,170,30,'O','OK');
           show_mouse;
           click_wait(mx,my,b,c);
          end;
        end;
       if (c='N') then ok:=true;
      until ok;
    end
   else
    begin
      hide_mouse;
      show_text('','You aren''t near a starbase!','',15,180);
      make_button(185,170,30,'O','OK');
      show_mouse;
      click_wait(mx,my,b,c);
    end;
  end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure load_mines(p,n:integer);
var
 i,j,k,l,nb,xx,yy:integer;
 ok:boolean;
 mx,my:integer;
 c:char;
 b:boolean;
begin
 with player[p].ship[n] do
  if (count_pods(pod,'W')<=0) or
     (mines>=max_mines(player[p].ship[n])) then
     begin beep; exit; end;
 xx:=60; yy:=110;
 hide_mouse;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons; ok:=false;
 with player[p].ship[n] do
  begin
   k:=nearest_base(p,x,y);
   if (abs(x-player[p].ship[k].x)<=action_range) and
      (abs(y-player[p].ship[k].y)<=action_range) and
      (player[p].ship[k].a) and (k>0) then
    begin
      hide_mouse;
      i:=100;
      i:=i+(max_mines(player[p].ship[n])-mines)*50;
      show_text('Mine reload cost: '+cstr(i),'Reload this ship?','',15,183);
      make_button(120,170,30,'Y','Yes');
      make_button(250,170,30,'N','No');
      show_mouse;
      repeat
       click_wait(mx,my,b,c);
       if (c='Y') then
        begin
         ok:=true;
         if i<=player[p].money then
          begin
           player[p].money:=player[p].money-i;
           mines:=max_mines(player[p].ship[n]);
          end
         else
          begin
           hide_mouse;
           kill_buttons;
           show_text('','You can''t afford that!','',15,183);
           make_button(185,170,30,'O','OK');
           show_mouse;
           click_wait(mx,my,b,c);
          end;
        end;
       if (c='N') then ok:=true;
      until ok;
    end
   else
    begin
      hide_mouse;
      show_text('','You aren''t near a starbase!','',15,180);
      make_button(185,170,30,'O','OK');
      show_mouse;
      click_wait(mx,my,b,c);
    end;
  end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
end;

procedure get_zoom_loc(var mapx,mapy:integer);
var
 mx,my:integer;
 lb,rb,bb:boolean;
 c:char;
 timer:longint;
begin
 hide_mouse;
 setrowrange(41,329);
 setcolumnrange(41,329);
 setwritemode(xorput);
 mx:=185; my:=185;
 mousetoxy(mx,mx);
 setcolor(14);
 rectangle(mx-36,my-36,mx+35,my+35);
 repeat
  repeat until timer<>meml[0:$46C]; timer:=meml[0:$46C];
  c:=#255; if keypressed then c:=upcase(readkey);
  rectangle(mx-36,my-36,mx+35,my+35);
  askmouse(mx,my,lb,rb,bb);
  rectangle(mx-36,my-36,mx+35,my+35);
 until (c in [#13,#27]) or lb or rb or bb;
 rectangle(mx-36,my-36,mx+35,my+35);
 if c<>#27 then
  begin
   mapx:=((mx-41) div 3)-47;
   mapy:=((my-41) div 3)-47;
  end;
 setwritemode(copyput);
 repeat
  askmouse(mx,my,lb,rb,bb);
 until not (lb or rb or bb);
 start_mouse;
end;

procedure player_menu;
var
 mx,my,i,j,k,l,num,lship,lx,ly,lastnum:integer;
 b,redraw,draw,drawmap,redraw_all,lb:boolean;
 c:char;
 tship:ship_rec;
 mapmode,mapx,mapy,tmode:integer;
 lpod:string[max_pods];
label
 start_over;
begin
 for i:=1 to max_ships do
  player[playnum].ship[i].repaired:=false;
 start_over:
 k:=0;
 with player[playnum] do
  for i:=1 to max_ships do
   if (k=0) and (ship[i].a) and (ship[i].base) then k:=i;
 if k>0 then num:=k
  else
   with player[playnum] do
    for i:=1 to max_ships do
     if (k=0) and (ship[i].a) and (not ship[i].base) then k:=i;
 num:=k; if num<=0 then exit; lship:=num;
 setscreen(true,player[playnum].ship[num].base); hide_mouse;
 player[playnum].name:=btrim(player[playnum].name);
 if player[playnum].name='' then player[playnum].name:=get_name('Corperation Name:');
 redraw:=true; mapmode:=0; drawmap:=true; tmode:=0; redraw_all:=false;
 clear_ship(tship); show_mouse;
 with player[playnum] do
  repeat
   if redraw then
    begin redraw:=false;
     if redraw_all then setscreen(true,ship[num].base)
                   else setscreen(false,ship[num].base);
     if ship[num].base then draw:=true
     else
      begin hide_mouse;
       draw_ship_stats(playnum,num);
       setfillstyle(1,0); bar(5,422,363,474);
       draw_ship(185,448,ship[num].pod,ship[num].engine=2,ship[num].booster,ship[num].robot);
       init_istars(ship_speed(ship[num]));
      end;
    end;
   if draw and (ship[num].base) then
    begin draw:=false; hide_mouse;
      {if redraw_all or (lastnum<>num) then draw_base;}
      draw_base_stats(playnum,num,tship);
      setfillstyle(1,0); bar(5,422,363,474);
      draw_ship(185,448,tship.pod,tship.engine=2,tship.booster,tship.robot);
      init_istars(ship_speede(tship));
    end;
   lastnum:=num; redraw_all:=false;
   if drawmap then
    begin drawmap:=false;
     hide_mouse;
     case mapmode of
      0:draw_zoom_out;
      1:draw_zoom_in(mapx,mapy);
     end;
     draw_guy(5,5,mapx,mapy,playnum,num,mapmode,true);
     put_crosshair(mapx,mapy,playnum,num,mapmode);
     show_tmode(tmode);
    end;
   show_mouse;
   if ship[num].base then flash_wait(mx,my,b,c,ship_speede(tship))
                     else flash_wait(mx,my,b,c,ship_speed(ship[num]));
   if ship[num].base then
    begin
     if (c='P') and (count_pods(tship.pod,'P')<6) then
        begin tship.pod:=tship.pod+'P'; draw:=true; end;
     if (c='M') and (count_pods(tship.pod,'M')<6) then
        begin tship.pod:=tship.pod+'M'; draw:=true; end;
     if (c='L') and (count_pods(tship.pod,'L')<6) then
        begin tship.pod:=tship.pod+'L'; draw:=true; end;
     if (c='C') and (count_pods(tship.pod,'C')<6) then
        begin tship.pod:=tship.pod+'C'; draw:=true; end;
     if (c='A') and (count_pods(tship.pod,'A')<6) then
        begin tship.pod:=tship.pod+'A'; draw:=true; end;
     if (c='S') and (count_pods(tship.pod,'S')<6) then
        begin tship.pod:=tship.pod+'S'; draw:=true; end;
     if (c='T') and (count_pods(tship.pod,'T')<5) then
        begin tship.pod:=tship.pod+'T'; draw:=true; end;
     if (c='E') and (count_pods(tship.pod,'E')<5) then
        begin tship.pod:=tship.pod+'E'; draw:=true; end;
     if (c='B') and (count_pods(tship.pod,'B')<6) then
        begin tship.pod:=tship.pod+'B'; draw:=true; end;
     if (c='I') and (count_pods(tship.pod,'I')<1) then
        begin tship.pod:=tship.pod+'I'; draw:=true; end;
     if (c='U') and (count_pods(tship.pod,'F')<5) then
        begin tship.pod:=tship.pod+'F'; draw:=true; end;
     if (c='X') and (count_pods(tship.pod,'X')<1) then
        begin tship.pod:=tship.pod+'X'; draw:=true; end;
     if (c='W') and (count_pods(tship.pod,'W')<4) then
        begin tship.pod:=tship.pod+'W'; draw:=true; end;
     if (c='O') and (count_pods(tship.pod,'O')<4) then
        begin tship.pod:=tship.pod+'O'; draw:=true; end;
     if (c='J') and (count_pods(tship.pod,'J')<3) then
        begin tship.pod:=tship.pod+'J'; draw:=true; end;
     if (c='K') and (count_pods(tship.pod,'K')<3) then
        begin tship.pod:=tship.pod+'K'; draw:=true; end;
     if (c='V') and (count_pods(tship.pod,'V')<3) then
        begin tship.pod:=tship.pod+'V'; draw:=true; end;
     if (c=#8) and (length(tship.pod)>0) then
        begin tship.pod:=lstr(tship.pod,length(tship.pod)-1); draw:=true; end;
     if (c='N') and (length(tship.pod)>0) then
        begin tship.pod:=''; draw:=true; end;
     if (c='-') then
        begin tship.booster:=tship.booster=false; draw:=true; end;
     if (c='+') then
        begin tship.robot:=tship.robot=false; draw:=true; end;
     if (c='=') then
        begin tship.engine:=3-tship.engine; draw:=true; end;
     if (c='F') then
      begin
       k:=ship[num].hp;
       fix_base(playnum,num);
       if ship[num].hp<>k then redraw:=true;
      end;
     if (c=#13) then
      begin
       if money<ship_cost(tship) then beep
       else
        begin
         buy_ship(playnum,num,tship);
         clear_ship(tship);
         redraw:=true; drawmap:=true;
        end;
      end;
     if (c in ['1'..'9']) then beep;
    end
   else
    begin
     if (c in ['1'..'9']) then
      begin
       if value(c)<=length(ship[num].pod) then
        begin
         lpod:=ship[num].pod;
         jettison(playnum,num,value(c));
         hide_mouse;
         if lpod=ship[num].pod then draw_ship_stats(playnum,num) else redraw:=true;
         show_mouse;
        end else beep;
      end;
     if (c='O') then
      begin
       k:=ship[num].torpedoes;
       load_torps(playnum,num);
       if k<>ship[num].torpedoes then redraw:=true;
      end;
     if (c='I') then
      begin
       k:=ship[num].mines;
       load_mines(playnum,num);
       if k<>ship[num].mines then redraw:=true;
      end;
     if (c='-') then
      with ship[num] do
       begin
        lb:=leader; lx:=fnum;
        if leader then
         begin leader:=false; fnum:=0; end
        else
         begin
          k:=0; 
          repeat
           inc(k); j:=0;
           for i:=1 to max_ships do
            if (ship[i].a) and (ship[i].fnum=k) then j:=i;
          until j=0;
          leader:=true; fnum:=k;
         end;
        hide_mouse;
        draw_ship_stats(playnum,num);
        show_mouse; drawmap:=true;
       end;
     if (c='=') then
      with ship[num] do
       begin
        lb:=leader; lx:=fnum;
        if leader then
         begin beep; end
        else
         begin
          k:=fnum; 
          repeat
           inc(k); j:=0;
           for i:=1 to max_ships do
            if (ship[i].a) and (ship[i].fnum=k) and (ship[i].leader) then j:=i;
          until (k=100) or (j>0);
          if (k>0) and (j=0) then fnum:=0;
          if (k>0) and (j>0) then fnum:=k;
         end;
        if lx<>fnum then
         begin
          hide_mouse;
          draw_ship_stats(playnum,num);
          show_mouse; drawmap:=true;
         end;
       end;
     if (c='U') then
      begin
       lpod:=ship[num].pod;
       load_jumper(playnum,num);
       if ship[num].pod<>lpod then redraw:=true;
      end;
     if (c='J') then
      begin
       lx:=ship[num].x; ly:=ship[num].y;
       jump(playnum,num);
       if not ship[num].a then goto start_over;
       if (lx<>ship[num].x) or (ly<>ship[num].y) then
        begin
         if mapmode=1 then
           begin mapx:=ship[num].x; mapy:=ship[num].y; end;
         redraw:=true; drawmap:=true;
        end;
      end;
     if (c='!') then
      begin
       do_destruct(playnum,num,mapmode,mapx,mapy);
       if not ship[num].a then goto start_over;
      end;
     if (c='C') then
      begin
       if count_pods(ship[num].pod,'X')>0 then
        begin
         hide_mouse;
         ship[num].cloak_active:=ship[num].cloak_active=false;
         draw_ship_stats(playnum,num);
         show_mouse;
        end
       else beep;
      end;
     if (c='T') then
      begin
       if count_pods(ship[num].pod,'O')>0 then
        begin
         hide_mouse;
         ship[num].torping:=ship[num].torping=false;
         draw_ship_stats(playnum,num);
         show_mouse;
        end
       else beep;
      end;
     if (c='M') then
      begin
       if count_pods(ship[num].pod,'W')>0 then
        begin
         hide_mouse;
         ship[num].mining:=ship[num].mining=false;
         draw_ship_stats(playnum,num);
         show_mouse;
        end
       else beep;
      end;
     if (c='R') then
      begin
       hide_mouse;
       repair_ship(playnum,num);
       {draw_ship_stats(playnum,num);}
       redraw:=true;
       show_mouse;
      end;
     if (c='N') then
      begin
       ship[num].name:=get_name('Ship Name:');
       hide_mouse;
       draw_ship_stats(playnum,num);
       show_mouse;
      end;
     if c in ['A','B','S'] then
      begin
       hide_mouse;
       put_crosshair(mapx,mapy,playnum,num,mapmode);
      end;
     if (c='A') and (ship[num].auto or (count_pods(ship[num].pod,'C')>0)) then
        ship[num].auto:=ship[num].auto=false;
     if (c='B') and (ship[num].auto) then
        ship[num].anybase:=ship[num].anybase=false;
     if (c='S') and (ship[num].auto) then
        ship[num].anystar:=ship[num].anystar=false;
     if c in ['A','B','S'] then
      begin
       put_crosshair(mapx,mapy,playnum,num,mapmode);
       draw_ship_stats(playnum,num);
       show_mouse;
      end;
    end;
   if (c='^') then
      begin player[playnum].name:=get_name('Corperation Name:'); redraw:=true; end;
   if (c='?') then begin read_docs; start_mouse; redraw_all:=true; redraw:=true; drawmap:=true; end;
   if (c='#') then
     begin
      if mapmode=0 then grid2:=grid2=false else grid:=grid=false;
      drawmap:=true;
     end;
   if (c='*') then
    begin
     k:=num;
     repeat
      inc(num); if num>max_ships then num:=1;
     until ((ship[num].a) and (ship[num].base)) or (num=k);
     if num<>k then redraw:=true else beep;
    end;
   if (c in [#128..#131]) and (mapmode=1) then
    begin
     lx:=mapx; ly:=mapy;
     case c of
      #128:mapy:=mapy-6;
      #129:mapy:=mapy+6;
      #130:mapx:=mapx-6;
      #131:mapx:=mapx+6;
     end;
     if mapx>60 then mapx:=60;
     if mapx<-60 then mapx:=-60;
     if mapy>60 then mapy:=60;
     if mapy<-60 then mapy:=-60;
     if (lx<>mapx) or (ly<>mapy) then drawmap:=true;
    end;
   if (c=#0) and (mx<=365) and (my<=365) then
     begin
      hide_mouse;
      put_crosshair(mapx,mapy,playnum,num,mapmode);
      set_course(mx,my,mapx,mapy,playnum,num,mapmode,tmode);
      put_crosshair(mapx,mapy,playnum,num,mapmode);
      if not ship[num].base then draw_ship_stats(playnum,num);
      show_mouse;
     end;
   if (c=#255) and (mx<=365) and (my<=365) then
     begin
      hide_mouse;
      select_ship(mx,my,mapx,mapy,playnum,num,mapmode);
      show_mouse;
     end;
   if (c='~') then
    begin redraw:=true; redraw_all:=true; drawmap:=true; end;
   if (c='&') then
    begin
     hide_mouse;
     inc(tmode); if tmode>max_tmode then tmode:=0;
     show_tmode(tmode);
     show_mouse;
    end;
   if (c='Z') then
    begin
     hide_mouse;
     mapmode:=1-mapmode; {redraw:=true;} drawmap:=true;
     if mapmode=1 then
      begin
       mapx:=10000; mapy:=10000;
       get_zoom_loc(mapx,mapy);
       if (abs(mapx)>70) and (abs(mapy)>70) then mapmode:=0;
      end;
     show_mouse;
    end;
   if (c='[') then
    begin
     k:=num;
     repeat
      dec(num); if num<=0 then num:=max_ships;
     until (k=num) or (ship[num].a);
     if (k=num) and (not ship[num].a) then c:='D';
    end;
   if (c=']') then
    begin
     k:=num;
     repeat
      inc(num); if num>max_ships then num:=1;
     until (k=num) or (ship[num].a);
     if (k=num) and (not ship[num].a) then c:='D';
    end;
   if lship<>num then
    begin
     redraw:=true;
     hide_mouse;
     put_crosshair(mapx,mapy,playnum,lship,mapmode);
     draw_guy(5,5,mapx,mapy,playnum,lship,mapmode,false);
     draw_guy(5,5,mapx,mapy,playnum,num,mapmode,true);
     put_crosshair(mapx,mapy,playnum,num,mapmode);
     show_mouse;
     lship:=num;
    end;
  until (c in ['D']) or loaded_game;
end;

procedure plant_mine(p,n:integer);
var
 ok:boolean;
 i,j,k,l:integer;
begin
 k:=0;
 with player[p].ship[n] do
  if (not a) or (not mining) or (count_pods(pod,'W')<=0) or (mines=0) then exit;
 with player[p] do
  for i:=1 to max_weaps-4 do
   if (weap[i].typ=0) and (k=0) then k:=i;
 if k>0 then
  begin
   with player[p].weap[k] do
    begin
     x:=player[p].ship[n].x; y:=player[p].ship[n].y;
     typ:=weap_mine; age:=0;
     dec(player[p].ship[n].mines);
     {--- Make sure we're not in something else ---}
     repeat
      ok:=true;
      for i:=1 to max_players do
       for j:=1 to max_weaps do
        if (abs(player[i].weap[j].x-x)=0) and (abs(player[i].weap[j].y-y)=0) and
           (player[i].weap[j].typ>0) and ((i<>p) or (j<>k)) then begin
           ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
      for i:=1 to max_stars do
       if (abs(star[i].x-x)=0) and (abs(star[i].y-y)=0) then
          begin ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
     until ok;
    end;
  end;
end;

procedure launch_torp(p,n:integer);
var
 ok:boolean;
 i,j,k,l:integer;
begin
 {Torpedo transfer (loaders):}
 with player[p].ship[n] do
  if (count_pods(pod,'K')>0) and (torpedoes>0) then
   begin j:=torpedoes-(3*count_pods(pod,'O'));
    if j>0 then
     begin
      k:=0;
      for i:=1 to max_ships do
       if (player[p].ship[i].a) and (j>0) and
          (abs(x-player[p].ship[i].x)<=action_range) and
          (abs(y-player[p].ship[i].y)<=action_range) and
          (count_pods(player[p].ship[i].pod,'O')>0) and
          (player[p].ship[i].torpedoes<max_torps(player[p].ship[i])) then
        begin
         l:=max_torps(player[p].ship[i])-player[p].ship[i].torpedoes;
         if l>j then l:=j;
         torpedoes:=torpedoes-l;
         inc(player[p].ship[i].torpedoes,l);
         j:=j-l;
        end;
     end;
   end;
 {Torpedo firing:}
 l:=0;
 with player[p].ship[n] do
  for i:=1 to length(pod) do
   begin
    if (pcount[i]>0) then dec(pcount[i]);
    if (pcount[i]=0) and (pod[i]='O') then l:=i;
   end;
 with player[p].ship[n] do
  if (not a) or (not torping) or (count_pods(pod,'O')<=0) or
     (torpedoes=0) or (l=0) then exit;
 k:=0;
 with player[p] do
  for i:=1 to max_weaps do
   if (weap[i].typ=0) and (k=0) then k:=i;
 if (k>0) and (l>0) then
  begin
   with player[p].weap[k] do
    begin
     player[p].ship[n].pcount[l]:=5;
     x:=player[p].ship[n].x;   y:=player[p].ship[n].y;
     tx:=player[p].ship[n].ox+random(9)-4;
     ty:=player[p].ship[n].oy+random(9)-4;
     typ:=weap_torp; age:=0;
     dec(player[p].ship[n].torpedoes);
    end;
  end;
end;

procedure fix_ships;
var
 i,j,k,l,n:integer;
begin
 {fix-ups}
 for n:=1 to max_ships do
  with player[playnum].ship[n] do
   if a then
    begin
     if (count_pods(pod,'X')<=0) then cloak_active:=false;
     if (count_pods(pod,'W')<=0) then mining:=false;
     if (count_pods(pod,'O')<=0) then torping:=false;
     if auto and (not leader) then begin fnum:=0; end;
     if (fnum>0) and (find_leader(playnum,fnum)=0) then fnum:=0;
     if (base) then begin auto:=false; leader:=false; fnum:=0; end;
     if (hp<=0) then a:=false;
     fired:=0;
    end;
end;

procedure do_ships(fleader:boolean; var fought:boolean);
var
 i,j,k,l,n,p,tp,tn,spd,ttx,tty,strt:integer;
 mx,my:integer;
 c:char;
 b,ok:boolean;
begin
 {the real stuff starts here}
 p:=playnum; fought:=false;
 for n:=1 to max_ships do
  if (player[p].ship[n].a) and (player[p].ship[n].leader=fleader) then
   with player[p].ship[n] do
    begin
     if keypressed then
      begin c:=readkey; if c=#0 then special_key(readkey); end;
     {------Check Auto Status---------}
     k:=count_pods(pod,'C');
     if (k=0) or (base) then auto:=false;
     {------Set Target based on settings----}
     if (fnum>0) and (not leader) and (find_leader(p,fnum)>0) then
      begin
       j:=find_leader(p,fnum);
       tx:=player[p].ship[j].x;
       ty:=player[p].ship[j].y;
      end;
     ttx:=tx; tty:=ty;
     {------Do Auto Maneuvers---------}
     if auto then
      begin
       k:=max_cargo(player[p].ship[n]);
       if cargo<k then
        begin
         k:=0; i:=0; l:=32767;
         if not anystar then k:=find_star(tx,ty) else
          while (i<max_stars) do
           begin inc(i); j:=myabs(x-star[i].x);
            if myabs(star[i].y-y)>j then j:=myabs(star[i].y-y);
            if (j<l) and (star[i].supply>0) then begin l:=j; k:=i; end;
           end;
         if k>0 then
          begin
           ttx:=star[k].x;
           tty:=star[k].y;
          end;
         l:=nearest_base(p,rx,ry);
         if gamesys.base_mobile and (l>0) then
            begin rx:=player[p].ship[l].x; ry:=player[p].ship[l].y; end;
        end
       else
        begin
         l:=nearest_base(p,rx,ry);
         if gamesys.base_mobile and (l>0) then
            begin rx:=player[p].ship[l].x; ry:=player[p].ship[l].y; end;
         if anybase then l:=nearest_base(p,x,y)
                    else l:=nearest_base(p,rx,ry);
         if (l>0) and (player[p].ship[l].a) then
          begin
           ttx:=player[p].ship[l].x;
           tty:=player[p].ship[l].y;
          end;
        end;
      end;
     {------Move ship-----------------}
     {precise:=true;}
     j:=abs(x-ttx); if abs(y-tty)>j then j:=abs(y-tty);
     if not leader then spd:=ship_speed(player[p].ship[n])
                   else spd:=slowest_speed(p,n,fnum);
     if (not gamesys.base_mobile) and (base) then spd:=0;
     if j<=spd then
      begin
       x:=ttx;
       y:=tty;
      end
     else
      begin
       k:=spd;
       if abs(x-ttx)<=k then
        x:=ttx else begin if x>ttx then x:=x-k else x:=x+k; end;
       if abs(y-tty)<=k then
        y:=tty else begin if y>tty then y:=y-k else y:=y+k; end;
      end;
     {--- Make sure we're not in something else ---}
     if (not base) then
     repeat
      ok:=true;
      for i:=1 to max_players do
       for k:=1 to max_ships do
        if (abs(player[i].ship[k].x-x)=0) and (abs(player[i].ship[k].y-y)=0) and
           (player[i].ship[k].a) and ((i<>p) or (k<>n)) then begin
           ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
      for i:=1 to max_stars do
       if (abs(star[i].x-x)=0) and (abs(star[i].y-y)=0) then
          begin ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
     until ok;
     {------Black Holes and Worm Holes--}
     for i:=1 to max_holes do
      begin
       if (x=hole[i].x) and (y=hole[i].y) and (i>=7) and (not base) then
          begin a:=false; yell('Ship #'+cstr(n)+' died in a black hole!',p); end;
       if (x=hole[i].x) and (y=hole[i].y) and (i<7) then
        begin
         case i of
          1:k:=2;
          2:k:=1;
          3:k:=4;
          4:k:=3;
          5:k:=6;
          6:k:=5;
         end;
         hole[i].travelled:=true;
         hole[i].visible:=true;
         hole[k].visible:=true;
         hole[k].travelled:=true;
         repeat
          x:=hole[k].x+random(3)-1;
          y:=hole[k].y+random(3)-1;
         until (y<>hole[k].y) or (x<>hole[k].x);
         if not base then
           yell('Ship #'+cstr(n)+' entered a worm hole!',p)
          else
           yell('StarBase#'+cstr(n)+' entered a worm hole!',p);
        end;
      end;
     {----mines---}
     plant_mine(p,n);
     {----torps---}
     launch_torp(p,n);
     {------Do nothing else if dead.----}
     if a then
      begin
       {------Mining--------------------}
       k:=max_cargo(player[p].ship[n]);
       for i:=1 to max_stars do
        if (abs(x-star[i].x)<=action_range) and (abs(y-star[i].y)<=action_range) and
           (cargo<k) then
           begin
            if star[i].supply<k-cargo then
               begin cargo:=cargo+star[i].supply; star[i].supply:=0; end
              else
               begin star[i].supply:=star[i].supply-(k-cargo); cargo:=k; end;
           end;
       {------Off-Loading---------------}
       l:=nearest_base(p,x,y);
       if (cargo>0) and (l>0) and (abs(x-player[p].ship[l].x)<=action_range) and
          (abs(y-player[p].ship[l].y)<=action_range) then
           begin
            player[p].money:=player[p].money+cargo; cargo:=0;
           end;
       {------Combat time---------------}
       hide_mouse; tp:=0; tn:=0; j:=5000;
       num_targets:=0;
       if (not cloak_active) then
        for i:=1 to num_players do
         for k:=1 to max_ships do
          if (player[i].ship[k].a) and (i<>p) and (player[i].team<>player[p].team)
             and (not player[i].ship[k].cloak_active)
             and ((not base) or (gamesys.shoot_base)) then
           begin
            l:=abs(x-player[i].ship[k].x);
            if l<abs(y-player[i].ship[k].y) then l:=abs(y-player[i].ship[k].y);
            if (l<j) and (l<=action_range) then
               begin num_targets:=1; target[num_targets].tp:=i;
                     target[num_targets].tn:=k; j:=l; end;
            if (l=j) and (l<=action_range) then
               begin inc(num_targets); target[num_targets].tp:=i;
                     target[num_targets].tn:=k; j:=l; end;
           end;
       if num_targets>0 then
        begin
         k:=random(num_targets)+1;
         tp:=target[k].tp;
         tn:=target[k].tn;
        end
       else begin tp:=0; tn:=0; end;
       k:=0; setwritemode(xorput);
       if (length(pod)>0) and (tp>0) then
        for i:=1 to length(pod) do
         if (pod[i] in ['P','L','M']) and (player[tp].ship[tn].hp>0) then
          begin
           fought:=true;
           if k=0 then
            begin
             hide_mouse;
             setwritemode(copyput);
             draw_zoom_in(x,y); working;
             setwritemode(xorput);
             putimage(170,170,crosshair^,xorput);
             setcolor(player_color(p));
             outtextxy(6,6,'Player #'+cstr(p)+':  ('+cstr(cycle)+')');
            end;
           case pod[i] of
            'P':setcolor(14);
            'L':setcolor(12);
            'M':setcolor(9);
           end;
           line(180,180,180+(player[tp].ship[tn].x-x)*14,
                        180+(player[tp].ship[tn].y-y)*14);
           sound_effect(2);
           j:=1;
           case pod[i] of
            'P':j:=6;
            'L':j:=6;
            'M':j:=4;
           end;
           j:=j+count_pods(pod,'T');
           j:=j-count_pods(player[tp].ship[tn].pod,'E');
           if robot then inc(j);
           if random(12)<j then
            begin
             j:=1;
             case pod[i] of
              'P':j:=4;
              'L':j:=2;
              'M':j:=3;
             end;
             putimage(171+(player[tp].ship[tn].x-x)*14,
                      173+(player[tp].ship[tn].y-y)*14,explosion^,xorput);
             sound_effect(1);
             damage_ship(tp,tn,j,x,y);
             putimage(171+(player[tp].ship[tn].x-x)*14,
                      173+(player[tp].ship[tn].y-y)*14,explosion^,xorput);
            end;
           line(180,180,180+(player[tp].ship[tn].x-x)*14,
                        180+(player[tp].ship[tn].y-y)*14);
           if fast_combat then
            begin
             if sound_off then delay(25) else delay(55);
            end else delay(fire_delay);
           working;
           k:=i;
          end;
      end;
    end;
 setwritemode(copyput);
end;

function torp_blast(range,x,y,xx,yy:integer):integer;
var
 i,j,k,l:integer;
begin
  k:=0;
  for j:=1 to num_players do
   for i:=1 to max_ships do
    if (player[j].ship[i].a) and
       (x+xx=player[j].ship[i].x) and (y+yy=player[j].ship[i].y) then
       begin
        k:=i;
        putimage(171+(player[j].ship[i].x-x)*14,
                 173+(player[j].ship[i].y-y)*14,explosion^,xorput);
        sound_effect(1);
        if range<3 then l:=0 else l:=1;
        damage_ship(j,i,(random(3)+3) shr l,x,y);
        putimage(171+(player[j].ship[i].x-x)*14,
                 173+(player[j].ship[i].y-y)*14,explosion^,xorput);
       end;
 torp_blast:=k;
end;

procedure do_weaps(var fought:boolean);
var
 i,j,k,l,p,n,ttx,tty,spd:integer;
 ok:boolean;
begin
 for p:=1 to num_players do
 with player[p] do
  for n:=1 to max_weaps do
   with weap[n] do
    if typ>0 then
     begin
      if typ=weap_mine then begin tx:=x; ty:=y; end;
      ttx:=tx; tty:=ty; spd:=torp_speed;
      j:=abs(x-ttx); if abs(y-tty)>j then j:=abs(y-tty);
      {--- Move that weap! ---}
      if (p=playnum) then
       begin
        if j<=spd then
         begin
          x:=ttx;
          y:=tty;
         end
        else
         begin
          k:=spd;
          if abs(x-ttx)<=k then x:=ttx
             else begin if x>ttx then x:=x-k else x:=x+k; end;
          if abs(y-tty)<=k then y:=tty
             else begin if y>tty then y:=y-k else y:=y+k; end;
         end;
       end;
       if age<100 then inc(age);
       {--- Make sure we're not in something else ---}
       if (typ=weap_torp) or (age<2) then
       repeat
        ok:=true;
        for i:=1 to max_players do
         for k:=1 to max_weaps do
          if (abs(player[i].weap[k].x-x)=0) and (abs(player[i].weap[k].y-y)=0) and
             (player[i].weap[k].typ>0) and ((i<>p) or (k<>n)) then begin
             ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
        for i:=1 to max_players do
         for k:=1 to max_ships do
          if (abs(player[i].ship[k].x-x)=0) and (abs(player[i].ship[k].y-y)=0) and
             (player[i].ship[k].a) and (typ=weap_torp) then begin
             ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
        for i:=1 to max_stars do
         if (abs(star[i].x-x)=0) and (abs(star[i].y-y)=0) then
            begin ok:=false; x:=x+random(3)-1; y:=y+random(3)-1; end;
       until ok;
      case typ of
       weap_mine:begin
                  k:=0;
                  for i:=1 to max_ships do
                   with player[playnum] do
                    if (ship[i].a) and (not ship[i].base) and (p<>playnum) and
                       (abs(x-ship[i].x)<=1) and (abs(y-ship[i].y)<=1) then k:=i;
                  if k>0 then
                   begin
                    hide_mouse; fought:=true;
                    draw_zoom_in(x,y); working;
                    putimage(164,164,big_blast^,xorput);
                    sound_effect(3);
                    for j:=1 to num_players do
                     for i:=1 to max_ships do
                      if (player[j].ship[i].a) and
                         (abs(x-player[j].ship[i].x)<=2) and
                         (abs(y-player[j].ship[i].y)<=2) then
                         begin
                          putimage(171+(player[j].ship[i].x-x)*14,
                                   173+(player[j].ship[i].y-y)*14,explosion^,xorput);
                          sound_effect(1);
                          damage_ship(j,i,random(4)+2,x,y);
                          putimage(171+(player[j].ship[i].x-x)*14,
                                   173+(player[j].ship[i].y-y)*14,explosion^,xorput);
                         end;
                    putimage(164,164,big_blast^,xorput);
                    typ:=0;
                   end;
                 end;
       weap_torp:begin
                  for j:=1 to num_players do
                   if (j<>p) and (j=playnum) then
                    for i:=1 to max_ships do
                     if (player[j].ship[i].a) and (count_pods(player[j].ship[i].pod,'V')>0) and
                        (abs(x-player[j].ship[i].x)<=action_range) and
                        (abs(y-player[j].ship[i].y)<=action_range) and (typ>0) then
                      begin
                       hide_mouse; fought:=true;
                       draw_zoom_in(player[j].ship[i].x,player[j].ship[i].y); working;
                       setcolor(15); inc(player[j].ship[i].fired);
                       for l:=1 to count_pods(player[j].ship[i].pod,'V') do
                        if (player[j].ship[i].fired<=2) and (typ>0) then
                        begin
                         setwritemode(xorput); 
                         line(180,180,180+(x-player[j].ship[i].x)*14,
                              180+(y-player[j].ship[i].y)*14);
                         sound_effect(2); 
                         line(180,180,180+(x-player[j].ship[i].x)*14,
                              180+(y-player[j].ship[i].y)*14);
                         if random(24)+count_pods(player[j].ship[i].pod,'T')>=12 then
                          begin
                           putimage(164+(x-player[j].ship[i].x)*14,
                                    164+(y-player[j].ship[i].y)*14,big_blast^,xorput);
                           sound_effect(3);
                           putimage(164+(x-player[j].ship[i].x)*14,
                                    164+(y-player[j].ship[i].y)*14,big_blast^,xorput);
                           typ:=0;
                          end;
                        end;
                       setwritemode(copyput);
                      end;
                  if (abs(x-tx)<=3) and (abs(y-ty)<=3) and (p=playnum) and (typ>0) then
                   begin
                    hide_mouse; fought:=true;
                    draw_zoom_in(x,y); working;
                    putimage(164,164,big_blast^,xorput);
                    sound_effect(3);
                    torp_blast(0,x,y,0,0);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,i,i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,0,i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,-i,i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,-i,0);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,-i,-i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,0,-i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,i,-i);
                    k:=0; for i:=1 to 3 do if k=0 then k:=torp_blast(i,x,y,i,0);
                    typ:=0;
                    putimage(164,164,big_blast^,xorput);
                   end;
                 end;
      end;
     end;
end;


procedure comp_player;
var
 i,j,k,l,n,mode,p,bnum:integer;
 rr:real;
 tship:ship_rec;
 ok:boolean;
begin
 mode:=0; p:=playnum;
 working; if random(10)=0 then player[p].tactic:=3-player[p].tactic;
 for i:=1 to max_ships do
  if (player[p].money>=500) and (player[p].ship[i].hp<gamesys.base_damage) and
     (player[p].ship[i].a) and (random(4)=0) and (player[p].ship[i].base) then
      begin
       player[p].money:=player[p].money-500;
       inc(player[p].ship[i].hp);
      end;
 if count_bases(p)>0 then
 with tship do
  repeat
   if random(10)=0 then booster:=true else booster:=false;
   if random(10)=0 then engine:=2 else engine:=1;
   if random(20)=0 then robot:=true else robot:=false;
   repeat
     pod:='';
     rr:=count_ships(p);
     if rr=0 then rr:=0.00001;
     if ((count_cargo_ships(p)/rr<=player[p].ratio)) or
        ((count_cargo_ships(p)<player[p].cships) and (player[p].tactic=2)) then
        j:=1 else j:=2;
     k:=random(2)+random(2)+random(2)+2;
     l:=random(4);
     case player[p].tactic of
      1:for i:=1 to k do
         begin
          l:=random(8);
          case j of
           1:case l of
              0:pod:=pod+'A';
              1:pod:=pod+'C';
              2:pod:=pod+'C';
              3:pod:=pod+'C';
              4:pod:=pod+'C';
              5:pod:=pod+'C';
              6:pod:=pod+'C';
              7:pod:=pod+'X';
             end;
           2:case l of
              0:pod:=pod+'M';
              1:pod:=pod+'L';
              2:pod:=pod+'P';
              3:pod:=pod+'A';
              4:pod:=pod+'E';
              5:pod:=pod+'I';
              6:pod:=pod+'T';
              7:pod:=pod+'P';
             end;
          end;
          if random(30)=0 then pod:=pod+'O';
         end;
      2:begin
         case j of
          1:begin
             l:=random(2)+1;
             case l of
              1:pod:='CCC';
              2:pod:='CCCC';
             end;
            end;
          2:begin
             l:=random(8)+1;
             if random(20)=0 then
              pod:='OOK' else
             case l of
              1:pod:='PPPP';
              2:pod:='PPEEE';
              3:pod:='PPP';
              4:pod:='PPL';
              5:pod:='PPPL';
              6:pod:='PPA';
              7:pod:='PPPA';
             end;
            end;
         end;
        end;
     end;
    if random(15)=0 then pod:=pod+'V';
    ok:=false; i:=0; k:=0;
    for l:=1 to length(pod) do
     begin if pod[l]='C' then inc(i);
           if pod[l] in ['P','L','M'] then inc(k); end;
    l:=2; if length(pod)-1>l then l:=length(pod)-1;
    if ((j=1) and (i>=l)) or ((j=2) and (k>=l)) then ok:=true;
   until ok;
   if player[p].money>=ship_cost(tship) then
      k:=add_ship(p,random_base(p),pod,engine,booster,robot)
     else k:=0;
   if k>0 then player[p].money:=player[p].money-ship_cost(tship)
  until k=0;
 if ((count_weapon_ships(p)>=6) or (count_bases(p)<=0)) then
  begin
   if ((mode>0) and (mode<=num_players) and (count_bases(mode)<=0) and
      (player[mode].team<>player[p].team)) or (mode<=0) then
      j:=0;
      for i:=1 to num_players do
       if (count_bases(i)>0) and (i<>p) then inc(j);
      repeat mode:=random(num_players)+1;
      until ((mode<>p) and (count_bases(mode)>0)) or (j=0);
  end;
 for n:=1 to max_ships do
  with player[p].ship[n] do
  if (a) and (not base) then
   begin
    mining:=true; torping:=true; cloak_active:=true;
    bnum:=nearest_base(p,x,y);
    if (player[p].ship[bnum].a) and (bnum>0) and
       (diff(x,player[p].ship[bnum].x)<=action_range) and
       (diff(y,player[p].ship[bnum].y)<=action_range) then
       begin
        if (hp<max_armor(pod)) and (player[p].money>=1500) then
           begin player[p].money:=player[p].money-1500; hp:=max_armor(pod); end;
        k:=100+((max_torps(player[p].ship[n])-torpedoes)*80);
        if (torpedoes<max_torps(player[p].ship[n]) div 2) and (count_pods(pod,'O')+count_pods(pod,'K')>0) then
           begin
            player[p].money:=player[p].money-k; torpedoes:=max_torps(player[p].ship[n]);
           end;
        k:=100+((max_mines(player[p].ship[n])-mines)*50);
        if (mines<max_mines(player[p].ship[n]) div 2) and (count_pods(pod,'W')>0) then
           begin
            player[p].money:=player[p].money-k; mines:=max_mines(player[p].ship[n]);
           end;
       end;
    k:=0;
    if count_pods(pod,'C')>0 then
     begin auto:=true; anybase:=true; anystar:=true; end
    else
     begin
      auto:=false;
      k:=count_pods(pod,'P')+count_pods(pod,'L')+count_pods(pod,'M');
     end;
    case gamesys.end_type of
     1:begin
        if (mode>0) and (mode<=num_players) and (count_pods(pod,'O')>0) then
         begin
          j:=random_base(mode);
          ox:=player[mode].ship[j].x;
          oy:=player[mode].ship[j].y;
         end;
        if (mode>0) and (mode<=num_players) and (find_a_base(tx,ty)<>p) then
         begin
          find_enemy_base(p,tx,ty,10,i,j);
          if (i>0) and (j>0) and (player[i].ship[j].a) and
             (player[i].ship[j].base) and (i<>p) then
           begin
            tx:=player[i].ship[j].x;
            ty:=player[i].ship[j].y;
           end;
         end;
        j:=0;
        for i:=1 to num_players do
         begin
          l:=nearest_base(i,tx,ty);
          if (l>0) and (tx=player[i].ship[l].x) and (ty=player[i].ship[l].y) and
             (player[i].team=player[p].team) then j:=i;
         end;
        bnum:=nearest_base(p,x,y);
        if (k>0) and (mode in [1..num_players]) and
           (((tx=player[p].ship[bnum].x) and (ty=player[p].ship[bnum].y))
           or (j>0) or (find_a_base(tx,ty)=0)) then
         begin
          i:=mode; k:=weakest_base(i);
          fnum:=1;
          if find_leader(p,1)<=0 then leader:=true else leader:=false;
          if k>0 then
           begin
            tx:=player[i].ship[k].x;
            ty:=player[i].ship[k].y;
           end;
         end;
       end;
    end;
   end;
 {vipers}
 with player[p] do
  for n:=1 to max_ships do
   with ship[n] do
    if a and (count_pods(pod,'V')>0) then
     begin
      num_targets:=0;
      for j:=1 to num_players do
       for i:=1 to max_weaps do
        if (j<>p) and (player[j].weap[i].typ=weap_torp) and
           (abs(x-player[j].weap[i].x)<=ship_speed(ship[n])+action_range) and
           (abs(y-player[j].weap[i].y)<=ship_speed(ship[n])+action_range) then
           begin inc(num_targets); target[num_targets].tp:=j; target[num_targets].tn:=i; end;
      if num_targets>0 then
       begin
        auto:=false; fnum:=0;
        k:=random(num_targets)+1;
        tx:=player[target[k].tp].weap[target[k].tn].x+random(3)-1;
        ty:=player[target[k].tp].weap[target[k].tn].y+random(3)-1;
       end;
     end;
end;



function game_over(var winner:integer; var message:string; var col:integer):boolean;
var
 i,j,k,l,n:integer;
 teams:array[1..max_players] of integer;
 over:boolean;
begin
 over:=false;
 for i:=1 to max_players do
  teams[i]:=0;
 case gamesys.end_type of
  1:begin
     for i:=1 to num_players do
      for k:=1 to max_ships do
       with player[i].ship[k] do
        if (a) and (base) then inc(teams[player[i].team]);
    end;
 end;
     k:=0; j:=0;
     for i:=1 to max_players do
      if teams[i]>0 then begin inc(j); k:=i; end;
     if (j<=1) then
      begin
       l:=0; j:=0;
       for i:=1 to num_players do
        if player[i].team=k then begin inc(l); j:=i; end;
       if k>0 then
        begin
         if l=1 then begin k:=j; message:='Player #'+cstr(k)+' wins!';
                           col:=player_color(j); end
                else begin message:='Team #'+cstr(k)+' wins!'; col:=14; end;
        end;
       winner:=k;
       over:=true;
      end;
 game_over:=over;
end;

procedure main;
var
 fought:boolean;
 mx,my,i,j,k,winner,col:integer;
 message:string;
 b:boolean;
 c:char;
begin
 cleardevice;
 start_mouse;
 if all_computers then setscreen(true,true);
 flushkey;
 init_istars(10);
 repeat
  k:=0;
  for i:=1 to max_stars do
   if star[i].supply>0 then inc(k);
  if k=0 then with star[max_stars] do
   begin
    x:=0; y:=0; supply:=100000;
   end;
  if loaded_game then loaded_game:=false else
   begin
    inc(playnum);
    if playnum>gamesys.num_players then begin playnum:=1; inc(cycle); end;
   end;
  ship_sort(playnum);
  if all_computers then begin hide_mouse; show_game_stats; end;
  if player[playnum].comp then comp_player else player_menu;
  fought:=false;
  if not loaded_game then
   begin
    fix_ships;
    do_ships(true,fought);
    do_ships(false,fought);
    do_weaps(fought);
    if (not all_computers) and (fought) then
     begin
      if not player[playnum].comp then
       begin
        setcolor(player_color(playnum));
        outtextxy(6,346,'Combat Complete: Click to continue.');
        show_mouse;
        click_wait(mx,my,b,c);
       end;
     end;
   end;
 until game_over(winner,message,col);
 hide_mouse;
 ending(winner,message,col);
 shutdown;
end;


function get_pods(s:string):string;
var
 xx,yy,i,k:integer;
 p:string[max_pods];
begin
 hide_mouse;
 xx:=60; yy:=110;
 open_window(xx,yy,80);
 buttonbak:=button;
 kill_buttons;
 show_text(s,'Enter new pod sequence:','',15,183);
 p:=btrim(ucase(getpassword(67,170,max_pods,14,false)));
 i:=0;
 if length(p)>0 then
  while i<length(p) do
   begin inc(i);
    if not (p[i] in ['C','L','M','A','S','I','P','B','T','E','F','X','O','W','J','K','V','-','+']) then
       begin p:=lstr(p,i-1)+rstr(p,length(p)-i); dec(i); end;
   end;
 hide_mouse;
 button:=buttonbak;
 close_window(xx,yy);
 get_pods:=p;
 show_mouse;
end;


procedure draw_menu(tf:boolean);
var
 s:string;
begin
 kill_buttons;
 if tf then
  begin
   cleardevice;
   setfillstyle(1,1);
   bar(0,0,640,30);
   setcolor(11);
   settextjustify(centertext,toptext);
   outtextxy(320,8,cnotice1);
   outtextxy(320,18,cnotice2);
   settextjustify(lefttext,toptext);
   h_bar(0,2,639,2,1);
   h_bar(0,477,639,477,1);
   v_bar(2,1,2,478,1);
   v_bar(637,1,637,478,1);
   h_bar(4,2,635,2,1);
   h_bar(4,30,635,30,1);
   h_bar(4,477,635,477,1);
   draw_ship(450,70,'PMLASETXI',true,true,true);
   putimage(30,430,base_portrait^,copyput);
   putimage(554,430,base_portrait^,copyput);
   if registered then s:='-= Registered to: '+regname+' =-' else s:='== Unregistered Copy ==';
   setcolor(15);
   settextjustify(centertext,toptext);
   outtextxy(320,440,s);
   settextjustify(lefttext,toptext);
  end;
 make_button(180,460,60,'Q','Quit');
 make_button(320,460,60,'G','Start Game');
 make_button(460,460,60,'I','Instructions');
 prt(20,40,'Teams:',15);
 make_button(30,055,10,'1','1'); prt(45,055,'Player#1: Team '+cstr(player[1].team),player_color(1));
 make_button(30,070,10,'2','2'); prt(45,070,'Player#2: Team '+cstr(player[2].team),player_color(2));
 make_button(30,085,10,'3','3'); prt(45,085,'Player#3: Team '+cstr(player[3].team),player_color(3));
 make_button(30,100,10,'4','4'); prt(45,100,'Player#4: Team '+cstr(player[4].team),player_color(4));
 prt(20,130,'Players:',15);
 make_button(30,145,10,'A','A'); prt(45,145,'Player#1: '+human_comp(1),player_color(1));
 make_button(30,160,10,'B','B'); prt(45,160,'Player#2: '+human_comp(2),player_color(2));
 make_button(30,175,10,'C','C'); prt(45,175,'Player#3: '+human_comp(3),player_color(3));
 make_button(30,190,10,'D','D'); prt(45,190,'Player#4: '+human_comp(4),player_color(4));
 prt(20,220,'Computer CargoShip Ratio:',15);
 make_button(30,235,10,#128,''); prt(45,235,'Player#1: '+cstrrr(player[1].ratio),player_color(1));
 make_button(30,250,10,#129,''); prt(45,250,'Player#2: '+cstrrr(player[1].ratio),player_color(2));
 make_button(30,265,10,#130,''); prt(45,265,'Player#3: '+cstrrr(player[1].ratio),player_color(3));
 make_button(30,280,10,#131,''); prt(45,280,'Player#4: '+cstrrr(player[1].ratio),player_color(4));
 make_button(30,320,10,'P','P'); prt(45,320,'Number of Players:   '+cstr(gamesys.num_players),14);
 make_button(30,340,10,'M','M'); prt(45,340,'Starting Cash:       '+cstr(gamesys.start_money),14);
 make_button(30,360,10,'I','I'); prt(45,360,'Read Instructions',14);
 make_button(30,380,10,'L','L'); prt(45,380,'Load saved game.',14);
 if not registered then
  begin
   make_button(30,400,10,'R','R'); prt(45,400,'Enter Registration Codes',14);
  end;

 prt(295,105,'Base Stats:',15);
 make_button(305,120,10,#140,''); prt(320,120,'Bases can be shot:   '+cbool(gamesys.shoot_base),14);
 make_button(305,140,10,#141,''); prt(320,140,'Bases can be bombed: '+cbool(gamesys.bomb_base),14);
 make_button(305,160,10,#142,''); prt(320,160,'Bases can fire:      '+addrear(cbool(gamesys.base_fire),4)+'(Adds "MLP")',14);
 make_button(305,180,10,#143,''); prt(320,180,'Bases per player:    '+cstr(gamesys.num_bases),14);
 make_button(305,200,10,#144,''); prt(320,200,'Base Hit Points:     '+cstr(gamesys.base_damage),14);
 make_button(305,220,10,#145,''); prt(320,220,'Base Speed:          '+cstr(gamesys.base_speed),14);
 make_button(305,240,10,#146,''); prt(320,240,'Base Pods:           '+gamesys.base_pod,14);
 make_button(305,260,10,#147,''); prt(320,260,'Base Distribution:   '+bd(gamesys.base_distribution),14);
                                  prt(320,270,'  (Both Random and Clustered require',7);
                                  prt(320,280,'   settings of 2 players and no more',7);
                                  prt(320,290,'   than 4 bases per player, got it!?)',7);
 prt(295,320,'Starting Ships:',15);
 make_button(305,335,10,#161,''); prt(320,335,'#1:  '+gamesys.ship[1,1].pod,14);
 make_button(305,350,10,#162,''); prt(320,350,'#2:  '+gamesys.ship[1,2].pod,14);
 make_button(305,365,10,#163,''); prt(320,365,'#3:  '+gamesys.ship[1,3].pod,14);
 make_button(305,380,10,#164,''); prt(320,380,'#4:  '+gamesys.ship[1,4].pod,14);
 make_button(305,395,10,#165,''); prt(320,395,'#5:  '+gamesys.ship[1,5].pod,14);
 make_button(470,335,10,#166,''); prt(485,335,'#6:  '+gamesys.ship[1,6].pod,14);
 make_button(470,350,10,#167,''); prt(485,350,'#7:  '+gamesys.ship[1,7].pod,14);
 make_button(470,365,10,#168,''); prt(485,365,'#8:  '+gamesys.ship[1,8].pod,14);
 make_button(470,380,10,#169,''); prt(485,380,'#9:  '+gamesys.ship[1,9].pod,14);
 make_button(470,395,10,#170,''); prt(485,395,'#10: '+gamesys.ship[1,10].pod,14);
end;

procedure menu;
var
 mx,my,i,j,k,l:integer;
 b:boolean;
 c,c2:char;
 f:text;
 s1,s2:string[40];
begin
 repeat
  playnum:=0;
  start_mouse;
  setrowrange(getmaxy,0);
  hide_mouse;
  draw_menu(true);
  show_mouse;
  repeat
   show_mouse; nospecial_wait(mx,my,b,c); hide_mouse;
   case c of
    '1'..'4':begin
              k:=value(c);
              inc(player[k].team);
              if player[k].team>max_players then player[k].team:=1;
              prt(45,40+15*k,'Player#'+c+': Team '+cstr(player[k].team),player_color(k));
             end;
    'A'..'D':begin
              k:=ord(c)-ord('A')+1; c2:=chr(k+ord('0'));
              player[k].comp:=player[k].comp=false;
              prt(45,130+15*k,'Player#'+c2+': '+human_comp(k),player_color(k));
             end;
    #128..#131:begin
              k:=ord(c)-127; c2:=chr(k+ord('0'));
              player[k].ratio:=round((player[k].ratio*10)+1)/10;
              if player[k].ratio>0.9 then player[k].ratio:=0.1;
              prt(45,220+15*k,'Player#'+c2+': '+cstrrr(player[k].ratio),player_color(k));
             end;
    'P': begin
          inc(gamesys.num_players);
          if gamesys.num_players>max_players then gamesys.num_players:=2;
          prt(45,320,'Number of Players:   '+cstr(gamesys.num_players),14);
         end;
    'M': begin
          inc(gamesys.start_money,5000);
          if gamesys.start_money>150000 then gamesys.start_money:=5000;
          prt(45,340,'Starting Cash:       '+addrear(cstr(gamesys.start_money),7),14);
         end;
    'L': begin
          open_window(60,110,80);
          show_text('Load-Game:','Enter a number from 1 to 9,','to select game, or 0 to abort.',15,180);
          flushkey;
          repeat
           c:=readkey;
          until c in ['0'..'9'];
          if c<>'0' then
           begin
            show_text('','Loading..','',11,180);
            load_game(main_filename+'.SV'+c);
           end;
          close_window(60,110);
          c:=#254;
         end;
    #140:begin
          gamesys.shoot_base:=gamesys.shoot_base=false;
          prt(320,120,'Bases can be shot:   '+addrear(cbool(gamesys.shoot_base),5),14);
         end;
    #141:begin
          gamesys.bomb_base:=gamesys.bomb_base=false;
          prt(320,140,'Bases can be bombed: '+addrear(cbool(gamesys.bomb_base),5),14);
         end;
    #142:begin
          gamesys.base_fire:=gamesys.base_fire=false;
          prt(320,160,'Bases can fire:      '+addrear(cbool(gamesys.base_fire),4)+'(Adds "MLP")',14);
         end;
    #143:begin
          inc(gamesys.num_bases);
          if gamesys.num_bases>5 then gamesys.num_bases:=1;
          prt(320,180,'Bases per player:    '+addrear(cstr(gamesys.num_bases),5),14);
         end;
    #144:begin
          inc(gamesys.base_damage,10);
          if gamesys.base_damage>150 then gamesys.base_damage:=50;
          prt(320,200,'Base Hit Points:     '+addrear(cstr(gamesys.base_damage),5),14);
         end;
    #145:begin
          inc(gamesys.base_speed);
          if gamesys.base_speed>6 then gamesys.base_speed:=0;
          prt(320,220,'Base Speed:          '+addrear(cstr(gamesys.base_speed),5),14);
         end;
    #146:begin
          gamesys.base_pod:=get_pods('--StarBase Pods--');
          prt(320,240,'Base Pods:           '+gamesys.base_pod,14);
         end;
    #147:begin
          inc(gamesys.base_distribution);
          if gamesys.base_distribution>max_distrib then gamesys.base_distribution:=0;
          prt(320,260,'Base Distribution:   '+bd(gamesys.base_distribution),14);
         end;
    #161..#170:begin
          k:=ord(c)-160; j:=k-1;
          gamesys.ship[1,k].pod:=get_pods('--Start Ship Pods--');
          for i:=2 to max_players do
           gamesys.ship[i,k].pod:=gamesys.ship[1,k].pod;
          prt(320+165*(j div 5),335+15*(j mod 5),addrear('#'+cstr(k)+':',5)+
                                                 addrear(gamesys.ship[1,k].pod,9),14);
         end;
    'G':if (gamesys.base_distribution=0) or
           ((gamesys.base_distribution in [1,2]) and (gamesys.num_players=2) and
           (gamesys.num_bases<=4)) then begin {do nothing} end
                                   else begin beep; c:=#0; end;
    'R':if not registered then
         begin
          open_window(60,110,80);
          show_text('Have you paid for this','game and received your','registration codes? (Y/N)',15,182);
          repeat
           c:=upcase(readkey);
          until c in ['Y','N'];
          if c='Y' then
           begin
            assign(f,main_filename+'.REG');
            rewrite(f);
            s1:='exactly as it appears on';
            s2:='your registration response:';
            show_text('Enter your name below',s1,s2,15,182);
            writeln(f,btrim(getpassword(67,170,80,14,false)));
            show_text('Enter Reg-Code below',s1,s2,15,182);
            writeln(f,btrim(getpassword(67,170,80,14,false)));
            close(f);
            verify_reg;
            c:='R';
           end
          else c:=#0;
          close_window(60,110);
         end;
   end;
  until c in ['Q',#27,'G','I',#254,'R'];
  case c of
   'G',#254:begin hide_mouse; working2; if not loaded_game then the_init; main; end;
   'I':read_docs;
  end;
 until c in ['Q',#27];
end;

begin
 init;
 menu;
 shutdown;
end.

