unit stuff;

{
Stuff, Copyright (C) 1994 Ed T. Toton III, All Rights Reserved.

This source code is being distributed as open-source freeware. That is, you're
free to modify it for your own use, or distribute it (for non-profit). You 
may even distribute modified copies and derivative works, so long as proper
credit is given. 

Please note, however, that this code may or may not be 100% complete, and
may be challenging to compile. It was originally designed in Turbo Pascal 6.0.
Also note that there may be some code included that was not originally written by
me, and was in turn borrowed from free examples found online and on BBSes.

Good luck! :)
}



interface

uses graph, dos;

{const
  pi=3.1415926535;}

type
  strl=string[255];

var
  mirror:boolean;
  hangup:boolean;
  r:registers;

{interface}

  function cstrr(i:real):string;
  function cstr(i:longint):string;
  function value(i:string):longint;
  function valuer(i:string):real;
  Procedure GraphVGA;
  Procedure GraphEGA;
  Procedure GraphMCGA;
  procedure lin(x1,y1,x2,y2,col:integer);
  procedure box(x1,y1,x2,y2,col:integer);
  procedure dot(x,y,col:integer);
  procedure cir(x,y,rad,col:integer);
  Function Timer:real;
  Function DetectVGA:integer;
  Function addfront(b:string;l:integer): string;
  Function addrear(b:string;l:integer): string;
  Function ucase(s:string):string;
  Function lcase(s:string):string;
  Function space(i:byte):string;
  Function repchar(c:char; i:byte):string;
  function tch(i:strl):strl;
  function time:string;
  function date:string;
  function ltrim(s1:string):string;
  function rtrim(s1:string):string;
  function btrim(s1:string):string;
  function lstr(s1:string; l:integer):string;
  function rstr(s1:string; l:integer):string;
  Procedure FlushKey;
  Procedure CursorOn;
  Procedure CursorOff;
  function hexnum(num:byte):char;
  function hex(num:word):string;
  function hexb(num:byte):string;
  procedure beep;
  procedure getkey(var c:char);
  function pausescr:char;
  function LeadingZero(w : Word) : String;
  procedure inputln(var i:string; ml:integer; up:boolean);
  Function locase(c:char):char;
  function zero_pad(n,l:longint):string;
  function zero_pads(s:string;l:longint):string;
  procedure scr_str(x,y:byte; s:string; col:byte);
  function nformat(l:longint):string;
  function case_fix(s:string):string;

implementation

(* 'Detection' routine *)
{$F+}                                   (* Force to far calls *)
function DetectVGA : Integer;
var Vid : Integer;

begin
{  Writeln('Which video mode would you like to use?');
  Writeln('  0) 320x200x256');
  Writeln('  1) 640x400x256');
  Writeln('  2) 640x480x256');
  Writeln('  3) 800x600x256');
  Writeln('  4) 1024x768x256');
  Write('> ');
  Readln(Vid);
}
  vid:=0;
  DetectVGA := Vid;
end;
{$F-}

function cstrr(i:real):string;
var
 s1:string[255];
begin
 str(i,s1);
 cstrr:=s1;
end;

function cstr(i:longint):string;
var
 s1:string[255];
begin
 str(i,s1);
 cstr:=s1;
end;

function valuer(i:string):real;
var
 s:real;
 n:integer;
begin
 val(i,s,n);
 if (n>0) then s:=0;
 valuer:=s;
end;

function value(i:string):longint;
var
 s:longint;
 n:integer;
begin
 val(i,s,n);
 if (n>0) then s:=0;
 value:=s;
end;


Procedure GraphVGA;
var
 driver, mode:integer;
 i:integer;
begin
      driver:=VGA; mode:=VGAHI;
      initgraph(driver,mode,'');
      i:=graphresult;
      if (i<>0) then
       begin
        writeln('Graphics Error: ',GraphErrorMsg(i));
	writeln('You must have a VGA to run this program');
	halt;
       end;
end;

Procedure GraphEGA;
var
 driver, mode:integer;
 i:integer;
begin
      driver:=EGA; mode:=EGAHI;
      initgraph(driver,mode,'');
      i:=graphresult;
      if (i<>0) then
       begin
        writeln('Graphics Error: ',GraphErrorMsg(i));
	writeln('You must have an EGA or VGA to run this program');
	halt;
       end;
end;

Procedure GraphMCGA;
var
  graphmode,graphdriver,i:integer;
  autodetect:pointer;
begin
  AutoDetect := @DetectVGA;
  GraphDriver := InstallUserDriver('SVGA256',AutoDetect);
  GraphDriver := Detect;
  InitGraph(GraphDriver,GraphMode,'');
  i:=graphresult;
  if (i<>0) then
       begin
        writeln('Graphics Error: ',GraphErrorMsg(i));
	writeln('You must have a VGA to run this program');
	halt;
       end;
end;

procedure lin(x1,y1,x2,y2,col:integer);
begin
 setcolor(col);
 line(x1,y1,x2,y2);
 if mirror then
  begin
   line(getmaxx-x1,y1,getmaxx-x2,y2);
   line(x1,getmaxy-y1,x2,getmaxy-y2);
   line(getmaxx-x1,getmaxy-y1,getmaxx-x2,getmaxy-y2);
  end;
end;

procedure cir(x,y,rad,col:integer);
var
 maxx,maxy:longint;
begin
 maxx:=getmaxx;
 maxy:=getmaxy;
 setcolor(col);
 circle(x,y,rad);
 if mirror then
  begin
   circle(maxx-x,y,rad);
   circle(x,maxy-y,rad);
   circle(maxx-x,maxy-y,rad);
  end;
{
 setcolor(col);
 setfillstyle(1,col);
 fillellipse(x,y,rad,rad);
 if mirror then
  begin
   fillellipse(getmaxx-x,y,rad,rad);
   fillellipse(x,getmaxy-y,rad,rad);
   fillellipse(getmaxx-x,getmaxy-y,rad,rad);
  end;
}
end;

procedure box(x1,y1,x2,y2,col:integer);
begin
 setcolor(col);
 rectangle(x1,y1,x2,y2);
 if mirror then
  begin
   rectangle(getmaxx-x1,y1,getmaxx-x2,y2);
   rectangle(x1,getmaxy-y1,x2,getmaxy-y2);
   rectangle(getmaxx-x1,getmaxy-y1,getmaxx-x2,getmaxy-y2);
  end;
end;

procedure dot(x,y,col:integer);
begin
 putpixel(x,y,col);
 if mirror then
  begin
   putpixel(getmaxx-x,y,col);
   putpixel(x,getmaxy-y,col);
   putpixel(getmaxx-x,getmaxy-y,col);
  end;
end;


Function Timer:real;
 var
  hour,min,sec,hun:word;
  num:longint;
 begin
  gettime(hour,min,sec,hun);
  timer:=(hun/100+sec+(min*60)+(hour*3600));
 end;



Function addfront(b:string;l:integer): string;
Begin
  while length(b)< l do
    b := ' '+b;
  addfront := b;
End;

Function addrear(b:string;l:integer): string;
Begin
  while length(b)< l do
    b := b+' ';
  addrear := b;
End;

Function ucase(s:string):string;
var
 i:integer;
begin
 if length(s)>=1 then
  begin
   for i:=1 to length(s) do
    s[i]:=upcase(s[i]);
  end;
 ucase:=s;
end;

Function lcase(s:string):string;
var
 i:integer;
begin
 if length(s)>=1 then
  begin
   for i:=1 to length(s) do
    if (ord(s[i])>=65) and (ord(s[i])<=90) then s[i]:=chr(ord(s[i])+32);
  end;
 lcase:=s;
end;


Function space(i:byte):string;
var
 s:string[255];
 k:integer;
begin
 s:='';
 if i>0 then for k:=1 to i do s:=s+' ';
 space:=s;
end;

Function repchar(c:char; i:byte):string;
var
 s:string[255];
 k:integer;
begin
 s:='';
 if i>0 then
  for k:=1 to i do
   begin
    s:=s+c;
   end;
 repchar:=s;
end;

function tch(i:strl):strl;
  begin
   if length(i)>2 then i:=copy(i,length(i)-1,2) else
    if length(i)=1 then i:='0'+i;
   tch:=i;
  end;

 function time:string;
  var
   h,m,s,t:word;
   ampm:string[2];
   hs,ms,ss:string[3];
  begin
   GetTime(h,m,s,t);
   if h<12 then ampm:=' AM' else ampm:=' PM';
   hs:=cstr(h);
   ms:=cstr(m);
   ss:=cstr(s);
   time:=tch(hs)+':'+tch(ms)+':'+tch(ss)+ampm;
  end;

 function date:string;
  var
   d,m,y,w:word;
   ds,ms,ys:string[2];
  begin
   GetDate(y,d,m,w);
   y:=y mod 100;
   ds:=cstr(d);
   ms:=cstr(m);
   ys:=cstr(y);
   date:=tch(ds)+'/'+tch(ms)+'/'+tch(ys);
  end;


function ltrim(s1:string):string;
var
 i:integer;
begin
 while (length(s1)>0) and ((copy(s1,1,1)=' ') or (copy(s1,1,1)=#8) or (copy(s1,1,1)=#9)) do
  begin
   s1:=copy(s1,2,length(s1)-1);
  end;
 ltrim:=s1;
end;

function rtrim(s1:string):string;
var
 i:integer;
begin
 while (length(s1)>0) and ((copy(s1,length(s1),1)=' ') or (copy(s1,length(s1),1)=#8)
         or (copy(s1,length(s1),1)=#9)) do
  begin
   s1:=copy(s1,1,length(s1)-1);
  end;
 rtrim:=s1;
end;

function btrim(s1:string):string;
begin
 btrim:=ltrim(rtrim(s1));
end;

function lstr(s1:string; l:integer):string;
begin
 if length(s1)<=l then lstr:=s1
 else lstr:=copy(s1,1,l);
end;

function rstr(s1:string; l:integer):string;
begin
 if length(s1)<=l then rstr:=s1
 else rstr:=copy(s1,length(s1)-l+1,l);
end;

Procedure FlushKey;              { Clears any key strokes in the key-  }
                                 { board buffer so a couple of key     }
var                              { presses don't race you through program. }
  Regs : Registers;

begin
  Regs.AH := $01;  { AH=1: Check for keystroke }
  Intr($16,regs); { Interupt $16: Keyboard services}
  IF (regs.Flags and $0040) = 0 then { if chars in buffer }
    REPEAT
      Regs.AH := 0;
      Intr($16,Regs);
      Regs.AH := $01;
      Intr($16,Regs);
    Until (regs.flags and $0040) <> 0;
end;

procedure CursorOff;					{ Turn off the cursor }
   begin
   with R do
      begin
      AX := 1*$100;			     { Set cursor size to nothing     }
      CX := $2000;			     { Set bit 5 in CH for cursor off }
      intr ($10,Dos.Registers(R));
      end;
   end;

procedure CursorOn;					 { Turn on the cursor }
   begin
   with R do
      begin
      AX := 1*$100;				    { Set cursor size	      }
      CX := $1010;				    { Set cursor to underline }
      intr ($10,Dos.Registers(R));
      end;
   end;

function hexnum(num:byte):char;
begin
 case num of
  0 : hexnum:='0';
  1 : hexnum:='1';
  2 : hexnum:='2';
  3 : hexnum:='3';
  4 : hexnum:='4';
  5 : hexnum:='5';
  6 : hexnum:='6';
  7 : hexnum:='7';
  8 : hexnum:='8';
  9 : hexnum:='9';
 10 : hexnum:='A';
 11 : hexnum:='B';
 12 : hexnum:='C';
 13 : hexnum:='D';
 14 : hexnum:='E';
 15 : hexnum:='F';
 else hexnum:='X';
 end; {case}
end;

function hexb(num:byte):string;
begin
 hexb:=hexnum(num shr 4)+hexnum(num and 15);
end;

function hex(num:word):string;
begin
 hex:=hexb(num shr 8)+hexb(num and 255);
end;


Procedure beep;
begin
 write(#7);
end;

 procedure getkey(var c:char);
 var
  regs:registers;
   begin
   with regs do
    begin
     ax:=$0800;
     msdos(regs);
     c:=chr(ax and $00ff);
    end;
  end;


function pausescr:char;
  var
   i:integer;
   cc:char;
  begin
   write('[PAUSE]');
   getkey(cc);
   for i:=1 to 7 do write(#8+' '+#8);
   pausescr:=cc;
  end;

function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

procedure inputln(var i:string; ml:integer; up:boolean);
  var
   cp:integer;
   c,c2:char;
   r:real;
  begin
     r:=timer;
     cp:=1;
     repeat
      getkey(c);
      if up then c:=upcase(c);
      if (c>=' ') and (c<chr(127)) then
       if cp<=ml then
        begin
         i[cp]:=c;
         cp:=cp+1;
         write(c);
        end
       else
      else
       case ord(c) of
         8:if cp>1 then
            begin
             c:=chr(8);
             write(#8#32#8);
             cp:=cp-1;
            end;
        24:while cp<>1 do
            begin
             cp:=cp-1;
             write(#8#32#8);
            end;
       end;
     until (c=#13) or (c=#14);
     i[0]:=chr(cp-1);
     writeln;
  end;

Function locase(c:char):char;
begin
 if c in ['A'..'Z'] then c:=chr(ord(c)+32);
 locase:=c;
end;

function zero_pad(n,l:longint):string;
var
 s:string;
begin
 s:=cstr(n);
 while length(s)<l do
  s:='0'+s;
 zero_pad:=s;
end;

function zero_pads(s:string;l:longint):string;
var
 s1:string;
begin
 s1:=s;
 while length(s1)<l do
  s1:='0'+s1;
 zero_pads:=s1;
end;
 
procedure scr_str(x,y:byte; s:string; col:byte);
var
 i,k:integer;
begin
  for i:=0 to length(s)-1 do
   begin
    mem[$B800:y*160+x*2+i*2]:=ord(s[i+1]);
    mem[$B800:y*160+x*2+i*2+1]:=col;
   end;
end;


function nformat(l:longint):string;
var
 i,k:integer;
 s,o:string;
begin
 s:=cstr(l); o:=''; k:=0;
 for i:=length(s) downto 1 do
  begin inc(k);
   o:=s[i]+o;
   if k mod 3=0 then o:=','+o;
  end;
 o:=btrim(o);
 if o[1]=',' then o:=rstr(o,length(o)-1);
 nformat:=o;
end;

function case_fix(s:string):string;
var
 i,j,k:integer;
begin
 s:=lcase(s);
 for i:=1 to length(s) do
  if (i<=1) or (not (s[i-1] in ['A'..'Z','a'..'z','0'..'9'])) then s[i]:=upcase(s[i]);
 case_fix:=s;
end;


end.
